<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/
// needs safesql work

$noheader=true;
require('../config.inc.php');


$GameCP->loadIncludes("billing");
$GameCP->loadIncludes("cron");

$Cron=new Cron();
$Billing=new Billing();

if((isset($_SERVER['REQUEST_METHOD']) && !isset($_REQUEST['key'])) || (isset($_REQUEST['key']) && $Cron->CheckKey($_REQUEST['key']) == false)){
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

sql_query("UPDATE settings SET value='".time()."' WHERE name='ran_auto';");


if(backupemail){
	echo "------------------------------------------------------------\n";
	echo " - Backing up gamecp...\n";
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->Backup("true");
	echo "------------------------------------------------------------\n";
}

$hook_vars="";
run_hook("daily_cron");

if(usebilling != "1") exit;


if(isset($_SERVER['argv'][1]) && $_SERVER['argv'][1] == "1"){
	define('doDelete', "1");
} else define('doDelete', "0");


function notifyEmail($notifyPre, $emailData, $notifybill, $doEmail, $cid, $bid) {
	global $GameCP, $safesql;

	$resultNotifyPre = mysql_query($safesql->query("SELECT U.id , B.gross as 'bgross', emailsent, B.id FROM billing B, users U WHERE B.id='%i'", array($bid))) or die(mysql_error());
	$row = mysql_fetch_array($resultNotifyPre);

	$billamount = $row[1];
	$emailsent = $row[2];

	// Over ride for manual notification
	if($doEmail=="auth") $emailsent="auth";

	// Grab user info.
	$UserInfoQ = mysql_query($safesql->query("SELECT email FROM users WHERE id ='%i'", array($cid))) or die(mysql_error());
	$UserInfo = mysql_fetch_row($UserInfoQ); 
	$UserEmail = $UserInfo[0];

	$GameCP->loadIncludes("email");
	$Email=new Email();
	$Email->emailto = $UserEmail;

	$Email->templatename=$emailData;
	$Email->GetTemplateStuff();
	$Email->userid = $cid;
	$Email->ubillid=$bid;
	$Email->usegamedata = true;
	$Email->usevoicedata = true;
	$Email->usebilldata = true;

	$Email->BillDaysTill=$notifybill;
	$Email->ReplaceStuff();
	$Email->send();

	$domail=$doEmail+1;
	sql_query($safesql->query("UPDATE billing SET emailsent='%s' WHERE id='%i'", array($domail, $bid)));

	if($emailData == "Billing-Pre"){
		echo " - Emailed: $UserEmail - Bill Date: $notifyPre - Due in $notifybill days\n";
	} else echo " - Emailed: $UserEmail - Bill Date: $notifyPre - Due $notifybill days ago\n";
}




ob_start();
echo "------------------------------------------------------------\n";
echo " - Scanning pending & completed bills to create new ones\n";
	// Select all non-updated bills.
	$billGen = mysql_query("SELECT * FROM billing WHERE `update`= '0' AND status !='Canceled' AND daystill > '0' ") or die(mysql_error());
	$totalBillsReady=mysql_num_rows($billGen);
	$dueday=date(dateformat, strtotime("+".notifyPre . "day"));

	echo " - Bill(s) to process: ". $totalBillsReady . "\n - Scanning for ones due in ".notifyPre." day(s) on $dueday\n";

	while ($row = mysql_fetch_array($billGen)){
		$bid = $row['id']; 
		$cid = $row['cid']; 
		$gross = $row['gross']; 
		$fee = $row['fee']; 
		$subscr_id = $row['subscr_id']; 
		$sssuspend = $row['suspend']; 
		$billdate = $row['date'];	
		$daystillQ = $row['daystill'];	
		$services = $row['services'];
		$clientDetailsQ = mysql_query($safesql->query("SELECT username, email, active FROM users WHERE id='%i'", array($cid))) or die(mysql_error());
		$clientDetails = mysql_fetch_row($clientDetailsQ);
		$userName=$clientDetails[0];
		$userEmail=$clientDetails[1];
		$userActive=$clientDetails[2];


		$notifyWhen=notifyPre;
		$newDueDate=$Billing->GetDueDate($row['date'], $daystillQ);
		$daysFromTodayA= $Billing->DateDifference($newDueDate, date(dateformat, strtotime('now')));
		if(debugging != "0"){
			echo "-- DEBUG: $userName - bid #$bid, cid #$cid, date $billdate, days from today $daysFromTodayA, new date $newDueDate\n";
			echo "	if($daysFromTodayA == -$notifyWhen && $userActive == 1)\n";
		}
		// Create the new bill if the total days before the bill is due is equal to notify pre, the day we create new bills
		if($daysFromTodayA == "-".$notifyWhen && $userActive == "1"){ 

			$promo=unserialize($row['promo']);
			foreach($promo as $p => $mo){
				$info = sql_query("SELECT * FROM promotions WHERE id = '".$mo['id']."' LIMIT 1") or die(mysql_error());
				$promoInfo = mysql_fetch_array($info);
				if($promoInfo['recurring'] == "0" || $promoInfo['active'] == "0"){
					$gross=$gross+$mo['total'];
					unset($promo[$p]);
				}
			}
			$checkQ=mysql_query("SELECT * FROM billing WHERE 
							cid = '$cid' AND
							date = '$newDueDate'  AND
							status = 'Pending' AND
							gross = '$gross' AND
							fee = '$fee' AND
							`update` = '1' AND
							daystill='$daystillQ' AND
							subscr_id='$subscr_id' AND
							promo='".serialize($promo)."' AND
							services='$services' AND
							suspend='$sssuspend'") or die(mysql_error());
			if(mysql_num_rows($checkQ) == "0"){

				echo " -- Creating new pending bill for: "  . $userName ."\n";
				echo " --- Due date: "  . $newDueDate ."\n";
				echo " --- Gross: "  . $gross ."\n";

				mysql_query("UPDATE billing SET subscr_id='' WHERE subscr_id='$subscr_id';") or die(mysql_error());
				mysql_query("UPDATE billing SET `update`='1' WHERE id='$bid';") or die(mysql_error());

				mysql_query("INSERT INTO billing SET 
								cid = '$cid',
								date = '$newDueDate' ,
								status = 'Pending',
								gross = '$gross',
								fee = '$fee',
								`update` = '0',
								daystill='$daystillQ',
								subscr_id='$subscr_id',
								promo='".serialize($promo)."',
								services='$services',
								suspend='$sssuspend'") or die(mysql_error());

				$newBID=mysql_insert_id();

				$userSubBill = mysql_query("SELECT pid, gross, fee, description, taxed, ugid, uvid FROM userbills WHERE bid='$bid'") or die(mysql_error());
				while ($row = mysql_fetch_array($userSubBill))	{
					if($row['description'] != "Credit") mysql_query("INSERT INTO userbills SET cid='$cid', bid='$newBID', pid='".$row['pid']."', gross='".str_replace(",", '', $row['gross'])."', fee='".str_replace(",", '', $row['fee'])."', description='".$row['description']."', taxed='".$row['taxed']."', ugid='".$row['ugid']."', uvid='".$row['uvid']."'") or die(mysql_error());
				} 
				// do billtotals here
				// add taxed to userbill insert

				notifyEmail($newDueDate, "Billing-Add", "0", '0', $cid, $newBID); 

				/* notify admin(s) that a bill is due today */
				if(notifyAdminNewBill == "1"){
					$emailAdmins = mysql_query("SELECT id FROM users WHERE userlevel ='1' and active ='1'") or die(mysql_error());
					while ($adminList = mysql_fetch_array($emailAdmins)){
						notifyEmail($newDueDate, "Billing-Add", "0", '0', $adminList['id'], $newBID); 
					}
				}


				$hook_vars="";
				run_hook("billing_auto_create", array('billid'=>$newBID, 'gross'=>$gross,'fee'=>$fee,'cid'=>$cid, 'services'=>$services, 'duedate'=>$newDueDate, 'daystill', $daystill));


			} else echo " --- Bill already created\n";
		} 
	} // end while




echo "------------------------------------------------------------\n";
echo " - Scanning pending bills for notification\n";

	// Select all non-updated bills.
	$billGen = mysql_query("SELECT * FROM billing  WHERE `status` = 'Pending'") or die(mysql_error());
	$totalBillsReady=mysql_num_rows($billGen);
	echo " - Bill(s) pending notification: ". $totalBillsReady . "\n";
	while ($row = mysql_fetch_array($billGen)){
		$bid = $row['id']; 
		$cid = $row['cid']; 
		$gross = $row['gross']; 
		$fee = $row['fee']; 
		$billdate = $row['date'];	
		$billdateQ = strtotime($billdate);
		$daystillQ = $row['daystill'];	

		$newDueDate=$Billing->GetDueDate($billdate, $daystillQ);

		$billdateA = date(dateformat,strtotime($newDueDate));
		$daysFromTodayA= $Billing->DateDifference($billdateA, date(dateformat, strtotime('now')));
		$notifyWhen=notifyPre;

		$billdate = date(dateformat,strtotime($billdate));
		$daysFromToday= $Billing->DateDifference($billdate, date(dateformat, strtotime('now')));

		$clientDetailsQ = mysql_query("SELECT username, email, active FROM users WHERE id='$cid'") or die(mysql_error());
		$clientDetails = mysql_fetch_row($clientDetailsQ);
		$userName=$clientDetails[0];
		$userEmail=$clientDetails[1];
		$userActive=$clientDetails[2];

		$notifyPre = notifyPre;	$notifyPre1 = notifyPre1;	$notifyPre2 = notifyPre2;	$notifyPre3 = notifyPre3;	$notifyPre4 = notifyPre4;
		$notifyPast = notifyPast;	$notifyPast1 = notifyPast1;	$notifyPast2 = notifyPast2;	$notifyPast3 = notifyPast3;	$notifyPast4 = notifyPast4;
		if($daysFromToday == "0" && $userActive == "1")  { 
			notifyEmail($billdate, "Billing-Due", "0", '0', $cid, $bid); 
		}else{
			if($notifyPre == "") $notifyPre="5";
			if($daysFromToday == "-".$notifyPre) notifyEmail($billdate, "Billing-Pre", $notifyPre, '1', $cid, $bid); 

			if($notifyPre1 !="" && $daysFromToday == "-".$notifyPre1)  notifyEmail($billdate, "Billing-Pre", $notifyPre1, '2', $cid, $bid); 
			if($notifyPre2 !="" && $daysFromToday == "-".$notifyPre2)  notifyEmail($billdate, "Billing-Pre", $notifyPre2, '3', $cid, $bid); 
			if($notifyPre3 !="" && $daysFromToday == "-".$notifyPre3)  notifyEmail($billdate, "Billing-Pre", $notifyPre3, '4', $cid, $bid); 
			if($notifyPre4 !="" && $daysFromToday == "-".$notifyPre4)  notifyEmail($billdate, "Billing-Pre", $notifyPre4, '5', $cid, $bid); 

			if($notifyPast !="" && $daysFromToday == $notifyPast)   notifyEmail($billdate, "Billing-Past", $notifyPast, '6', $cid, $bid);   
			if($notifyPast1 !="" && $daysFromToday == $notifyPast1) notifyEmail($billdate, "Billing-Past", $notifyPast1, '7', $cid, $bid); 
			if($notifyPast2 !="" && $daysFromToday == $notifyPast2) notifyEmail($billdate, "Billing-Past", $notifyPast2, '8', $cid, $bid); 
			if($notifyPast3 !="" && $daysFromToday == $notifyPast3) notifyEmail($billdate, "Billing-Past", $notifyPast3, '9', $cid, $bid); 
			if($notifyPast4 !="" && $daysFromToday == $notifyPast4) notifyEmail($billdate, "Billing-Past", $notifyPast4, '10', $cid, $bid); 
		}
	}

if(suspendDays){
	$suspendDays  = suspendDays;
	$suspendDay=date(dateformat, strtotime("-".$suspendDays . "day"));
	echo "------------------------------------------------------------\n";
	echo " - Scanning for past due bills\n - Were due $suspendDays days ago on $suspendDay - ".date(dateformat, time())." minus $suspendDays\n";
		// Select all non-updated bills.
		$billGen = mysql_query("SELECT * FROM billing where `status`='Pending' AND suspend='1'") or die(mysql_error());
		$totalPendingsReady=mysql_num_rows($billGen);
		$i=0;
		while ($row = mysql_fetch_array($billGen)){
			$bid = $row['id']; 
			$cid = $row['cid']; 
			$gross = $row['gross']; 
			$fee = $row['fee']; 
			$billdate = $row['date'];	
			$billdateQ = strtotime($billdate);
			$daystillQ = $row['daystill'];	
			$suspend = $row['suspend'];	
			$services = unserialize($row['services']);	

			// CLIENT DETAILS
			$clientDetailsQ = mysql_query("SELECT username, email, active FROM users WHERE id='$cid'") or die(mysql_error());
			$clientDetails = mysql_fetch_row($clientDetailsQ);
			$userName=$clientDetails[0];
			$userEmail=$clientDetails[1];
			$userActive=$clientDetails[2];

			if($userName){
				if(strtotime($suspendDay) >= $billdateQ && $userName && $suspend == "1"){ 
					echo " --- User Over-due: " . $userName . "\n";
					echo " --- Bill ID: ". $bid . "\n";
					echo " --- Suspend Date: ". $billdate . "\n";
					echo " --- E-mail: ". $userEmail . "\n";
					$GameCP->loadIncludes("suspend");
					$Suspend=new Suspend();
					if(is_array($services) && count($services) > 0){
						foreach($services as $ser){
							if(preg_match("/game/s" ,$ser)){
								$serviceid=preg_replace("/game/s", '' ,$ser);
								$Suspend->Game($serviceid);
								echo " --- Suspended Service #: ". $serviceid . "\n";
							} else if(preg_match("/voice/s" ,$ser)){
								$serviceid=preg_replace("/voice/s", '' ,$ser);
								$Suspend->Voice($serviceid);
								echo " --- Suspended Voice #: ". $serviceid . "\n";
							} else if(preg_match("/module/s" ,$ser)){
								$serviceid=preg_replace("/module/s", '' ,$ser);
								$Suspend->Module($serviceid);
								echo " --- Suspended Module #: ". $serviceid . "\n";
							}
						}
					}
					echo "------------------------------------------------------------\n";

					$i++;
				}
			}
		}
	echo " - $i bill(s) services  suspended.\n";
	echo "------------------------------------------------------------\n";
}

if(deleteDays){
	$deleteDays  = deleteDays;
	if($deleteDays == "1"){
		$d="day";
	} else $d="days";
	$deleteDay=date(dateformat, strtotime("-".$deleteDays . " $d"));
	echo "------------------------------------------------------------\n";
	echo " - Scanning for bills past the client suspend date\n - Were due $deleteDays days ago on $deleteDay - ".date(dateformat, time())." minus $deleteDays\n";
	// Select all non-updated bills.
		$billGen = mysql_query("SELECT * FROM billing where `status`='Pending'") or die(mysql_error());
		$i=0;
		while ($row = mysql_fetch_array($billGen)){
			$bid = $row['id']; 
			$cid = $row['cid']; 
			$gross = $row['gross']; 
			$fee = $row['fee']; 
			$billdate = $row['date'];	
			$billdateQ = strtotime($billdate);
			$daystillQ = $row['daystill'];	

			if(!$userEmail) { $userEmail = "no e-mail provided"; }
			$checkFinal = mysql_query("SELECT id FROM billing where `status`='Pending' AND cid='$cid' AND id !='$bid'") or die(mysql_error());

			if(strtotime($deleteDay) >= $billdateQ && $userName && $userActive == "1" && mysql_num_rows($checkFinal) == "0"){ 
				echo " --- Bill Over-due: #$bid - user - " . $userName . "\n";
				$GameCP->loadIncludes("suspend");
				$Suspend=new Suspend();
				$Suspend->User($cid); 
				echo "------------------------------------------------------------\n";
				$i++;
			}
		}
	echo " - $i billing client(s) suspended.\n";
	echo "------------------------------------------------------------\n";
}


echo " - Billing completed for ".date(dateformat, time())."\n";
echo "------------------------------------------------------------\n";

$log = ob_get_contents();
ob_end_clean();
echo $log;

if($log && emailNotify){
	$GameCP->loadIncludes("email");
	$Email=new Email();
	$Email->emailto = emailNotify;
	$Email->emailsubject = "GameCP Daily Billing";
	$Email->emailbody = nl2br($log);
	$Email->ReplaceStuff();
	$Email->send();
	echo " - Log sent to ". emailNotify ."\n";
	echo "------------------------------------------------------------\n";

}

exit;
?>