<?php
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$gatewayinfo = mysql_query("SELECT * FROM gateways WHERE name='Psigate.com' LIMIT 1;") or die(mysql_error());
$gateway = mysql_fetch_array($gatewayinfo);

$authorizeAcountEmail =	 $gateway['value1'];
$authorizeAcountLogin = $gateway['value2'];
$authorizeAcountPassword = $gateway['value3'];

$cost = $_POST['cost'];
$email = $_POST['email'];
$city = $_POST['city'];
$state = $_POST['state'];
$zip = $_POST['zip'];
$cardnum = $_POST['cardnum'];
$cardcvv2  = $_POST['cardcvv2'];
$expmonth = $_POST['expmonth'];
$expyear = $_POST['expyear'];
$expdate = $expmonth . $expyear;
$bid = $_POST['bid'];


include_once("psigate.inc.php");

$psi = new PsiGatePayment;


$psi->setGatewayURL('https://secure.psigate.com:7934/Messenger/XMLMessenger'); // Set URL or use 'https://dev.psigate.com:7989/Messenger/XMLMessenger' for testing
$psi->setPaymentType('CC');
$psi->setTaxTotal1('0'); // Tax value 1, ex Sales Tax
$psi->setCardIDCode('1'); // Pass CVV code


$psi->setStoreID($gateway['value1']);
$psi->setPassPhrase($gateway['value2']); // Assures authenticity
$psi->setUserID($gateway['value3']); // Unique customer identifier set by merchant.
$psi->setCardAction("0"); // 1 for Authorize, 0 for Immediate Charge
//$psi->setOrderID($bid); // Order ID.  Leave blank to have PSiGate assign
$psi->setSubTotal($cost); // Amount
$psi->setCardNumber($cardnum); // Card Number
$psi->setCardExpMonth($expmonth); // Month in 2-digit format
$psi->setCardExpYear($expyear); // Year in 2-digit format
$psi->setBname($_POST['Bname']); // Billing Name
$psi->setBcompany(''); // Company Name
$psi->setBaddress1($_POST['address1']); // Billing Address 1
$psi->setBaddress2($_POST['address2']); // Billing Address 2
$psi->setBcity($city); // Billing City
$psi->setBprovince($state); // Billing state or province
$psi->setBpostalCode($zip); // Billing Zip
$psi->setBcountry($_POST['country']); // Country Code - 2 alpha characters
$psi->setPhone($_POST['phone']); // Customer Phone
$psi->setEmail($_POST['email']); // Customer Email
$psi->setComments('');  // comments, whatever you'd like
$psi->setCustomerIP($_SERVER['REMOTE_ADDR']); // Customer IP address, for fraud
$psi->setCardIDNumber($cardcvv2); // CVV code

 // $psi->setTestResult('A'); // Test result if you'd like to pass one.  See xml guide for more details

$api_result=$psi->doPayment(); 

$details="3";
if($api_result == "APPROVED"){
	$details="1";
	$result=$psi->getTrxnReturnCode();

} elseif($api_result == "DECLINED"){
	$details="2";
	$result=$psi->getTrxnErrMsg();

} elseif($api_result == "ERROR"){
	$details="3";
	$result=$psi->getTrxnErrMsg();
} 


switch($details){
	case "1";
		$orderStatus = "Completed";
		$paidPrice=$cost;
		$responseMessage=$result;
	break;
	case "2";
		$orderStatus = "Failed";
		$errorCode= "This transaction has been declined.<br><br>".$result;
	break;
	case "3";
		$orderStatus = "Failed";
		$errorCode= "There has been an error while processing your card.";
	break;
}

?>