<?php

$noheader = true;
require('../../config.inc.php');
$GameCP->loadIncludes("billing");
$Billing=new Billing();
require_once(path.'/includes/core/classes/gamecp/event.inc.php');

require_once('WebToPay.php');

$gatewayinfo = mysql_query("SELECT * FROM gateways WHERE name='WebtoPay' LIMIT 1;") or die(mysql_error()); // Gateway info
$gateway = mysql_fetch_array($gatewayinfo);

$responseText = explode(",", $gateway['value3'], 3);

try {
    $response = WebToPay::checkResponse($_GET, array(
            'projectid'     => $gateway['value1'],
            'sign_password' => $gateway['value2']
        ));

    echo 'OK '.$responseText[2];
}
catch (Exception $e) {
    echo get_class($e).': '.$e->getMessage();
}

$Event = new Event();
$Event->EventLogAdd('', "WebToPay IPN system was triggered, notifications sent to $ipnNotifyEmail - ".serialize($_GET) ." - ". date('l jS \of F Y h:i:s A'));

$errors = array("0x1" => "Arve on liiga väike", "0x2" => "Arve on liiga suur", "0x3" => "Valitud valuuta ei ole sobilik", "0x4" => "Puudub valuuta või arve summa", "0x6" => "Projekti ID on puudu, või seda ei eksisteeri", "0x7" => "Proovisid teha testimakset, kui testimine oli offis", "0x8" => "Sul puudub sellise maksetüübi kasutamise luba", "0x9" => "paytext väärtus peab olema UTF-8", "0x10" => "OrderID on vigane", "0x11xError" => "Projekti ei eksisteeri", "0x11x0" => "Projekt pole aktiveeritud", "0x11x2" => "Projekt on müüa poolt blokeeritud", "0x11x4" => "Projekt on administraatori poolt blokeeritud", "0x11x5" => "Projekt on meie süsteemist kustutatud", "0x12" => "projectid väärtus on tühi", "0x13" => "...url väärtused pole õiged", "0x14" => "Vale sign väärtus", "0x15" => "Mõned väärtused on vigased", "0x15x0" => "Üks ...url väärtustest on vigane", "0x15x1" => "time_limit on vigane"); // WebtoPay võimalikud errorid

$params = array();
parse_str(base64_decode(strtr($_GET['data'], array('-' => '+', '_' => '/'))), $params);

$sms_price		= (int)@$params['amount']/100; // Summa, mida klient maksis
$sms_order		= @$params['orderid']; // Order ID
$sms_status		= (int)@$params['status']; // Makse staatus
$error			= @$params['error']; // Errorid

if(array_key_exists($error, $errors)) {
	$orderStatus	= "Pending"; // Kuna tekkis error, siis muudame tellimuse "Pending"
	$responseMessage= $errors[$error]; // Saadame errori, mis tuleb $errors arrayst
} else {
	switch($sms_status){
		case 0: {
			$orderStatus	= "Pending"; // Kuna makset ei sooritatud, siis muudame tellimuse "Pending"
			$responseMessage= "Makset ei sooritatud.";
		}
		case 1: {
			$orderStatus	= "Completed"; // Makse sooritatud, kõik korras!
			$paidPrice		= $sms_price;
			$responseMessage= "Makse sooritatud!";
		}
		case 2: {
			$orderStatus	= "Completed"; // Makse sooritatud, kõik korras!
			$paidPrice		= $sms_price;
			$responseMessage= "Makse sooritatud!";
		}
	}
}

if($sms_order[0] == "b"){
	// bill pay
	$sms_order=substr($sms_order, '1');
	$Billing->AddPayment($sms_order, $paidPrice, '', '', 'WebtoPay', '');
	$Event->EventLogAdd('', "WebToPay IPN system was triggered, Bill: $sms_order , Status $orderStatus , paid $paidPrice , response $responseMessage - ". date('l jS \of F Y h:i:s A'));
} else {
	// order pay
	$qid=$sms_order;
	$checkQ = sql_query("SELECT user, status, `mod` FROM queue where id='".$qid."'") or die(mysql_error()); 
	$qInfo=mysql_fetch_row($checkQ);

	if($orderStatus == "Completed"){ 
		$mod=unserialize($qInfo[2]);
		if($paidPrice >= $mod['gross']) $mod['status']="Completed";
		$mod['paidPrice']=$paidPrice;
		sql_query("UPDATE queue SET `mod`='".serialize($mod)."' where id='".$qid."'") or die(mysql_error()); 
		if($paidPrice >= $mod['gross'] && $qInfo[1] == "3"){
			$Event->EventLogAdd('', "#WebtoPay - Queue #$qid executed - ". date('l jS \of F Y h:i:s A'));
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->ExecQueue($qid);
		}
	}
	$Event->EventLogAdd('', "WebToPay IPN system was triggered, Order: $sms_order , Status $orderStatus , paid $paidPrice , response $responseMessage - ". date('l jS \of F Y h:i:s A'));
}

?>