<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_ticket_list.php
 * Type:     function
 * Name:     gcp_ticket_list
 * Purpose:  displays GameCP's ticket list
 * -------------------------------------------------------------
 */
function smarty_function_gcp_ticket_list($params, &$smarty)
{
	global $GameCP, $safesql;
// Ticket list

$formName="tickets";
$sql=$params['sql'];
$modeView=$params['modeView'];
$pageTitle=$params['pageTitle'];
$initial=$_GET['initial'];
$view=$_GET['view'];

if(!$sql){ echo "Fatal Error: Missing MySQL query."; exit; }
if(!$pageTitle){ echo "Fatal Error: page title."; exit; }

if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
	$sql=str_replace("RSIDQUERY", "AND (U.rsid='".$_SESSION['gamecp']['userinfo']['id']."' OR U.id='".$_SESSION['gamecp']['userinfo']['id']."')", $sql);
} else $sql=str_replace("RSIDQUERY", "", $sql);


if($_REQUEST['initial']) $sql=$sql." AND UPPER(LEFT(U.username,1)) LIKE '".$GameCP->whitelist($_REQUEST['initial'][0])."'"; 

if($_REQUEST['uid']){
	$sql=str_replace("UIDQ", "AND U.id = '".$GameCP->whitelist($_REQUEST['uid'], "int")."'", $sql);
} else 	$sql=str_replace("UIDQ", "", $sql);


// Clear any old variabels.
$smarty->clearAssign("rowTicketDetails"); 
$TicketList=array();
$i = "0"; 
$ii = "0"; 

/* page control */
$result=Smarty_PageControl($sql, $formName, "ticketlist");

while ($rowTicketDetails = mysql_fetch_array($result)){

	if($_SESSION['gamecp']['userinfo']['ulevel'] == "5"){
		$addRow=false;
		$usersServersQ = sql_query($safesql->query("SELECT servers FROM users WHERE id='%i'", array($GameCP->whitelist($_SESSION['gamecp']['userinfo']['id'], "int")))) or die(mysql_error());
		$usersServers = mysql_fetch_array($usersServersQ);
		$userServer=unserialize($usersServers[0]);

		$clientServersQ = sql_query($safesql->query("SELECT S.sid FROM users U, servers S, iptable I, usergames UG WHERE U.id='%i' AND U.id = UG.cid AND UG.ip = I.ip AND I.sid = S.sid", array($GameCP->whitelist($rowTicketDetails['uid'], "int")))) or die(mysql_error());
		$clientServers = mysql_fetch_array($clientServersQ);

		if(is_array($clientServers)){
			foreach($clientServers as $srv){
				if(in_array($srv, $userServer)) $addRow = true;

			}
		} 
		if($rowTicketDetails['uid'] == $_SESSION['gamecp']['userinfo']['id']) $addRow=true;
	} else $addRow = true;
	

	if($addRow == true){

		if($i == "0"){ $bg=$bge; $class="even";}
		if($i == "1"){ $bg=$bgd; $i="0"; $class="odd";  }

		if($rowTicketDetails['status'] == "Open"){
			$class="yellow";
		}elseif($rowTicketDetails['status'] == "Closed"){
			$class="red";
		}

		$haystack="/Replied/i";
		$haystack2="/".$_SESSION['gamecp']['userinfo']['name']."/i";
		if (preg_match($haystack, $rowTicketDetails['status'])){
			if (preg_match($haystack2, $rowTicketDetails['status'])){
				$class="orange";
			} else $class="green";
		}

		if($rowTicketDetails['firstname'] || $rowTicketDetails['lastname']){
			$rowTicketDetails['name']=$rowTicketDetails['firstname'] .' '. $rowTicketDetails['lastname'];
		} elseif($rowTicketDetails['email']) $rowTicketDetails['name']=$rowTicketDetails['email'];
		
		$TicketList[$ii]=array("title" => $rowTicketDetails['title'],
			"status" => $rowTicketDetails['status'],
			"summary" => $rowTicketDetails['summary'],
			"rowusername" => $rowTicketDetails['name'],
			"rowuserlevel" => $rowTicketDetails['userlevel'],
			"ticketid" => $rowTicketDetails['tid'],
			"updatedDate" => $rowTicketDetails['updated'],
			"mail_address" => $rowTicketDetails['mail_address'],
			"class" => $class
			);



		$i++;
		$ii++;
	}
}	

if($TicketList && count($TicketList) > 0)$smarty->assign('rowTicketDetails', $TicketList);

$smarty->assign("pageTitle", $pageTitle); 
$smarty->assign("showTicketList", count($TicketList)); 

$smarty->display('troubletickets/ticket-list.tpl');

// Clear re-used variables
$smarty->clearAssign("pageTitle"); 

}
?>