<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_voice_list.php
 * Type:     function
 * Name:     gcp_voice_list
 * Purpose:  displays GameCP's voice list
 * -------------------------------------------------------------
 */
function smarty_function_gcp_voice_list($params, &$smarty)
{
global $GameCP, $limit, $LNG_PREV, $LNG_NEXT, $safesql;
// Ticket list

$sql=$params['sql'];
$pageTitle=$params['pageTitle'];

$sortTableName=$params['sortTableName'];
$formName=$params['formName'];
$jsCheckScript=$params['jsCheckScript'];

$initial=$_GET['initial'];
$view=$_GET['view'];

if(!$sql){ echo "Fatal Error: Missing MySQL query."; exit; }
if($initial){ $cQuery="AND UPPER(LEFT(username,1)) LIKE '$initial'"; }



if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
	$sql=str_replace("RSIDQUERY", "AND U.rsid='".$_SESSION['gamecp']['userinfo']['id']."'", $sql);
}elseif($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3"){
	$sql=str_replace("RSIDQUERY", "AND U.id='".$_SESSION['gamecp']['userinfo']['id']."'", $sql);
} else $sql=str_replace("RSIDQUERY", "", $sql);

if($_REQUEST['initial']) $sql=$sql." AND UPPER(LEFT(U.username,1)) LIKE '".$GameCP->whitelist($_REQUEST['initial'], "text")."'"; 

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3" && $_SESSION['gamecp']['userinfo']['ulevel'] != "4"  && $_SESSION['gamecp']['userinfo']['ulevel'] != "5"){
	$sql=$sql." AND U.id = '". $_SESSION['gamecp']['userinfo']['id']."'";
} else if(isset($_REQUEST['cid']) && $_REQUEST['cid']){
	$sql=$sql." AND U.id = '". $GameCP->whitelist($_REQUEST['cid'], 'int')."'";
}

// Clear any old variabels.
$smarty->clearAssign("rowVoiceDetails"); 
$VoiceList=array();
$i = "0"; 

/* page control */
$result=Smarty_PageControl($sql, "voice", "voice");

while ($rowVoiceDetails= mysql_fetch_array($result)){

	if($_SESSION['gamecp']['userinfo']['ulevel'] == "5"){
		$usersServersQ = sql_query("SELECT servers FROM users WHERE id='". $_SESSION['gamecp']['userinfo']['id'] ."'") or die(mysql_error());
		$usersServers = mysql_fetch_array($usersServersQ);
		$userServer=unserialize($usersServers[0]);
		if(in_array($rowVoiceDetails['ip'], $userServer)){
				$addRow = true;
		} else $addRow = false;

	} else $addRow = true;

	if($addRow == true){
		/* server info */
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$machineInfo=$Panel->GetServer('', $rowVoiceDetails['ip']);
		$superpass=$machineInfo['tspass'];
		$superuser=$machineInfo['tsadmin'];

		if ($tssid == "" || $tssid == NULL)$tssid = 0;
		
		if($rowVoiceDetails['tssid'] == "0"){ $type="Ventrilo"; } else { $type="TeamSpeak2"; } 

		if($rowVoiceDetails['firstname'] || $rowVoiceDetails['lastname']){
			$rowVoiceDetails['user']=$rowVoiceDetails['firstname'].' '.$rowVoiceDetails['lastname'];
		} else if($rowVoiceDetails['email']) $rowVoiceDetails['user']=$rowVoiceDetails['email'];

		$VoiceList[$i]=array("vid" => $rowVoiceDetails['vid'],
			"uvid" => $rowVoiceDetails['id'], 
			"tssid" => $rowVoiceDetails['tssid'],
			"sp" => $sp,
			"tsip" => $rowVoiceDetails['ip'],
			"tsport" => $rowVoiceDetails['port'],
			"ipport" => $rowVoiceDetails['ip'].":".$rowVoiceDetails['port'],
			"type" => $type,
			"servername" => $rowVoiceDetails['servername'],
			"rowusername" => $rowVoiceDetails['user'],
			"voicepass" => $rowVoiceDetails['pass'],
			"voicetype" => $rowVoiceDetails['voicetype'],
			"active" => $rowVoiceDetails['active'],
			"ts3token" => $rowVoiceDetails['ts3token']
			);

		$i++;
	}

}	

/* page control */
if($VoiceList && count($VoiceList) > 0)$smarty->assign('rowVoiceDetails', $VoiceList);


$smarty->assign("pageTitle", $realPageTitle); 
$smarty->assign("sortTableName", $sortTableName); 

$smarty->assign("displayControls", "yes"); 
$smarty->assign("showVoiceList", count($VoiceList)); 

$smarty->display('modules/voice-list.tpl');

// Clear re-used variables
$smarty->clearAssign("pageTitle"); 
$smarty->clearAssign("displayControls"); 

}
?>