{strip}
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
            "http://www.w3.org/TR/html4/loose.dtd">
<html lang="{$lang}">
<head {if #TYPE_DIRECTION# == "rtl"}dir="rtl"{/if}>
	{include file="headers/global_header.tpl"}
	{include file="headers/graph_settings.tpl"}
</head>
<body id="site_body">
<div class="container">
	{include file="headers/specializedheader.tpl"}
	<div id="ajaxlog"></div>
	<div id="topHeader">
		{* logo *}
		<div class="headerLogo">
			<a href="{if $sessionUserLevel == "0"}{$url}/system/{else}{$url}/manage/{/if}">
				{if $sessionUserLevel == "0" }
					{if $logoImage}
						<img src="{$logoImage}" alt="{$domainName}" title="{$domainName}">
					{else}
						{if !isset($copyrightRemoval)}
							<div id="logo" title="{$domainName}"></div>
						{/if}
					{/if}
				{else}
					{if $adminLogoImage}
						<img src="{$adminLogoImage}" alt="{$domainName}" title="{$domainName}">
					{else}
						{if !isset($copyrightRemoval)}
							<div id="logo" title="{$domainName}"></div>
						{/if}
					{/if}
				{/if}
			</a>
		</div>
		{if $slogan}<div class="headerSlogan">{$slogan}</div>{/if}
	{* admin controls *}
	{if $sessionUserLevel == "1"}
		<input class="headerDetailsAdminButton button" type="button" onclick="$('.headerDetailsAdmin, .headerDetailsLastAccess').slideToggle();" value="{#LNG_SEARCH#}" title="Admin Menu">
		<div class="headerDetailsLastAccess">
			{if isset($smarty.session.gamecp.user.browseGame)}<a href="{$url}/system/userservices.php?mode=edit2&opt=edit&ggid={$smarty.session.gamecp.user.browseGame}" class="button">{#LNG_LASTSERVICE#}: #{$smarty.session.gamecp.user.browseGame}</a>{/if}
		</div>
		<div class="headerDetailsAdmin">
			<div class="headerQuickControl">
				{$GameCP->generateUserList()}
				{assign var="userList" value=$GameCP->userList}
				<form id="quickselect_form" name="quickselect_form" method="post" action="{$url}/includes/quickcontrol.php">
					<select name="id" id="quickselect_id">
						<option value="">{#LNG_SELECTUSER# nofilter}</option>
						{if $deviceType == "computer"}<option value="" class="selectspace">{#LNG_QUICKLINKSPACE# nofilter}</option>{/if}
						{section name=userListRow loop=$userList}
							<option value="{$userList[userListRow].id}" class="selecta">{$userList[userListRow].name}</option>
						{/section}
					</select>
					<select name="opt" id="quickselect_opt" onchange="return validateQuickNav();">
						<option value="">{#LNG_OPTIONS# nofilter}</option>
						{if $deviceType == "computer"}<option value="" class="selectspace">{#LNG_QUICKLINKSPACE# nofilter}</option>{/if}
						<option value="suspend" class="selecta">{#LNG_SUSPENDSERVER# nofilter}</option>
						<option value="unsuspend" class="selecta">{#LNG_UNSUSPENDSERVER# nofilter}</option>
						<option value="delete" class="selecta">{#LNG_REMOVE# nofilter}</option>
						{if $deviceType == "computer"}<option value="" class="selectspace">{#LNG_QUICKLINKSPACE# nofilter}</option>{/if}
						<option value="edit" class="selectc">{#LNG_EDITCLIENT# nofilter}</option>
						<option value="viewgames" class="selectc">{#LNG_VIEWGAMES# nofilter}</option>
						<option value="notify" class="selectc">{#LNG_NOTIFYCLIENT# nofilter}</option>
						{if $deviceType == "computer"}<option value="" class="selectspace">{#LNG_QUICKLINKSPACE# nofilter}</option>{/if}
						{if $usebilling == "1"}
							<option value="addbill" class="selecta">{#LNG_ADDBILL# nofilter}</option>
							<option value="viewbill" class="selecta">{#LNG_VIEWBILLS# nofilter}</option>
						{/if}
					</select>
				</form>
			</div>
			<div class="headerSearch">
				<form method="post" action="{$url}/manage/clients.php">
					<input type="text" id="searchcontent" name="searchcontent" value="{#LNG_SEARCHCLIENTS# nofilter}" onclick="if(this.value == '{#LNG_SEARCHCLIENTS# nofilter}') this.value='';">
					<input type="hidden" name="displayType" value="Active">
					<input type="hidden" name="mode" value="edit">
					<input type="submit" value="GO">
				</form>
			</div>
		</div>
	{/if}
</div>
{if $deviceType != "computer"}
	{include file="navigation/mobilenav.tpl"}
{else}
	{include file="navigation/navigation.tpl"}
{/if}
{* div is open until it is closed in side the footer, wraps all content *}
<div class="content_wrapper">
{/strip}