{strip}
<div class="pageHeader">
	<h3>{#LNG_GAMEMANAGEMENT# nofilter}</h3>
</div>
<div class="pageNavigation">
	{include file="managegames/gamemenu.tpl" gamepg="repos"}
</div>

<div class="clear"></div>

<div class="inner_content">

<table class="listTable" width="100%" align="center" cellpadding="2" cellspacing="0">
	<tr>
		<td colspan="2" align="right">
		{if $gamelist.page_total > "1"}
			{if $smarty.request.view != "all"}
				<a href="?mode=edit&amp;view=all" class="pageAll button">{#LNG_ALL# nofilter}</a> 
			{else}
				<a href="?mode=edit" class="pageAll button">{#LNG_RESET# nofilter}</a> 
			{/if}
			{if $smarty.request.view != "all"}<span class="pagePrev">&nbsp; {paginate_prev id="gamelist"}</span> <span class="pageNext">{paginate_next id="gamelist"}&nbsp;</span>{/if}
		{/if}
		</td>
	</tr>
</table>


<table class="bgb sort-table listTable" id="table-glist" width="100%" align="center" cellpadding="2" cellspacing="0">
	<thead>
	<tr class="tableTop">
		<td colspan="3" class="tableTitle">{#LNG_REPOSITORIES# nofilter}</td>
		<td colspan="2" align="right">
			{if $smarty.request.view == "all"}{#LNG_ALL# nofilter}{else}{$gamelist.first} - {$gamelist.last}{/if} of {$gamelist.total} 
		</td>
	</tr>
	<tr class="bgc">
		<th align="center" nowrap>&nbsp;</th>
		<th align="left">&nbsp;</th>
		<th align="center">Last Ran</th>
		<th align="left">Health Check</th>
		<th align="center" width="30%">History</th>
	</tr>
	</thead>
	<tfoot>
	<tr class="tableBottom">
		<td colspan="3">&nbsp;</td>
		<td colspan="2" align="right">
			{if $smarty.request.view == "all"}{#LNG_ALL# nofilter}{else}{$gamelist.first} - {$gamelist.last}{/if} of {$gamelist.total} 
		</td>
	</tr>

	</tfoot>
	<tbody>

{section name="gi" loop=$gameInfo}
	<tr class="{cycle values='even, odd'}">
		<td>		
			<div class="button-group">
				<input class="button" type="button" value="{#LNG_UPDATE#}"  onClick="document.location='?mode=run&amp;gmid={$gameInfo[gi].id}'">
				<input class="button danger" type="button" value="{#LNG_REINSTALL#}"  onClick="document.location='?mode=run&amp;action=reinstall&amp;gmid={$gameInfo[gi].id}'">
			</div>
		</td>
		<td align="left">{$gameInfo[gi].name}</td>
		<td align="center">{if $gameInfo[gi].lastran}{$gameInfo[gi].lastran|date_format:$dateformattpl}{else}{#LNG_NEVER#}{/if}</td>
		<td align="left">
			{if $gameInfo[gi].lastran}
				<div id="repohealth{$gameInfo[gi].id}">
					<img src='{$url}/includes/core/javascript/jquery/ajax-loader2.gif' alt='Loading...' title='Loading...' >
				</div>
				<script type="text/javascript">
					checkRepoHealth('{$gameInfo[gi].id}');
				</script>
			{/if}
		</td>
		<td align="center" style="padding:0px">
			{if $gameInfo[gi].status == "1"}
				<div id="movedone{$gameInfo[gi].id}" class="ui-helper-hidden">
					<h3>{#LNG_UPDATECOMPLETE# nofilter}</h3>
				</div>
				<div id="loadingbars{$gameInfo[gi].id}">
					<img src='{$url}/includes/core/javascript/jquery/ajax-loader2.gif' alt='Loading...' title='Loading...' ><br>
				</div>
				<div id="movestatus{$gameInfo[gi].id}"></div>
				<script type="text/javascript">
					RepoUpdateStatus('#movestatus{$gameInfo[gi].id}', '', '300000', '{$gameInfo[gi].id}')
				</script>
			{else}
				<div id="repohistory">
					<table width="100%" cellpadding="2" cellspacing="0">
					{foreach $gameInfo[gi].log as $i => $l}
							{if $l.result.log || $l.result.status}
								<tr>
									<td colspan="2"><strong>{$i}</strong></td>
								</tr>

								{if $l.result.log}
									<tr>
										<td><strong>Log:</strong></td>
										<td><textarea class="ninenine">{$l.result.log}</textarea></td>
									</tr>
								{/if}
								{if $l.result.status}
									<tr>
										<td><strong>Status:</strong></td>
										<td>{$l.result.status}</td>
									</tr>
								{/if}
							{/if}
					{/foreach}
					</table>
				</div>
			{/if}
		</td>
	</tr>
{/section}
</tbody>
</table>



<table class="listTable" width="100%" align="center" cellpadding="2" cellspacing="0">
	<tr>
		<td colspan="2" align="right">
		{if $gamelist.page_total > "1"}
			<a href="?mode=edit&amp;view=all" class="pageAll button">{#LNG_ALL# nofilter}</a> 
			{if $smarty.request.view != "all"}<span class="pagePrev">&nbsp; {paginate_prev id="gamelist"}</span> <span class="pageNext">{paginate_next id="gamelist"}&nbsp;</span>{/if}
		{/if}
		</td>
	</tr>
</table>





<script type="text/javascript" src="{$url}/includes/gzip.php?uri=includes/core/javascript/jquery/jquery.tablesorter.min.js"></script>
<script type="text/javascript">
{literal}

$(window).load(function() { 
    $("#table-glist").tablesorter(); 
});

{/literal}
</script>

</div>
{/strip}