<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

class Migrate{

	function Start(){
		global $smarty;

		$bb=array();
		if(is_file("TCAdmin.mdb.TC_SERVICES.txt") && is_readable("TCAdmin.mdb.TC_SERVICES.txt")){
			$usertable=$this->readData("TCAdmin.mdb.TC_SERVICES.txt");
			unset($usertable[0]);
			foreach($usertable as $d => $a){
				$bb[strtolower($a[3])]=array(
					"user" => strtolower($a[3]),	
					"name" => $a[5],	
					"ip" => $a[12],	
					"port" => $a[13],	
					"query" => $a[14],	
					"rcon" => $a[14],	
					"slots" => $a[16],	
					"private" => $a[17],	
					"billingid" => $a[17],	
				);
			}
		}
		$smarty->assign("gameList", $bb);
		$smarty->assign("gameMaster", $this->GameList());

		$dd=array();
		if(is_file("TCAdmin.mdb.TC_USERS.txt") && is_readable("TCAdmin.mdb.TC_USERS.txt")){
			$usertable=$this->readData("TCAdmin.mdb.TC_USERS.txt");
			unset($usertable[0]);
			foreach($usertable as $d => $a){
				$username=str_replace(" ", "", strtolower(trim($a[1])).substr(strtolower(trim($a[2])), 0, 1));
				if($username && $this->IsUser($username) != "1") $dd[]=$username;
			}
		}
		$smarty->assign("userList", $dd);

		$cc=array();
		if(is_file("TCAdmin.mdb.TC_VIRTUAL_VOICE_SERVERS.txt") && is_readable("TCAdmin.mdb.TC_VIRTUAL_VOICE_SERVERS.txt")){
			$voicetable=$this->readData("TCAdmin.mdb.TC_VIRTUAL_VOICE_SERVERS.txt");
			unset($voicetable[0]);
			foreach($voicetable as $d => $a){
				$username=strtolower($a[1]);
				$port=$a[2];
				$cc[$username]=array($port, $a[4]);

			}
		}
		$smarty->assign("voiceList", $cc);
		$smarty->assign("serverList", $this->ServerList());
		$smarty->display("migrate/tca2gcp/start.tpl");
	}

	function Step1(){
		global $smarty;
	
		error_reporting(2039);

		require_once('../includes/core/classes/mysql/SafeSQL.class.php');
		require_once('../includes/core/classes/gamecp/class.inc.php');
		require_once('../includes/core/classes/voice/class.inc.php');
		require_once('../includes/core/classes/query/class.inc.php');
		require_once('../includes/core/classes/user/class.inc.php');
		$GameCP= new GameCP();
		$Query= new Query();
		$Voice= new Voice();
		$User= new User();
		$safesql = new SafeSQL_MySQL();

		if(isset($_REQUEST['import']) && is_array($_REQUEST['import']) && is_file("TCAdmin.mdb.TC_USERS.txt") && is_readable("TCAdmin.mdb.TC_USERS.txt")){
			$usertable=$this->readData("TCAdmin.mdb.TC_USERS.txt");
			unset($usertable[0]);
			foreach($usertable as $d => $a){
				$username=strtolower(trim($a[1])).substr(strtolower(trim($a[2])), 0, 1);
				if($username && in_array($username, $_REQUEST['import'])){
					$q=$safesql->query("INSERT INTO users SET name = '%s', email = '%s', 
									username = '%s', userlevel = '%s',
									active = '1', phone = '%s', address = '%s',
									city = '%s', state = '%s', country = '%s',
									zip = '%s', website = '%s', 
									extranotes = '%s',
									firstname = '%s', lastname = '%s',
									payment = '%s', address2 = '%s', 
									bash = '%s', 
									indexsort='%s',
									joindate = '%s', `limit`='1',
									filemanager='%i', billingid='%i' $reseller", array(
										$username,
										$a[14],
										$username,
										'0',
										$a[12],
										$a[5],
										$a[8],
										$a[9],
										$a[10],
										$a[11],
										'',
										'',
										$a[1],
										$a[2],
										'',
										$a[6],
										"no",
										'a:2:{s:4:"left";s:93:"a:4:{i:0;s:12:"controlicons";i:1;s:11:"activegames";i:2;s:13:"inactivegames";i:3;s:4:"news";}";s:5:"right";s:81:"a:3:{i:0;s:13:"serverdetails";i:1;s:14:"supporttickets";i:2;s:12:"pendingbills";}";}',
										time(),
										'0',
										$a[19]
									));
					if($this->IsUser($usr) != "1"){
						mysql_query($q);
						$GameCP->SetPassword(mysql_insert_id(), $this->RandomPassword());
					}
				}
			}
		}
		if(isset($_REQUEST['game']) && is_array($_REQUEST['game'])){
			foreach($_REQUEST['game'] as $g => $v){
				if($v['use'] == true){
					$usr=$g;
					$pid=$v['type'];
					if($this->IsUser($usr) == "1"){
						$usrInfo=$this->GetUser($usr);
						$cid=$usrInfo[0];
						$_SESSION['gamecp']['order_api']=false;
						$User->AddGame($usr, $cid, $pid, $v['ip'], $v['port'], $v['query'], '', 'yes',
								$v['slots'],
								$v['private'], 
								true,
								'', 
								'yes',
								'',
								'',
								'',
								'',
								$v['name'],
								'',
								'', '',
								'no',
								'no',
								'',
								'',
								'',
								"1",
								'', '',
								'', '', 
								'', '',
								'', '',
								'',
								$v['billingid'], "no", '', '', '', '');
					} else {
						$_SESSION['gamecp']['order_api']=true;
						$User->Add($usr,
								'',
								$pid,
								$usr,
								'0',
								$this->RandomPassword(), 
								$v['ip'], $v['port'],'',
								'','','','','','','no','', 
								'', '','',
								'','',
								'no',
								time(),
								'',
								$v['ip'], $v['port'],
								'',
								$v['slots'],
								$v['private'], 
								'',
								'',
								'','','', 'no','no','no',
								'no',
								false, 
								true,'','','','',
								$v['name'],
								'','', '', '','','','', '','','','', 
								$v['query'], '', '','', 
								'', '', '',
								'yes',
								$v['billingid'],
								'');

					}
				}
			}
		}

		if(isset($_REQUEST['voice']) && is_array($_REQUEST['voice'])){
			foreach($_REQUEST['voice'] as $usr => $v){
				if(isset($v['port'])){
					if($this->IsUser($usr) == "1"){
						$usrInfo=$this->GetUser($usr);
						$cid=$usrInfo[0];
					} else {
						$cid=$Voice->AddVoiceUser($usr, $this->RandomPassword(), '');
						$GameCP->SetPassword($cid, $this->RandomPassword());
					}
					if($cid){
						switch($v['type']){
							case "ts3":
								$details=$this->GetMachine($v['ip']);
								$results=$Query->Teamspeak($v['ip'], $details['ts3pass'], $details['ts3admin'], $v['port'],$v['type']);
								$fmaxclients=$results[0];
								$fservername=$results[3];
								$tssid=$results[4];
								if(!$tssid) break;
							break;

							case "ts2":
								$results=$Query->Teamspeak($v['ip'], '', '', $v['port'],$v['type']);
								$fmaxclients=$results[0];
								$fservername=$results[3];
								$tssid=$results[4];
								if(!$tssid) break;
							break;

							case "vent":
								$fmaxclients="16";
								$fservername="Imported from TCAdmin";
								$tssid="";
							break;
						}
						// detech if no and make new + this
						$Voice->AddVoiceDB($cid, $usr, $GameCP->Password($cid), $fmaxclients, $v['ip'], $v['port'], $fservername, $v['billingid'], $v['type'], $tssid, '', '');
					}
				}
			}
		}
		$smarty->display("migrate/completed.tpl");
	}

	
	function IsUser($usr){
		$q=mysql_query("SELECT id FROM users WHERE name='$usr' LIMIT 1");
		return mysql_num_rows($q);
	}

	function GetUser($usr){
		$q=mysql_query("SELECT * FROM users WHERE name='$usr' LIMIT 1");
		return mysql_fetch_array($q);
	}

	function GetMachine($sid){
		$q=mysql_query("SELECT * FROM servers WHERE sid='$sid' LIMIT 1");
		return mysql_fetch_array($q);
	}

	function ServerList(){
		$row=array();
		$q=mysql_query("SELECT sid FROM servers WHERE ts3host='1' OR ts2='1' OR vent='1'");
		while($a=mysql_fetch_array($q)) $row[]=$a[0];
		return $row;
	}

	function GameList(){
		$row=array();
		$q=mysql_query("SELECT id, name FROM game");
		while($a=mysql_fetch_array($q)) $row[]=$a;
		return $row;
	}



	function readData($d){
		$row = 1;
		$a=array();
		if (($handle = fopen($d, "r")) !== FALSE) {
			while (($data = fgetcsv($handle, 1000, "\t")) !== FALSE) {
				$ab=array();
				$num = count($data);
				$row++;
				for ($c=0; $c < $num; $c++) {
					$ab[]=$data[$c];
				}
				$a[]=$ab;
			}
			fclose($handle);
		}
		return $a;
	}

	
	
	function RandomPassword() { 
		$salt = "_abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890"; 
		srand((double)microtime()*1000000);  
		$i = 0; 
		while ($i < 10) {  // change for other length
			$num = rand() % 33; 
			$tmp = substr($salt, $num, 1); 
			@$pass = $pass . $tmp; 
			$i++; 
		} 

		return strip_tags($pass);
	}
}

?>