function validateMySQL(){
	$('#badsql').fadeOut();
	$.ajax({
	  type: 'POST',
	  url: 'index.php',
	  data: { 
		  mode: "checkSQL",
			  host: $('#sqlhost').val(),
			  db: $('#sqldb').val(),
			  user: $('#sqluser').val(),
			  pass: $('#sqlpass').val()
		  } ,
	  success: function(data) {
		  if(data != "ok"){
			$('#badsql').fadeIn();
		  } else $('#step2').fadeOut(function(){$('#step3').fadeIn()});
	  }
	});
}

function validateInstall(){
	$('#step2error').fadeOut(function(){ 
		$.ajax({
		  type: 'POST',
		  url: 'index.php',
		  data: { mode: "checkValidation" } ,
		  success: function(data) {
			  if(data){
				  $('#step2error').fadeIn();
				  $('#step2ul').html(data);
			  } else $('#step2details').fadeIn();
		  }
		});
	});
}

function launchMySQLCreate(){
	window.open("index.php?mode=createsql","mywindow","status=0,toolbar=0,menubar=0,width=420,height=456");
}
function createMySQLUser(){
	$.ajax({
	  type: 'POST',
	  url: 'index.php',
	  data: allDetails2() ,
	  success: function(data) {
		  if(data){
			$('#badsqlerror').html(data);
			$('#badsql').fadeIn();
		  } else {
			$('#sqluser', window.opener.document).val($('#sqluser').val());
			$('#sqlpass', window.opener.document).val($('#sqlpass').val());
			$('#sqlhost', window.opener.document).val($('#sqlhost').val());
			$('#sqldb', window.opener.document).val($('#sqldb').val());
			window.close();
		 }
	  }
	});
}
function installGameCP(){
	$.ajax({
	  type: 'POST',
	  url: 'index.php',
	  data: allDetails() ,
	  success: function(data) {
		  if(data != "ok"){
			  $('#step4load').hide();
			  $('#step4error').html(data);
			  $('#step4false').fadeIn();
		  } else {
			  $('#step4load').hide();

			$('#displayuser').html($('#username').val());
			$('#displaypass').html($('#password').val());
			$('#displayemail').html($('#email').val());

			$('#loginuser').val($('#username').val());
			$('#loginpass').val($('#password').val());

			$('#step4true').fadeIn();
		  }
		 }
	});
}

function updateGameCP(){
	$.ajax({
	  type: 'POST',
	  url: 'index.php',
	  data: { mode: "updateGameCP", passupdate: $("#encrypt").attr("checked") } ,
	  success: function(data) {
		  if(data != "ok"){
			  $('#step2load').hide();
			  $('#step2error').html(data);
			  $('#step2error').show();
			  $('#step2false').fadeIn();
		  } else {
			  $('#step2load').hide();
			  $('#step2true').fadeIn();
		  }
		 }
	});
}


function firstStep(upgrade){
	$('#step2load').show();
	$('#step2true, #step2false').hide();

	$('#step1').fadeOut(function(){
		$('#step2').fadeIn(); 
		if (upgrade == true) updateGameCP();
	});
}

function checkVal(check){
	if($('#'+check).val() != "") return true;
	return false;
}

function validateProfile(){
	if(checkVal('username') == false || checkVal('password') == false   || checkVal('email')  == false  || $('#agreetos').attr("checked") == false ){
		$('#step3required').fadeIn();
		return false;
	}
	$('#step3required').fadeOut();
	return true;
}

function submitProfile(){
	if(validateProfile() == true){
		$('#step4load').show();
		$('#step4true, #step4false').hide();

		$('#step3').fadeOut(function(){
			$('#step4').fadeIn()
			installGameCP();
		});
	}
}

function allDetails(){
	return {
		mode: "installGameCP",
		username: $('#username').val(),
		password: $('#password').val(),
		license: $('#license').val(),
		email: $('#email').val(),
		style: $('#style').val(),
		sqluser: $('#sqluser').val(),
		sqlpass: $('#sqlpass').val(),
		sqlhost: $('#sqlhost').val(),
		sqldb: $('#sqldb').val()
	};

}
function allDetails2(){
	return {
		mode: "addsqluser",
		adminsqluser: $('#adminsqluser').val(),
		adminsqlpass: $('#adminsqlpass').val(),
		sqluser: $('#sqluser').val(),
		sqlpass: $('#sqlpass').val(),
		sqlhost: $('#sqlhost').val(),
		sqldb: $('#sqldb').val()
	};

}

$(document).ready(function(){
	$(".sqlform input").bind("keydown", function(e) {
		if (e.keyCode == 13) {
			validateMySQL();
			return false; 
		}
	});
	$(".detailsform input").bind("keydown", function(e) {
		if (e.keyCode == 13) {
			submitProfile();
			return false; 
		}
	});


});






function migrateFirstStep(type){
	var loadme=type.val();

	if(loadme){
		window.location='?mode=load&migrate='+loadme;
	} else alert("Unknown migration.");

}

function migrateStatusCheck(type, step){

	$.ajax({
		type: "GET",
		url: "?debugging=true&mode=load&step="+step+"&noheader=true&migrate="+type,
		success: function(msg){
			if(msg == "completed"){
				window.location='?mode=load&step=completed&migrate='+type;
			}else if(msg == "failed" || msg == "error"){
				window.location='?mode=load&step=failed&migrate='+type;
			} else {
				if(msg) $("#status").html(msg);	
				setTimeout(function() {	
					migrateStatusCheck(type, step);
				}, '3000');	
			}
		}
	});
}


function sqlUserFunctions(){
    $('input[type=text], input[type=password]').keyup(function(e) {
        if(e.keyCode == 13) createMySQLUser();    
	});

	$('#sqlpass, #sqlpassid').dblclick(function() {
		$.ajax({
			type: "GET",
			url: "?&mode=getpassword",
			success: function(msg){
				if(msg){
					$('#sqlpass').val(msg);
				}
			}
		});
	});
}