<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
$GameCP->CheckPermissions('addons');

$smarty->assign('page_title', $LNG_GAMEMANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

function addonGameList(){
	global $smarty;

	$addonsList="";
	$resultClient = sql_query("SELECT id, name FROM addons ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($resultClient)) $addonsList.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";
	$smarty->assign("addonsList", $addonsList);

	$gameList = Array(); 
	$resultClient = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_assoc($resultClient)) $gameList[] = $row; 
	$smarty->assign('gameList', $gameList);

	$catList = Array(); 
	$resultClient = sql_query("SELECT * FROM `addoncategorys` ORDER BY 'title'") or die(mysql_error());
	while ($row = mysql_fetch_assoc($resultClient)) $catList[] = $row; 
	$smarty->assign('catList', $catList);
}





if(!isset($mode) || isset($mode) && !$mode){
	$mode="";
	addonGameList();
}


if ($mode == "remove") {
	if($aid) sql_query($safesql->query("DELETE FROM addons WHERE id='%i';", array( $GameCP->whitelist($aid, "int")))) or die(mysql_error());
	$smarty->assign("showSaved", "true");
	$mode="";
}

if ($mode == "update") {
	if(!$_REQUEST['gmid']){
		echo "Please select a game.";
	} else if($aid){

		if(!isset($dodisable)) $dodisable ='0';
		if(!isset($doenable)) $doenable ='0';
		if(!isset($doinstall)) $doinstall ='0';
		if(!isset($doupdate)) $doupdate ='0';
		if(!isset($douninstall)) $douninstall ='0';
		if(!isset($doexecute)) $doexecute ='0';
		if(!isset($restart)) $restart="0";

		sql_query($safesql->query("UPDATE addons SET 
			installfile = '%s',
			name ='%s',
			command = '%s',
			uninstallcommandline='%s',
			updatecommandline='%s',
			adminonly='%s', 
			`notes`='%s',
			wincommand='%s',
			winuninstallcommandline='%s',
			winupdatecommandline='%s',
			enablecmdline='%s', 
			winenablecmdline='%s',
			disablecmdline='%s', 
			windisablecmdline='%s',
			winexeccmd='%s',
			execcmd='%s',
			dodisable='%i',
			doenable='%i',
			doinstall='%i',
			doupdate='%i',
			douninstall='%i',
			doexecute='%i',
			restart='%i',
			category='%i'
		WHERE id='%i'",
		array(
			$GameCP->whitelist($installfile, "web"),
			$GameCP->whitelist($ainame, "useredit"),
			$GameCP->whitelist($commandline, "web"),
			$GameCP->whitelist($uninstallcommandline, "web"),
			$GameCP->whitelist($updatecommandline, "web"),
			$GameCP->whitelist($adminonly, "useredit"),
			$GameCP->whitelist($fnotes, "web"),
			$GameCP->whitelist($wincommand, "web"),
			$GameCP->whitelist($winuninstallcommandline, "web"),
			$GameCP->whitelist($winupdatecommandline, "web"),
			$GameCP->whitelist($enablecmdline, "web"),
			$GameCP->whitelist($winenablecmdline, "web"),
			$GameCP->whitelist($disablecmdline, "web"),
			$GameCP->whitelist($windisablecmdline, "web"),
			$GameCP->whitelist($winexeccmd, "web"),
			$GameCP->whitelist($execcmd, "web"),
			$GameCP->whitelist($dodisable, "int"),
			$GameCP->whitelist($doenable, "int"),
			$GameCP->whitelist($doinstall, "int"),
			$GameCP->whitelist($doupdate, "int"),
			$GameCP->whitelist($douninstall, "int"),
			$GameCP->whitelist($doexecute, "int"),
			$GameCP->whitelist($restart, "int"),
			$GameCP->whitelist($aicat, "int"),
			$GameCP->whitelist($aid, "int")
		))) or die(mysql_error());

		sql_query($safesql->query("DELETE FROM addongames WHERE aid='%i';", array( $GameCP->whitelist($aid, "int")))) or die(mysql_error());
		if(is_array($gmid)){
			foreach($gmid as $gm){
				if($gm) sql_query($safesql->query("INSERT INTO addongames SET aid='%i', gid='%i';", array( $GameCP->whitelist($aid, "int"), $GameCP->whitelist($gm, "int")))) or die(mysql_error());
			}
		}

	}

	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";

	$_REQUEST['aid']=$aid;
}

if ($mode == "add") {
	if($_REQUEST['gmid']){
		if(!isset($dodisable)) $dodisable ='0';
		if(!isset($doenable)) $doenable ='0';
		if(!isset($doinstall)) $doinstall ='0';
		if(!isset($doupdate)) $doupdate ='0';
		if(!isset($douninstall)) $douninstall ='0';
		if(!isset($doexecute)) $doexecute ='0';
		if(!isset($restart)) $restart="0";

		sql_query($safesql->query("INSERT INTO addons SET
			installfile = '%s',
			name ='%s',
			command = '%s',
			uninstallcommandline='%s',
			updatecommandline='%s',
			adminonly='%s', 
			`notes`='%s',
			wincommand='%s',
			winuninstallcommandline='%s',
			winupdatecommandline='%s',
			enablecmdline='%s', 
			winenablecmdline='%s',
			disablecmdline='%s', 
			windisablecmdline='%s',
			winexeccmd='%s',
			execcmd='%s',
			dodisable='%i',
			doenable='%i',
			doinstall='%i',
			doupdate='%i',
			douninstall='%i',
			doexecute='%i',
			restart='%i',
			category='%i'",
		array(
			$GameCP->whitelist($installfile, "web"),
			$GameCP->whitelist($ainame, "useredit"),
			$GameCP->whitelist($commandline, "web"),
			$GameCP->whitelist($uninstallcommandline, "web"),
			$GameCP->whitelist($updatecommandline, "web"),
			$GameCP->whitelist($adminonly, "useredit"),
			$GameCP->whitelist($fnotes, "web"),
			$GameCP->whitelist($wincommand, "web"),
			$GameCP->whitelist($winuninstallcommandline, "web"),
			$GameCP->whitelist($winupdatecommandline, "web"),
			$GameCP->whitelist($enablecmdline, "web"),
			$GameCP->whitelist($winenablecmdline, "web"),
			$GameCP->whitelist($disablecmdline, "web"),
			$GameCP->whitelist($windisablecmdline, "web"),
			$GameCP->whitelist($winexeccmd, "web"),
			$GameCP->whitelist($execcmd, "web"),
			$GameCP->whitelist($dodisable, "int"),
			$GameCP->whitelist($doenable, "int"),
			$GameCP->whitelist($doinstall, "int"),
			$GameCP->whitelist($doupdate, "int"),
			$GameCP->whitelist($douninstall, "int"),
			$GameCP->whitelist($doexecute, "int"),
			$GameCP->whitelist($restart, "int"),
			$GameCP->whitelist($aicat, "int"),
		))) or die(mysql_error());

		$aid=mysql_insert_id();
		if(is_array($gmid)){
			foreach($gmid as $gm){
				if($gm) sql_query($safesql->query("INSERT INTO addongames SET aid='%i', gid='%i';", array( $GameCP->whitelist($aid, "int"), $GameCP->whitelist($gm, "int")))) or die(mysql_error());
			}
		}
	}

	$smarty->assign("showSaved", "true");
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}

if($mode == "clone") { 
	$addonInfoQ = sql_query($safesql->query("SELECT * FROM addons WHERE id ='%i'", array($GameCP->whitelist($aid, "int")))) or die(mysql_error());
	$addonInfo = mysql_fetch_assoc($addonInfoQ);
	$addonInfo['id']="";
	foreach ($addonInfo as $key => $value) {
		if ($key != $id_field) $query.=$safesql->query("`$key` = '%s', ", array($value));
	} 
	$query=rtrim($query, ", ");

	$q="INSERT INTO addons SET $query";
	sql_query($q) or die(mysql_error());
	$aid=mysql_insert_id();
	$mode = "";
	$showsaved=true;

}

if($mode == "edit") { 
	addonGameList();
	$addonInfoQ = sql_query($safesql->query("SELECT * FROM addons WHERE id ='%i'", array($GameCP->whitelist($aid, "int")))) or die(mysql_error());
	$addonInfo = mysql_fetch_array($addonInfoQ);
	$addonGames=array();

	$addonInfoQ = sql_query($safesql->query("SELECT * FROM addongames WHERE aid ='%i'", array($GameCP->whitelist($aid, "int")))) or die(mysql_error());

	while($addonGamess=mysql_fetch_array($addonInfoQ)) $addonGames[]=$addonGamess['gid'];

	$smarty->assign("addonInfo", $addonInfo);
	$smarty->assign("addonGames", $addonGames);
	$smarty->display("manageaddons/manageaddons-edit.tpl");
} 

if($mode == "new"){
	addonGameList();
	$smarty->assign("addonGames", array());
	$smarty->display("manageaddons/manageaddons-edit.tpl");
}


if($mode == "") {
	$addonsList=array();
	$gameList=array();
	if(isset($_REQUEST['gmid']) && $_REQUEST['gmid']){
		$gmidq=" WHERE gmid = '$gmid'";
	} else $gmidq="";

	$gameList=array();
	$addonGamesQ = sql_query("SELECT distinct(gmid) FROM addons ORDER BY name") or die(mysql_error());
	while ($addonGames = mysql_fetch_array($addonGamesQ)){
		$gameQ = sql_query($safesql->query("SELECT name as 'gamename' FROM game WHERE id='%i' LIMIT 1;", array( $GameCP->whitelist($addonGames['gmid'], "int")))) or die(mysql_error());
		$game = mysql_fetch_array($gameQ);
		$addonGames['name']=$game['gamename'];
		$gameList[]=$addonGames;

	}

	$smarty->assign("gameList", $gameList);

	$addonCats=array();
	$addonsListQ = sql_query("SELECT * FROM `addoncategorys`") or die(mysql_error());
	while($ac = mysql_fetch_assoc($addonsListQ)) $addonCats[$ac['id']]=$ac['title'];
	$addonCats[0]=$LNG_DEFAULT;
	$smarty->assign("addonCats", $addonCats);

	$addonsList=array();
	$addonsListQ = sql_query("SELECT * FROM addons ORDER BY category ASC") or die(mysql_error());
	while($adlist=mysql_fetch_array($addonsListQ)){
		$aid=$adlist['id'];
		$adlist['gamename']="";
		$addonInfoQ = sql_query($safesql->query("SELECT gid FROM addongames WHERE aid ='%i'", array($GameCP->whitelist($aid, "int")))) or die(mysql_error());
		while($addonGames=mysql_fetch_array($addonInfoQ)){
			$gameQ =  sql_query($safesql->query("SELECT name FROM game WHERE id='%i' LIMIT 1;", array( $GameCP->whitelist($addonGames['gid'], "int")))) or die(mysql_error());
			$game = mysql_fetch_array($gameQ);
			if($game['name']) $adlist['gamename'].=$game['name'].", ";
		}

		$adlist['gamename']=substr($adlist['gamename'], 0, -2);

		if(isset($_REQUEST['gmid']) && $_REQUEST['gmid'] && $adlist['gmid'] == $_REQUEST['gmid']){
			$addonsList[]=$adlist;
		} elseif(!isset($_REQUEST['gmid']) || isset($_REQUEST['gmid']) && !$_REQUEST['gmid']) $addonsList[]=$adlist;

	}

	$smarty->assign("addonsList", $addonsList);
	$smarty->display("manageaddons/addons-list.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>