<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode="";

$GameCP->CheckPermissions('productaddons');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (paddons)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (paddons)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

if(!isset($_REQUEST['mode'])) $mode="";
if(!isset($_REQUEST['offset'])) $offset="";
if(!isset($_REQUEST['gmid'])) $gmid="";
if(!isset($_REQUEST['sortQ'])) $sortQ="";
if(!isset($_REQUEST['cQuery'])) $cQuery="";
if(!isset($_REQUEST['ALTQUERY'])) $ALTQUERY="";
if(!isset($_REQUEST['gid'])) $_REQUEST['gid']="";
if(!isset($_REQUEST['sortWay'])) $sortWay="";
if(!isset($_REQUEST['sortField'])) $sortField="";
if(!isset($_REQUEST['updateid'])) $updateid="";
if(!isset($_REQUEST['newSort'])) $newSort="";
if(!isset($_REQUEST['ioffset'])) $ioffset="";
if(!isset($_REQUEST['view'])) $view="";


if ($mode == "remove") {
	sql_query($safesql->query("DELETE FROM paddon WHERE id='%i'", array($_REQUEST['id']))) or die(mysql_error());
	$mode = "edit";
}
if ($mode == "removetype") {
	sql_query($safesql->query("DELETE FROM paddontype WHERE id='%i'", array($pid))) or die(mysql_error());
	sql_query($safesql->query("DELETE FROM paddon WHERE pid='%i'", array($pid))) or die(mysql_error());
	$mode = "";
}


if ($mode == "save") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	if(!isset($required)) $required='0';

	if(!$pid){
		sql_query($safesql->query("INSERT INTO paddontype SET
								prodid='%s',
								rank='%s',
								name='%s',
								cvar='%s',
								required='%i',
								`type` = '%s'", 
								array($prodid,$rank,$gname, $cvar,$required,$ptype)
							)) or die(mysql_error());
		$pid=mysql_insert_id();
	} else sql_query($safesql->query("UPDATE paddontype SET
								rank='%s',
								name='%s',
								cvar='%s',
								required='%i',
								`type` = '%s'
								WHERE id='%s'", 
								array($rank,$gname, $cvar,$required,$ptype, $pid)
							)) or die(mysql_error());

	
	if(is_array($_REQUEST['row'])){
		foreach($_REQUEST['row'] as $r => $w){
			if($r=="new") { 
				if(
					$w['rank'] ||
					$w['grate'] ||
					$w['name'] ||
					$w['gcost'] ||
					$w['gfee'] ||
					$w['quarterly'] || 
					$w['semiannualy'] || 
					$w['annauly'] ||
					$w['twoyears'] ||
					$w['cval']
				) sql_query($safesql->query("INSERT INTO paddon SET
										pid='%s',
										rank='%s',
										rate='%s', 
										name='%s',
										cost='%s',
										fee='%s', 
										quarterly = '%s',
										semiannualy = '%s',
										annauly = '%s', 
										2years = '%s', 
										pubpriv = '%s', 
										cval='%s'", 
										array($pid,$w['rank'],$Panel->RemFormatNumber($w['grate']), $w['name'],$Panel->RemFormatNumber($w['gcost']),$Panel->RemFormatNumber($w['gfee']),$Panel->RemFormatNumber($w['quarterly']), $Panel->RemFormatNumber($w['semiannualy']),$Panel->RemFormatNumber($w['annauly']),$Panel->RemFormatNumber($w['twoyears']),$w['pubpriv'], $w['cval'])
									)) or die(mysql_error());
			} else sql_query($safesql->query("UPDATE paddon SET
										pid='%s',
										rank='%s',
										rate='%s', 
										name='%s',
										cost='%s',
										fee='%s', 
										quarterly = '%s',
										semiannualy = '%s',
										annauly = '%s', 
										2years = '%s', 
										pubpriv = '%s', 
										cval='%s'
									WHERE id='%i'", 
										array($pid,$w['rank'],$Panel->RemFormatNumber($w['grate']), $w['name'],$Panel->RemFormatNumber($w['gcost']),$Panel->RemFormatNumber($w['gfee']),$Panel->RemFormatNumber($w['quarterly']), $Panel->RemFormatNumber($w['semiannualy']),$Panel->RemFormatNumber($w['annauly']),$Panel->RemFormatNumber($w['twoyears']),$w['pubpriv'], $w['cval'], $r)
									)) or die(mysql_error());
		}
	}
	$smarty->assign("showSaved", "true");
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}




if($mode == "edit") { 

	if(isset($pid)){
		$info = sql_query($safesql->query("SELECT * FROM paddon WHERE pid ='%i';", array($pid))) or die(mysql_error());
		while($pinf = mysql_fetch_assoc($info))$pinfo[]=$pinf;
		$smarty->assign("pinfo", $pinfo);
		$smarty->assign("pid", $pid);

		$info = sql_query($safesql->query("SELECT * FROM paddontype WHERE id ='%i' LIMIT 1;", array($pid))) or die(mysql_error());
		$prodinfo = mysql_fetch_assoc($info);
		$smarty->assign("prodinfo", $prodinfo);
		
	}

	$smarty->assign("prodid", $prodid);
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
		

	$smarty->assign("Panel", $Panel);

	$smarty->display("productaddons/manage-paddon.tpl");

} // end edit ng price



if(!isset($mode) || isset($mode) && !$mode) { 

	$pinfo=array();
	$info = sql_query($safesql->query("SELECT * FROM paddontype WHERE prodid ='%i';", array($prodid))) or die(mysql_error());
	while($pinf = mysql_fetch_assoc($info))$pinfo[]=$pinf;
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
		

	$smarty->assign("Panel", $pinfo);
	$smarty->assign("pinfo", $pinfo);
	$smarty->assign("prodid", $prodid);

	$smarty->display("productaddons/manage-ptype.tpl");

} // end edit ng price


require_once(path.'/includes/core/editable/footer.inc.php');

?>