<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "view";

$GameCP->CheckPermissions('products');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled.");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license.");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

if(!isset($_REQUEST['mode'])) $mode="";
if(!isset($_REQUEST['offset'])) $offset="";
if(!isset($_REQUEST['gmid'])) $gmid="";
if(!isset($_REQUEST['sortQ'])) $sortQ="";
if(!isset($_REQUEST['cQuery'])) $cQuery="";
if(!isset($_REQUEST['ALTQUERY'])) $ALTQUERY="";
if(!isset($_REQUEST['gid'])) $_REQUEST['gid']="";
if(!isset($_REQUEST['sortWay'])) $sortWay="";
if(!isset($_REQUEST['sortField'])) $sortField="";
if(!isset($_REQUEST['updateid'])) $updateid="";
if(!isset($_REQUEST['newSort'])) $newSort="";
if(!isset($_REQUEST['ioffset'])) $ioffset="";
if(!isset($_REQUEST['view'])) $view="";

if(isset($_REQUEST['pid'])) {
	$_REQUEST['pid']=$GameCP->whitelist($_REQUEST['pid'], 'int');
	$pid=$_REQUEST['pid'];
}

if(!$gmid && $mode == "newproduct") $mode="new"; 

if($mode == "mass"){
	if(DEMO == "yes") die("Demo restricted.<br>");
	if(!$_REQUEST['scimode'] && $_REQUEST['scimode2']) $_REQUEST['scimode']=$_REQUEST['scimode2'];
	if($_REQUEST['scimode'] == "remove"){
		foreach($_POST['users'] as $pid0 => $pid2) { 
			if($pid0) sql_query($safesql->query("DELETE FROM prices WHERE id='%i'", array($pid0))) or die(mysql_error());
		}

	}
	$mode = "view";
}

if ($mode == "remove") {
	sql_query($safesql->query("DELETE FROM prices WHERE id='%i'", array($pid))) or die(mysql_error());
	$pid=$prodid;
	$_REQUEST['pid']=$pid;
	$mode = "view";
}

if ($mode == "removepackage") {
	sql_query($safesql->query("DELETE FROM packages WHERE id='%i'", array($pid))) or die(mysql_error());
	sql_query($safesql->query("DELETE FROM prices WHERE pid='%i'", array($pid))) or die(mysql_error());
	$mode = "viewpackages";
}

if ($mode == "update") { 
	sql_query($safesql->query("UPDATE prices SET
								rank='%s',
								rate='%s', 
								name='%s',
								cost='%s',
								fee='%s', 
								quarterly = '%s',
								semiannualy = '%s',
								annauly = '%s', 
								2years = '%s', 
								type = '%s',
								slots='%s', 
								description='%s'
							WHERE id='%i'", 
								array($rank,$grate, $gname,$gcost,$gfee,$quarterly, $semiannualy,$annauly,$twoyears, $pubpriv, $slots, $gdescription,$pid   )
							)) or die(mysql_error());
	$smarty->assign("showSaved", "true");
	if(debugging == "0"){
		$mode = "editprice";
	} else echo "Saved";
}

if ($mode == "updatepackage") { 
	if(!$pactive) $pactive="0";
	sql_query($safesql->query("UPDATE packages SET
								name='%s', 
								active='%s', 
								gid='%s', 
								img='%s', 
								description='%s',
								category='%i',
								eid='%i',
								tax='%i',
								addontax='%i',
								module='%s'
							WHERE id='%i'", 
								array($gname, $pactive, $gmid, $gimage, $gdescription, $category, $eid, $ptax, $paddontax, $module, $pid)
							)) or die(mysql_error());

	if($module !='' && isset($_REQUEST['modsetting']) && is_array($_REQUEST['modsetting'])){
		$GameCP->loadIncludes("modules");
		$Modules=new Modules($module);
		$Modules->SetProduct($pid);
		$Modules->SetConfigOptions($_REQUEST['modsetting']);
	}

	$smarty->assign("showSaved", "true");
	if(debugging == "0"){
		$mode = "viewpackages";
	} else echo "Saved";
}



if ($mode == "add") {
	/* min/max slots */
	if(!isset($maps)) $maps='0';
	if(!isset($mips)) $mips='0';
	

	if(!$fvoice && isset($gid)){
		sql_query($safesql->query("INSERT INTO packages SET name='%s', gid='%i'", array($gname, $gid))) or die(mysql_error());
		$pid = mysql_insert_id();
	} else { 

		$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1000' LIMIT 1;");
		$addPackage=mysql_num_rows($addPackageQ);

		if($fvoice == "teamspeak"){ 
			$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1000' LIMIT 1;");
			$fvoice = "Teamspeak"; 
			$fid="1000";
		}
		if($fvoice == "teamspeak3"){ 
			$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1002' LIMIT 1;");
			$fvoice = "Teamspeak3"; 
			$fid="1002";
		}
		if($fvoice == "ventrilo"){ 
			$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1001' LIMIT 1;");
			$fvoice = "Ventrilo"; 
			$fid="1001";
		}


		if($fvoice == "mohawk"){ 
			$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1003' LIMIT 1;");
			$fvoice = "Mohawk"; 
			$fid="1003";
		}
		if($fvoice == "mumble"){ 
			$addPackageQ=sql_query("SELECT id FROM packages WHERE gid='1004' LIMIT 1;");
			$fvoice = "Mumble"; 
			$fid="1004";
		}


		$addPackage=mysql_num_rows($addPackageQ);
		if($addPackage == "0"){ 
			sql_query($safesql->query("INSERT INTO packages SET name='%s', gid='%i'", array($gname, $fid))) or die(mysql_error());
			$pid = mysql_insert_id();
		} else {
			$pidQ = sql_query($safesql->query("SELECT id FROM packages WHERE gid = '%i' LIMIT 1", array($fid))) or die(mysql_error());
			$pid = mysql_fetch_array($pidQ); $pid = $pid[0];
		}
	}

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();

	$x=$mips;
	$i=1;

	$cps=$Panel->RemFormatNumber($cps);
	$qcps=$Panel->RemFormatNumber($qcps);
	$semiannauly=$Panel->RemFormatNumber($semiannauly);
	$annauly=$Panel->RemFormatNumber($annauly);
	$twoyear=$Panel->RemFormatNumber($twoyear);

	$pcps=$Panel->RemFormatNumber($pcps);
	$pqcps=$Panel->RemFormatNumber($pqcps);
	$psemiannauly=$Panel->RemFormatNumber($psemiannauly);
	$pannauly=$Panel->RemFormatNumber($pannauly);
	$ptwoyear=$Panel->RemFormatNumber($ptwoyear);

	while ($x <= $maps){ 

		// Public
		if($cps >0) $totalCost=$cps * $x;
		if($qcps >0) $quartCost=$qcps * $x * 3;
		if($semiannauly >0) $semiCost=$semiannauly * $x * 6;
		if($annauly >0) $annualCost=$annauly * $x * 12;
		if($twoyear >0) $twoyearCost=$twoyear * $x * 24;

		if($cps == "0.00") $totalCost="0.00";
		if($qcps == "0.00") $quartCost="0.00";
		if($semiannauly == "0.00") $semiCost="0.00";
		if($annauly == "0.00") $annualCost="0.00";
		if($twoyear == "0.00") $twoyearCost="0.00";

		// Private
		if($pcps >0) $ptotalCost=$pcps * $x;
		if($pqcps >0) $pquartCost=$pqcps * $x * 3;
		if($psemiannauly >0) $psemiCost=$psemiannauly * $x * 6;
		if($pannauly >0) $pannualCost=$pannauly * $x * 12;
		if($ptwoyear >0) $ptwoyearCost=$ptwoyear * $x * 24;

		if($pcps == "0.00") $ptotalCost="0.00";
		if($pqcps == "0.00") $pquartCost="0.00";
		if($psemiannauly == "0.00") $psemiCost="0.00";
		if($pannauly == "0.00") $pannualCost="0.00";
		if($ptwoyear == "0.00") $ptwoyearCost="0.00";

		// Round the product prices 
		if($roundfinal == "yes"){ 
			// Public
			if($totalCost) $totalCost=round($totalCost); 
			if($quartCost) $quartCost=round($quartCost); 
			if($semiCost) $semiCost=round($semiCost); 
			if($annualCost) $annualCost=round($annualCost); 
			if($twoyearCost) $twoyearCost=round($twoyearCost); 

			// Private
			if($ptotalCost) $ptotalCost=round($ptotalCost); 
			if($pquartCost) $pquartCost=round($pquartCost); 
			if($psemiCost) $psemiCost=round($psemiCost); 
			if($pannualCost) $pannualCost=round($pannualCost); 
			if($ptwoyearCost) $ptwoyearCost=round($ptwoyearCost); 
		}

		// Public
		if(isset($totalCost)) $totalCost=$Panel->FormatNumber($totalCost);
		if(isset($quartCost)) $quartCost=$Panel->FormatNumber($quartCost);
		if(isset($semiCost)) $semiCost=$Panel->FormatNumber($semiCost);
		if(isset($annualCost)) $annualCost=$Panel->FormatNumber($annualCost);
		if(isset($twoyearCost)) $twoyearCost=$Panel->FormatNumber($twoyearCost);

		// Private
		if(isset($ptotalCost)) $ptotalCost=$Panel->FormatNumber($ptotalCost);
		if(isset($pquartCost)) $pquartCost=$Panel->FormatNumber($pquartCost);
		if(isset($psemiCost)) $psemiCost=$Panel->FormatNumber($psemiCost);
		if(isset($pannualCost)) $pannualCost=$Panel->FormatNumber($pannualCost);
		if(isset($ptwoyearCost)) $ptwoyearCost=$Panel->FormatNumber($ptwoyearCost);

		if(($x - (2 * floor($x/2))) == 0 || $countodd == "yes"){
			if($totalCost || $quartCost || $semiCost || $annualCost || $twoyearCost) sql_query($safesql->query("INSERT INTO prices SET 
						`rank`='%s', 
						name='%s', 
						cost='%s', 
						fee='%s', 
						quarterly = '%s' ,
						semiannualy = '%s' , 
						annauly = '%s' , 
						2years = '%s',
						type = 'Public', 
						slots='%s', 
						pid='%s', 
						rate='%s'", array($i, "$x Slot Public Server",$totalCost,$fee,$quartCost,$semiCost,$annualCost,$twoyearCost,$x,$pid,$frate))) or die(mysql_error());

			/* insert privates */
			if($pcps || $pqcps || $psemiannauly || $pannauly || $ptwoyear) sql_query($safesql->query("INSERT INTO prices SET 
					`rank`='%s', 
					name='%s', 
					cost='%s', 
					fee='%s', 
					quarterly = '%s' ,
					semiannualy = '%s' ,
					annauly = '%s' ,
					2years = '%s',
					type = 'Private', 
					slots='%s',
					pid='%s',
					rate='%s'", array($i, "$x Slot Private Server",$ptotalCost,$pfee,$pquartCost,$psemiCost,$pannualCost,$ptwoyearCost,$x,$pid,$prate))) or die(mysql_error());
			
			$i++;
		} 
	$x++;
	}


	$smarty->assign("showSaved", "true");
	$_REQUEST['pid']=$pid;

	if(debugging == "0"){
		$mode = "view";
	} else echo "Saved";

}

if ($mode == "addpriceQ") {
	if(!$slots) $slots='0'; 

	if(DIRECTORY_SEPARATOR != '\\'){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		if($gcost) $gcost=$Panel->FormatNumber($gcost);
		if($gfee) $gfee=$Panel->FormatNumber($gfee);
		if($quarterly) $quarterly=$Panel->FormatNumber($quarterly);
		if($semiannualy) $semiannualy=$Panel->FormatNumber($semiannualy);
		if($annauly) $annauly=$Panel->FormatNumber($annauly);
		if($twoyears) $twoyears=$Panel->FormatNumber($twoyears);
	}

	sql_query($safesql->query("INSERT INTO prices  SET
		name='%s',
		cost='%s',
		rate='%s',
		fee='%s',
		quarterly = '%s' ,
		semiannualy = '%s' ,
		annauly = '%s' ,
		2years = '%s',
		type = '%s', 
		slots='%s', 
		pid='%s'", array($gname,$gcost,$grate,$gfee,$quarterly,$semiannualy,$annauly,$twoyears,$pubpriv,$slots,$pid))) or die(mysql_error());

	$smarty->assign("showSaved", "true");
	if(debugging == "0"){
		$mode = "view";
	} else echo "Saved";
}

if($mode == "editprice") { 
	$info = sql_query($safesql->query("SELECT UP.cost, UP.fee, UP.name, P.name, UP.quarterly, UP.semiannualy, UP.annauly, UP.2years, UP.type, UP.slots, UP.rate, UP.rank, P.id as 'opid', UP.id as 'pid', UP.description FROM packages P, prices UP WHERE P.id = UP.pid AND UP.id ='%i' LIMIT 1;", array($pid))) or die(mysql_error());
	$pinfo = mysql_fetch_row($info);

	$smarty->assign("pinfo", $pinfo);
	$smarty->assign("pid", $pid);

	$smarty->display("manageproducts/edit-price.tpl");
}

if($mode == "editpackage") {

	$info = sql_query($safesql->query("SELECT * FROM packages WHERE id ='%i' LIMIT 1;", array($pid))) or die(mysql_error());
	$pinfo = mysql_fetch_array($info);

	$smarty->assign("pinfo", $pinfo);
	$smarty->assign("pid", $pid);


	$gamelist="";
	$game = sql_query("SELECT id, name FROM game WHERE name != '' ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($game)) {
		if($pinfo[2] == $row['id']){
			$gamelist.= "<option value=\"". $row['id'] ."\" selected=selected>". $row['name'];
		} else $gamelist.= "<option value=\"". $row['id'] ."\">". $row['name'];
	}
	$smarty->assign("gamelist", $gamelist);


	$catlist="";
	$game = sql_query("SELECT id, name FROM categories WHERE name != '' ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($game)) {
		if($pinfo['category'] == $row['id']){
			$catlist.= "<option value=\"". $row['id'] ."\" selected=selected>". $row['name'];
		} else $catlist.= "<option value=\"". $row['id'] ."\">". $row['name'];
	}
	$smarty->assign("catlist", $catlist);

	$result = sql_query("SELECT * FROM emails ORDER BY title") or die(mysql_error());
	$list = array();
	while ($row = mysql_fetch_array($result)){
		$list[] = $row;
	}
	$smarty->assign("emails",$list);


	$GameCP->loadIncludes("modules");
	$Modules=new Modules($pinfo['module']);

	$smarty->assign("module_list", $Modules->GetModules());
	
	$Modules->SetProduct($pid);
	$smarty->assign("modsettings", $Modules->GetConfigOptions());



	$smarty->display("manageproducts/edit-package.tpl");

} 

if($mode =="new"){ 

	$gamelist="";
	$game = sql_query("SELECT id, name FROM game WHERE name != '' ORDER BY 'name'") or die(mysql_error());

	while ($row = mysql_fetch_array($game)) {
		$gamelist.= "<option value=\"". $row['id'] ."\">". $row['name'];
	}

	$smarty->assign("gamelist", $gamelist);

	$smarty->display("manageproducts/product-new1.tpl");

} 


if($mode =="newproduct"){ 
	$gid = $gmid;
	$gameId='';

	switch($gmid){
		case "nogame":
			$gameName="";
			$gameId="";
		break;

		case "1000":
			$gameName="Teamspeak";
			$gameId="1000";
		break;


		case "1001":
			$gameName="Ventrilo";
			$gameId="1001";
		break;
		case "1003":
			$gameName="Mohawk";
			$gameId="1003";
		break;
		case "1004":
			$gameName="Mumble";
			$gameId="1004";
		break;

		default:
			$game = sql_query($safesql->query("SELECT id, name FROM game WHERE id = '%i' LIMIT 1;", array($gmid))) or die(mysql_error());
			$game = mysql_fetch_row($game); 
			$gameName = $game[1];
			$gameId=$game[0];
		break;	
	}

	$smarty->assign("gameid", $gameId);
	$smarty->assign("gameName", $gameName);
	$smarty->assign("gmid", $gmid);

	$smarty->display("manageproducts/product-new2.tpl");

} 

if($mode =="addprice"){ 

	$prodlist="";
	$game = sql_query("SELECT id, name FROM packages ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($game)) {
		$prodlist.= "<option value=\"". $row['id'] ."\">". $row['name'];
	}

	$smarty->assign("prodlist", $prodlist);
	$smarty->display("manageproducts/add-price.tpl");
} 



if($mode =="newprice"){ 

	$game = sql_query($safesql->query("SELECT name, id FROM packages WHERE id = '%i' LIMIT 1;", array($gmid))) or die(mysql_error());
	$game = mysql_fetch_row($game); $gameName = $game[0];
						
	$smarty->assign("gameName", $gameName);
	$smarty->assign("pid", $game[1]);

	$smarty->display("manageproducts/new-price.tpl");
				
} 

if($mode == "reorder"){
	if($myid && $newid){

		$newRankQ = sql_query($safesql->query("SELECT rank FROM prices WHERE id = '%i' LIMIT 1;", array($newid))) or die(mysql_error());
		$newRank = mysql_fetch_row($newRankQ); $newRank = $newRank[0];

		$myRankQ = sql_query($safesql->query("SELECT rank FROM prices WHERE id = '%i' LIMIT 1;", array($myid))) or die(mysql_error());
		$myRank = mysql_fetch_row($myRankQ); $myRank = $myRank[0];

		sql_query($safesql->query("UPDATE prices SET rank='%i' WHERE id='%i'", array($myRank, $newid))) or die(mysql_error());
		sql_query($safesql->query("UPDATE prices SET rank='%i' WHERE id='%i'", array($newRank, $myid))) or die(mysql_error());

	}

	$mode = "view";
}

if($mode == "view"){ 
	if($pid) { $query = "WHERE pid = '".$GameCP->whitelist($pid, 'int') ."'"; } else $query='';
	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM  prices $query ORDER BY rank";
	$result=Smarty_PageControl($sql, "prodlist", "prodlist");

	$products=array();
	while ($row = mysql_fetch_array($result)) $products[]=$row;
	

	$smarty->clearAssign("products");
	$smarty->assign("products", $products);
	$smarty->assign("pid", $pid);

	$smarty->display("manageproducts/view-products.tpl");
}


if($mode =="viewpackages"){ 
	if(isset($_REQUEST['searchcontent'])){
		$searchq= $safesql->query(" WHERE name LIKE '%%s%'",array($_REQUEST['searchcontent']));
	} else $searchq='';
	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM packages $searchq ORDER BY name";
	$result=Smarty_PageControl($sql, "packagelist", "packagelist");

	$packages=array();
	while ($row = mysql_fetch_array($result)) {
		$pricesQ = sql_query("SELECT COUNT(*) FROM  prices WHERE pid = '".$row['id']."'") or die(mysql_error());
		$prices = mysql_fetch_row($pricesQ);

		$row['prices']=$prices[0];
		$packages[]=$row;
	}

	$smarty->assign("packages", $packages);
	$smarty->display("manageproducts/view-packages.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>