<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('promotions');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (promo)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (promo)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

if ($mode == "update" && DEMO != "yes") { 
	if(!$totaluses) $totaluses="0";
	if(!isset($oneperuser)) $oneperuser="0";
	if(!isset($existinguser)) $existinguser="0";
	if(!isset($newuser)) $newuser="0";
	if(!isset($active)) $active="0";
	if(!isset($recurring)) $recurring="0";
	if(!isset($_REQUEST['locations'])) $_REQUEST['locations']=array();
	if(!isset($_REQUEST['products'])) $_REQUEST['products']=array();
	$products=serialize($_REQUEST['products']);
	$locations=serialize($_REQUEST['locations']);
	sql_query($safesql->query("UPDATE promotions SET 
					active='%s',
					name='%s',
					expire='%s',
					value='%s',
					type='%s',
					totaluses='%s',
					oneperuser='%s',
					existinguser='%s',
					newuser='%s',
					products='%s',
					recurring='%s',
					location='%s'
				WHERE id='%i'", array(
					$GameCP->whitelist($active, "clean"),	
					$GameCP->whitelist($code, "clean"),	
					$GameCP->whitelist($expire, "clean"),	
					$GameCP->whitelist($value, "clean"),	
					$GameCP->whitelist($type, "clean"),	
					$GameCP->whitelist($totaluses, "clean"),	
					$GameCP->whitelist($oneperuser, "clean"),	
					$GameCP->whitelist($existinguser, "clean"),	
					$GameCP->whitelist($newuser, "clean"),	
					$GameCP->whitelist($products, "clean"),	
					$GameCP->whitelist($recurring, "clean"),	
					$GameCP->whitelist($locations, "clean"),
					$GameCP->whitelist($pid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "add" && DEMO != "yes") {
	if(!$totaluses) $totaluses="0";
	if(!isset($oneperuser)) $oneperuser="0";
	if(!isset($existinguser)) $existinguser="0";
	if(!isset($newuser)) $newuser="0";
	if(!isset($active)) $active="0";
	if(!isset($recurring)) $recurring="0";
	if(!isset($products)) $products=array();
	$products=serialize($products);
	$locations=serialize($locations);

	sql_query($safesql->query("INSERT INTO promotions SET 
					active='%s',
					name='%s',
					expire='%s',
					value='%s',
					type='%s',
					totaluses='%s',
					oneperuser='%s',
					existinguser='%s',
					newuser='%s',
					products='%s',
					recurring='%s',
					location='%s'", array(
					$GameCP->whitelist($active, "clean"),	
					$GameCP->whitelist($code, "clean"),	
					$GameCP->whitelist($expire, "clean"),	
					$GameCP->whitelist($value, "clean"),	
					$GameCP->whitelist($type, "clean"),	
					$GameCP->whitelist($totaluses, "clean"),	
					$GameCP->whitelist($oneperuser, "clean"),	
					$GameCP->whitelist($existinguser, "clean"),	
					$GameCP->whitelist($newuser, "clean"),	
					$GameCP->whitelist($products, "clean"),	
					$GameCP->whitelist($recurring, "clean"),	
					$GameCP->whitelist($locations, "clean")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "remove" && DEMO != "yes") {
	sql_query($safesql->query("DELETE FROM promotions WHERE id='%i' LIMIT 1", array($GameCP->whitelist($pid, "int")))) or die(mysql_error());
	sql_query($safesql->query("DELETE FROM promotionsuse WHERE pmid ='%i'", array($GameCP->whitelist($pid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	$mode = "edit";

}


if($mode == "edit") { 
	$promotions=array();
	$result = sql_query("SELECT * FROM promotions ORDER BY 'name'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){
		$uses = sql_query("SELECT * FROM promotionsuse WHERE pmid ='".$row['id']."'") or die(mysql_error());
		$row['uses']=mysql_num_rows($uses);
		$promotions[]=$row;
	} 
	$smarty->assign("promoList",$promotions);
	$smarty->display("promotions/promo-list.tpl");


} // end edit ng price

if($mode == "edit2") {



	$info = sql_query($safesql->query("SELECT * FROM promotions WHERE id = '%i' LIMIT 1", array($GameCP->whitelist($pid, "int")))) or die(mysql_error());
	$promoInfo = mysql_fetch_array($info);

	$currentproducts=unserialize($promoInfo['products']);
	$currentlocation=unserialize($promoInfo['location']);

	$game = sql_query("SELECT id, name FROM packages LIMIT 1000") or die(mysql_error());
	$products=array();

	while ($row = mysql_fetch_array($game)) {
		if(is_array($currentproducts) && in_array($row['id'], $currentproducts)){
			$sel="true";
		} else $sel="false";
		if($row['name']) $products[]=array('id' => $row['id'], 'name' => $row['name'], 'sel' => $sel);
	}


	$local = sql_query("SELECT DISTINCT(location) as 'name', id FROM servers") or die(mysql_error());
	$locations=array();

	while ($row = mysql_fetch_array($local)) {
		if(is_array($currentlocation) && in_array($row['name'], $currentlocation)){
			$sel="true";
		} else $sel="false";
		$locations[]=array('id' => $row['id'], 'name' => $row['name'], 'sel' => $sel);
			
	}

	$smarty->assign("promoInfo",$promoInfo);
	$smarty->assign("pid",$pid);
	$smarty->assign("products", $products);
	$smarty->assign("locations", $locations);

	$smarty->display("promotions/promo-edit.tpl");

} // end edit ng price

if($mode =="new"){ 
	$currentlocation="";

	$game = sql_query("SELECT id, name FROM packages") or die(mysql_error());
	$i="0";
	$products=array();
	while ($row = mysql_fetch_array($game)) {
		$products[$i]['id']=$row['id'];
		$products[$i]['name']=$row['name'];
		$i++;
			
	}
	$local = sql_query("SELECT DISTINCT(location) as 'name', id FROM servers") or die(mysql_error());
	$locations=array();

	while ($row = mysql_fetch_array($local)) {
		if(is_array($currentlocation) && in_array($row['name'], $currentlocation)){
			$sel="true";
		} else $sel="false";
		$locations[]=array('id' => $row['id'], 'name' => $row['name'], 'sel' => $sel);
			
	}
	$smarty->assign("products", $products);
	$smarty->assign("locations", $locations);

	$smarty->display("promotions/promo-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>