<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('taxes');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (taxes)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (taxes)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}


if ($mode == "update" && DEMO != "yes") { 
	if(!$level) $level="1";
	if(!$active) $active="0";
	if(isset($allcountry) && $allcountry == "1") $country="all";
	if(isset($allcity) && $allcity == "1") $city="all";

	sql_query($safesql->query("UPDATE taxes SET 
					active='%i',
					country='%s',
					city='%s',
					description='%s',
					rate='%s',
					level='%i'
				WHERE id='%i'", array(
					$GameCP->whitelist($active, "int"),	
					$GameCP->whitelist($country, "clean"),	
					$GameCP->whitelist($city, "clean"),	
					$GameCP->whitelist($description, "clean"),	
					$GameCP->whitelist($rate, "clean"),
					$GameCP->whitelist($level, "int"),
					$GameCP->whitelist($txid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit2";
	} else echo "Saved";
}

if ($mode == "add" && DEMO != "yes") {
	if(!$level) $level="1";
	if(!$active) $active="0";
	if(isset($allcountry) && $allcountry == "1") $country="all";
	if(isset($allcity) && $allcity == "1") $city="all";

	sql_query($safesql->query("INSERT INTO taxes SET 
					active='%i',
					country='%s',
					city='%s',
					description='%s',
					rate='%s',
					level='%i'", array(
					$GameCP->whitelist($active, "clean"),	
					$GameCP->whitelist($country, "clean"),	
					$GameCP->whitelist($city, "clean"),	
					$GameCP->whitelist($description, "clean"),	
					$GameCP->whitelist($rate, "clean"),	
					$GameCP->whitelist($level, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";

}

if ($mode == "remove" && DEMO != "yes") {
	sql_query($safesql->query("DELETE FROM taxes WHERE id='%i' LIMIT 1", array($GameCP->whitelist($txid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	$mode = "edit";

}


if($mode == "edit") { 
	$taxes=array();
	$result = sql_query("SELECT * FROM taxes ORDER BY 'country'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){
		$taxes[]=$row;
	} 

	$smarty->assign("taxList",$taxes);
	$smarty->display("taxes/tax-list.tpl");


} // end edit ng price

if($mode == "edit2") {



	$info = sql_query($safesql->query("SELECT * FROM taxes WHERE id = '%i' LIMIT 1", array($GameCP->whitelist($txid, "int")))) or die(mysql_error());
	$taxInfo = mysql_fetch_array($info);



	$smarty->assign("taxInfo",$taxInfo);
	$smarty->assign("txid",$txid);

	$smarty->display("taxes/tax-edit.tpl");

} // end edit ng price

if($mode =="new"){ 
	$smarty->display("taxes/tax-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>