<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "view"; 

$GameCP->CheckPermissions('gameupdates');

$smarty->assign('page_title', $LNG_GAMEMANAGEMENT);
 
if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3"){ 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(!isset($_REQUEST['newSort'])) $newSort="";
if(!isset($_REQUEST['searchcontent '])) $searchcontent ="";
if(!isset($_REQUEST['sortG'])) $sortG="";
if(!isset($_REQUEST['view'])) $view="";
if(!isset($_REQUEST['ioffset'])) $ioffset="";
if(!isset($_REQUEST['offset'])) $offset="";
if(!isset($_REQUEST['cQuery'])) $cQuery="";
if(!isset($_REQUEST['sQuery'])) $sQuery="";
if(!isset($_REQUEST['sortS'])) $sortS="";
if(!isset($_REQUEST['iinitial'])) $iinitial="";
if(!isset($_REQUEST['initial'])) $initial="";
if(!isset($_REQUEST['pid'])) $pid="";
if(!isset($_REQUEST['sortWay'])) $sortWay="";
if(!isset($_REQUEST['sortField'])) $sortField="";
if(!isset($_REQUEST['updateid'])) $updateid="";


if(isset($updateid)) $updateid=$GameCP->whitelist($updateid, "int");
if(isset($bid)) $updateid=$GameCP->whitelist($bid, "int");
if(isset($uid)) $updateid=$GameCP->whitelist($uid, "int");

if ($mode == "remove") {
	if(DEMO != "yes") sql_query($safesql->query("DELETE FROM gameupdates WHERE id='%i'", array($GameCP->whitelist($updateid, "int")))) or die(mysql_error());
	$mode="view";
}


if($mode == "addedit"){

	if($updatename == "") die("Please insert a update name.");
	if(!isset($gid)) $gid=array();
	if(!isset($waitreply)) $waitreply ='';

	if($updateid){
		sql_query($safesql->query("UPDATE gameupdates SET 
			name='%s',
			description='%s',
			gid='%s',
			archive='%s',
			`type`='%s',
			`date`='%s',
			`waitreply`='%i',
			command='%s',
			wincommand='%s',
			winrepo='%s',
			linuxrepo='%s',
			steamid='%s',
			steammod='%s',
			syncmasterwin='%i',
			syncmasterlinux='%i'
		WHERE id = '%i'", array(
				$GameCP->whitelist($updatename, "clean"),
				$GameCP->whitelist(@$description, "clean"),
				$GameCP->whitelist(serialize($gid), "clean"),
				$GameCP->whitelist(@$updatearchive, "clean"),
				$GameCP->whitelist(@$updatetype, "clean"),
				$GameCP->whitelist(@$updatedate, "clean"),
				$GameCP->whitelist(@$waitreply, "clean"),
				$GameCP->whitelist(@$command, "clean"),
				$GameCP->whitelist(@$wincommand, "clean"),
				$GameCP->whitelist(@$winrepo, "clean"),
				$GameCP->whitelist(@$linuxrepo, "clean"),
				$GameCP->whitelist(@$steamid, "clean"),
				$GameCP->whitelist(@$steammod, "clean"),
				$GameCP->whitelist(@$syncmasterwin, "int"),
				$GameCP->whitelist(@$syncmasterlinux, "int"),
				$GameCP->whitelist($updateid, "int")))) or die(mysql_error());

	} else {
		if(!isset($gid)) $gid=array();
		sql_query($safesql->query("INSERT INTO gameupdates SET 
			name='%s',
			description='%s',
			gid='%s',
			archive='%s',
			`type`='%s',
			`date`='%s',
			`waitreply`='%i',
			command='%s',
			wincommand='%s'", array(
				$GameCP->whitelist($updatename, "clean"),
				$GameCP->whitelist($description, "clean"),
				$GameCP->whitelist(serialize($gid), "clean"),
				$GameCP->whitelist($updatearchive, "clean"),
				$GameCP->whitelist($updatetype, "clean"),
				$GameCP->whitelist($updatedate, "clean"),
				$GameCP->whitelist($waitreply, "clean"),
				$GameCP->whitelist($command, "clean"),
				$GameCP->whitelist($wincommand, "clean")))) or die(mysql_error());
		$updateid=mysql_insert_id(); 
	}


	$smarty->assign("showSaved", "true");
	$mode="manage";

}



if($mode == "doupdate"){
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$updateData=sql_query($safesql->query("SELECT *, `type` as 'ty' FROM gameupdates WHERE id='%i' LIMIT 1;", array($GameCP->whitelist($updateid, "int")))) or die(mysql_error());
	$updateInfo=mysql_fetch_array($updateData);
	$gidarray=unserialize($updateInfo['gid']);
	$updatetype=$updateInfo['ty'];
	$archive=$updateInfo['archive'];
	$updatecommand=$updateInfo['command'];
	$winupdatecommand=$updateInfo['wincommand'];
	$waitreply=$updateInfo['waitreply'];
	if($waitreply == "0"){
		$waitreply=true;
	} else $waitreply=false;
	$wgeturl=$url."/includes/core/secure/installs/".$archive;

	if($updatetype == "0" || !$updatetype){ 
		$smarty->assign("updatetype", "User Game Update");
		$smarty->display("managegameupdates/managegameupdates-header.tpl");
		$userArray= count($updateusers);

		$dled=array();
		for ($i = 0; $i < $userArray; $i++){
			$uid=$updateusers[$i];
			foreach($gidarray as $g => $gid){
				if($gid){
					$userInfoQ = sql_query($safesql->query("SELECT S.sid, U.name, U.bash, S.os, S.winport, UG.ip, UG.port, UG.id, U.id FROM users U, usergames UG, iptable I, servers S WHERE UG.ip = I.ip AND U.id = UG.cid AND UG.gid='%i' AND U.id='%i' AND I.sid = S.sid", array($GameCP->whitelist($gid, "int"),$GameCP->whitelist($uid, "int")))) or die(mysql_error());
					if(mysql_num_rows($userInfoQ) > 0){ 
						while($userInfo=mysql_fetch_array($userInfoQ)){
							$sid=$userInfo[0];
							$uname=$userInfo[1];
							$bash=$userInfo[2];
							$os=$userInfo['os'];
							$winport=$userInfo[4];
							$ugid=$userInfo[7];
							$userid=$userInfo[8];
							$fpass=$GameCP->Password($userid);
								

							echo "<h3>Updating: " . $uname . " @ " . $sid . "</h3>";

							if($archive && !in_array($sid, $dled)){
								if($os !="1"){
									echo "Downloading $archive to installs folder<br>";
									$Backend->QueryResponse($sid, $winport, "downloadfile:_:$wgeturl:_:\$MAINDIR/installs/$archive");
									$final="\$MAINDIR/installs/$archive";

								} else {
									echo "Downloading $archive to installs folder<br>";
									$Backend->QueryResponse($sid, $winport, "downloadfile:_:$wgeturl:_:\$MAINDIR\installs\\$archive");
									$final="\$MAINDIR\installs\\$archive";
								}
								$dled[]=$sid;
							}

							$updatecommand = str_replace("\$ARCHIVE", $final, $updatecommand);
							$winupdatecommand = str_replace("\$ARCHIVE", $final, $winupdatecommand);

							$GameCP->loadIncludes("game");
							$Game=new Game();

							$reply=$Game->GameCommand('default', $ugid, FALSE, $winupdatecommand, $updatecommand, $waitreply);
							if(!$waitreply) echo "<textarea rows=4 cols=60>". $reply ."</textarea><br>"; 
						}
					}
				}
			}
		}
	} else { 
		$smarty->assign("updatetype", "Machine Game Update");
		$smarty->display("managegameupdates/managegameupdates-header.tpl");
		$ipArray = count($mip);
		$uname="root";
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();

		for ($i = 0; $i < $ipArray; $i++){ 
			$sid=$mip[$i]; 
			$machineInfo=$Panel->GetServer($sid);
			$os=$machineInfo['os'];
			$winport=$machineInfo['winport'];
			$dled=array();

			echo "<b>Updating:</b> " . $sid . "<br>";

			if($archive && !in_array($sid, $dled)){
				if($os !="1"){
					echo "Downloading $archive to installs folder<br>";
					$Backend->QueryResponse($sid, $winport, "downloadfile:_:$wgeturl:_:\$MAINDIR/installs/$archive");
					$final="\$MAINDIR/installs/$archive";
					$command=$updatecommand;

				} else {
					echo "Downloading $archive to installs folder<br>";
					$Backend->QueryResponse($sid, $winport, "downloadfile:_:$wgeturl:_:\$MAINDIR\installs\\$archive");
					$final="\$MAINDIR\installs\\";
					$command=$winupdatecommand;
				}
				$dled[]=$sid;
			}

			if($command){

				$command = str_replace("\$ARCHIVE", $final, $command);
		

				$winscript="gameupdate$uname.bat";
				$script="gameupdate$uname.sh";
				$GameCP->loadIncludes("game");
				$Game=new Game();
				$command = $Game->ReplaceAllVars($ugid, $command);
				$result=$Game->Exec('', $os, $sid, $winport, $script, $winscript, $command, $waitreply);
				if(!$waitreply) echo "<textarea rows=4 cols=60>". $result . "</textarea><br>";
			}
		}

	}
	$smarty->display("managegameupdates/managegameupdates-footer.tpl");
}



if($mode == "manage"){ 
	
	$updateData=sql_query($safesql->query("SELECT * FROM gameupdates WHERE id='%i'", array($GameCP->whitelist($updateid, "int")))) or die(mysql_error());
	$uinfo=mysql_fetch_array($updateData);
	$uinfo['gid']=unserialize($uinfo['gid']);
	if(!is_array($uinfo['gid'])) $uinfo['gid']=array();

	$smarty->assign("updateInfo",$uinfo);

	$resultClient = sql_query("SELECT id, name FROM gameupdates ORDER BY 'name'") or die(mysql_error());
	$list = array();
	while ($row = mysql_fetch_array($resultClient))
		$list[] = $row;
	$smarty->assign("updates",$list);

	$resultClient = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
	$list = array();
	while ($row = mysql_fetch_array($resultClient)) $list[] = $row;
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	$smarty->assign("games",$list);
	$smarty->assign("themes",$Panel->GetDirContents(path."/includes/core/secure/installs", true));
	$smarty->assign("updateid",$updateid);
	$smarty->assign("today",date(dateformat, time()));
	$smarty->assign("maindir",path);
	

	$smarty->display("managegameupdates/managegameupdates-manage.tpl");

} elseif($mode == "run"){ 


	$updateData=sql_query($safesql->query("SELECT * FROM gameupdates WHERE id='%i'", array($GameCP->whitelist($updateid, "int")))) or die(mysql_error());
	$updateInfo=mysql_fetch_array($updateData);
	$smarty->assign("updateInfo",$updateInfo);
	$smarty->assign("updatetype",$updateInfo['type']);
	$gid=unserialize($updateInfo['gid']);

	if(is_array($gid) && count($gid) > 0){
		$resultClient = sql_query($safesql->query("SELECT distinct(U.id), U.name FROM users U, usergames UG WHERE U.id = UG.cid AND UG.gid IN ('%s')", array(join(',',$gid)))) or die(mysql_error());
		$list = array();
		while ($row = mysql_fetch_array($resultClient)) $list[] = $row;
		$smarty->assign("users",$list);
	}

	$serverNameQ = sql_query("SELECT sid FROM servers") or die(mysql_error());
	$list = array();
	while ($serverName = mysql_fetch_array($serverNameQ)){
		$list[] = $serverName;
	}
	$smarty->assign("servers",$list);

	$smarty->display("managegameupdates/managegameupdates-run.tpl");



} elseif($mode == "view") { 

	$sql="SELECT SQL_CALC_FOUND_ROWS 
	GU.*, G.name as 'gname',
	GU.name as 'guname',
	GU.date 
	
	FROM gameupdates GU, game G 
	WHERE G.id = GU.gid 
	";




	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM gameupdates";
	$result=Smarty_PageControl($sql, "gameupdate", "gameupdate");

	$packageArray[]=array();
	$i=0;
	while ($rowPackageDetails= mysql_fetch_array($result)){
		if($rowPackageDetails){
			$packageArray[$i]=$rowPackageDetails;
			$rowPackageDetails['gid']=unserialize($rowPackageDetails['gid']);
			if(count($rowPackageDetails['gid']) > 0){
				$gameInfoQ=sql_query($safesql->query("SELECT name FROM game WHERE id IN (%s);", array(join(',', $rowPackageDetails['gid']))));
				if(mysql_num_rows($gameInfoQ) == 0){
					$packageArray[$i]['gname']="No Game";
				} else {
					while($gameInfo=mysql_fetch_array($gameInfoQ)){
						$gameName=$gameInfo['name'];
						if($gameName){
							if(!isset($packageArray[$i]['gname'])) $packageArray[$i]['gname']="";
							$packageArray[$i]['gname']=$packageArray[$i]['gname'].", ".$gameName;
						}
					}
					$packageArray[$i]['gname']=ltrim($packageArray[$i]['gname'], ", ");
				}
			} else $packageArray[$i]['gname']="No Game";
			$i++;
		}
	}

	$smarty->assign("games", $packageArray);
	$smarty->assign("totalRecords",mysql_num_rows($result));


	$smarty->display("managegameupdates/managegameupdates-view.tpl");
}



require_once(path.'/includes/core/editable/footer.inc.php');

?>