<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
$GameCP->CheckPermissions('newmachine');

$smarty->assign('page_title', $LNG_MACHINE_MANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();


if ($mode == "multipleip"){
	function checkRowA($table, $col, $col2, $val, $val2){
		$checkQ=sql_query($safesql->query("SELECT * FROM `%s` WHERE `%s`='%s'", array($table, $col2, $val2))) or die(mysql_error());
		$chk=mysql_num_rows($checkQ);
		if($chk >= "1") return "0";
	}
	foreach($_POST['ipgen'] as $gid => $sci) { 
		$ip = str_replace(' ', '', $sci);
		if(checkRowA("iptable", "sid", "ip", $fsid, $ip) != "0")  {
			$ret.= "Inserting ip: " . $ip . "<br>";
			sql_query($safesql->query("INSERT INTO iptable SET sid='%s', ip='%s', useinternal='0'", array($GameCP->whitelist($fsid, "clean"),$GameCP->whitelist($ip, "clean")))) or die(mysql_error());
		} else $ret.= $ip . " already added<br>";
	}
	

	$smarty->assign("fsid", $fsid); 
	$smarty->assign("ret", $ret); 
	
	$smarty->display("managemachines/new-addip.tpl");
}

if($mode == "add") {

	if(!gcplickey){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit('No license found. Please register this software.');
	}

	$GameCP->loadIncludes("backend");
	$Backend=new Backend();

	if($distro == "4"){
		$distro="0";
		$_REQUEST['distro']="0";
		$smarty->assign("ubuntu",true);
	}

	if(!isset($msshport)) $msshport ='22';
	if(!isset($mftpport)) $mftpport ='21';

	$install=$Backend->Install($mip, $distro, $mname, $mlocation, $mcost, $slotquota, $mquota, $msshport, $mftpport, $malias, $mts2, $mvent, $winport);
	if(!is_array($install))	$smarty->assign("error", $_SESSION['gamecp']['error']);
	$smarty->assign("passphrase",$install[1]);
	$smarty->assign("newid",$install[0]);
	$smarty->assign("msid",$mip);
	$smarty->assign("winport",$winport);

	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$lic_api=$Backend->QueryResponse($mip, '', "lic_addip:_:");

	if(isset($_SESSION['gamecp']['nav_control'])) unset($_SESSION['gamecp']['nav_control']);

	$smarty->display("managemachines/new-completed.tpl");
} // end add


if($mode == "new") {
	
	if(!gcplickey){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit('No license found. Please register this software.');
	}

	$machineTotal = sql_query("SELECT * FROM `servers` WHERE os = '1'") or die(mysql_error());
	$winMachineTotal = mysql_num_rows($machineTotal);

	$machineTotal = sql_query("SELECT * FROM `servers` WHERE os != '1'") or die(mysql_error());
	$machineTotal = mysql_num_rows($machineTotal);
	
	if($_SESSION['gamecp']['count'][0] > $winMachineTotal){
		$allowWin=true;
	} else $allowWin=false;

	if($_SESSION['gamecp']['count'][1] > $machineTotal){
		$allowLin=true;
	} else $allowLin=false;

	$smarty->assign("allowWin", $allowWin); 
	$smarty->assign("allowLin",$allowLin); 


	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	if($allowLin == false && $allowWin == false) $Panel->ErrorExit('You have reached your machine limit, please upgrade your license.');

	$smarty->display("managemachines/new-add.tpl");
} // end if mode = new

require_once(path.'/includes/core/editable/footer.inc.php');

?>