<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('news');

$smarty->assign('page_title', $LNG_NEWSMANAGEMENT);

if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3" && $_SESSION['gamecp']['userinfo']['ulevel'] != "4") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();


if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
	$rsidQ=" AND rsid='".$_SESSION['gamecp']['userinfo']['id']."'";
} else $rsidQ="";


if ($mode == "remove" && DEMO != "yes") {
	sql_query($safesql->query("DELETE FROM news WHERE id='%i' $rsidQ LIMIT 1", array($nid))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	$mode = "edit";
}

if ($mode == "update" && DEMO != "yes") { 
	if(!$_REQUEST['gid'])$gid="0";
	if(!$fulevel) $fulevel="0";

	sql_query($safesql->query("UPDATE news SET name='%s', content='%s', gid='%s', sid='%s', ulevel='%s' WHERE id='%i' $rsidQ", array($title, $GameCP->whitelist($content, 'web'), $gid, $fsid, $fulevel, $nid))) or die(mysql_error());

	if(!isset($noheader)){
		$smarty->assign("showSaved", true);
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "add" && DEMO != "yes") {
	if(!$gid)$gid="0";
	if(!$fulevel) $fulevel="0";

	sql_query($safesql->query("INSERT INTO  news SET name='%s', content='%s', gid='%s', sid='%s', ulevel='%s', rsid='".$_SESSION['gamecp']['userinfo']['id']."' ", array($title, $GameCP->whitelist($content, 'web'), $gid, $fsid, $fulevel))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}



if($mode == "edit") { 
	$newsList=array();
	$result = sql_query($safesql->query("SELECT * FROM news WHERE 1 $rsidQ ORDER BY 'name'", array())) or die(mysql_error());

	while ($row = mysql_fetch_array($result)){
			$newsList[]=$row;
	}

	$smarty->assign("newsList",$newsList);
	$smarty->display("managenews/managenews-list.tpl");
}


if($mode == "edit2") { 

	$info = sql_query($safesql->query("SELECT * FROM news WHERE id = '%i' $rsidQ LIMIT 1;", array($nid))) or die(mysql_error());
	$ninfo = mysql_fetch_array($info);

	$fsid=$ninfo['sid'];
	$gid=$ninfo['gid'];

	/* lazy ass */
	$gameListQuery="";
	 $result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			if($row['id'] == $gid){ $SEL="SELECTED"; } else $SEL="";
			$gameListQuery.="<option value=\"". $row['id'] ."\" $SEL>". $row['name']."</option>";
		}

	$machineListQuery="";

	 $result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			if($row['sid'] == $fsid){ $SEL2="SELECTED"; } else $SEL2="";
			$machineListQuery.="<option value=\"". $row['sid'] ."\" $SEL2>". $row['name']."</option>"; 
		}


	$smarty->assign("fsid",$fsid);
	$smarty->assign("machineList",$machineListQuery);
	$smarty->assign("gameList",$gameListQuery);

	$smarty->assign("nid",$nid);
	$smarty->assign("newsTitle",$ninfo['name']);
	$smarty->assign("newsContent",$ninfo['content']);
	$smarty->assign("fulevel",$ninfo['ulevel']);

	$smarty->display("managenews/news-edit.tpl");

} // end edit ng price

if($mode =="new"){ 

	/* lazy ass */
	$gameListQuery="";
	$machineListQuery="";
	 $result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			$gameListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";
		}

	 $result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			$machineListQuery.="<option value=\"". $row['sid'] ."\">". $row['name']."</option>"; 
		}

	$smarty->assign("machineList",$machineListQuery);
	$smarty->assign("gameList",$gameListQuery);

	$smarty->display("managenews/news-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>