<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($_REQUEST['mode']) || isset($_REQUEST['mode']) && !$_REQUEST['mode']) $_REQUEST['mode'] = "edit";

$GameCP->CheckPermissions('orders');

$smarty->assign('page_title', $LNG_QUEUE_MANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if($_REQUEST['mode'] == "run") {
	if(isset($_REQUEST['qid'])){
		$smarty->assign("qid", $_REQUEST['qid']);
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ExecQueue($_REQUEST['qid'], false, true);
		$_REQUEST['mode']="edit2";
	}
}


if ($_REQUEST['mode'] == "reset") {
	sql_query("UPDATE settings SET value='0' WHERE name='zqueue'");
	echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/manage/orders.php?mode=edit\">"; 
}

if ($_REQUEST['mode'] == "remove") {
	sql_query($safesql->query("DELETE FROM queue WHERE id='%s'", array($GameCP->whitelist($_REQUEST['qid'], "int"))));
	echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/manage/orders.php?mode=edit\">"; 
}

if ($_REQUEST['mode'] == "pending") {
	$result = sql_query($safesql->query("SELECT result, `status`, `mod`, fraudcheck FROM queue WHERE id='%i' LIMIT 1;", array($GameCP->whitelist($_REQUEST['qid'], "int")))) or die(mysql_error());
	$queueResult = mysql_fetch_row($result);
	$status=$queueResult[1];
	$mod=unserialize($queueResult[2]);
	$mod['status']='Pending';
	$mod=serialize($mod);
	sql_query($safesql->query("UPDATE queue SET `mod`='%s', `status`='0' WHERE id='%s'", array($mod, $GameCP->whitelist($_REQUEST['qid'], "int"))));
	$_REQUEST['mode']='edit2';
}

if ($_REQUEST['mode'] == "fraud") {
	sql_query($safesql->query("UPDATE queue SET `status`='4' WHERE id='%s'", array($GameCP->whitelist($_REQUEST['qid'], "int"))));
	$_REQUEST['mode']='edit2';
}

if ($_REQUEST['mode'] == "paid") {
	$result = sql_query($safesql->query("SELECT result, `status`, `mod`, fraudcheck FROM queue WHERE id='%i' LIMIT 1;", array($GameCP->whitelist($_REQUEST['qid'], "int")))) or die(mysql_error());
	$queueResult = mysql_fetch_row($result);
	$status=$queueResult[1];
	$mod=unserialize($queueResult[2]);
	$mod['status']='Completed';
	$mod['transactionid']='approval'.time();
	$mod=serialize($mod);
	sql_query($safesql->query("UPDATE queue SET `mod`='%s' WHERE id='%s'", array($mod, $GameCP->whitelist($_REQUEST['qid'], "int"))));
	$_REQUEST['mode']='edit2';
}

if($_REQUEST['mode'] == "edit") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$smarty->assign("Panel",$Panel);


	if(isset($_REQUEST['mini'])){
		$smarty->assign("queueRecent",$Panel->QueueList("3", '10'));
	} else {
		$smarty->assign("queue0",$Panel->QueueList("0"));
		$smarty->assign("queue1",$Panel->QueueList("1"));
		$smarty->assign("queue2",$Panel->QueueList("2"));
		$smarty->assign("queue3",$Panel->QueueList("3"));
		$smarty->assign("queue4",$Panel->QueueList("4"));
	}

	$smarty->display("managequeue/queue.tpl");
}

if($_REQUEST['mode'] =="saveq"){
	sql_query($safesql->query("UPDATE queue SET `mod`='%s' WHERE id='%i';", array(serialize($mod),$GameCP->whitelist($_REQUEST['qid'], "int")))) or die(mysql_error());
	$_REQUEST['mode']='edit2';
}

if($_REQUEST['mode'] == "edit2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$smarty->assign("Panel",$Panel);

	$result = sql_query($safesql->query("SELECT result, `status`, `mod`, fraudcheck FROM queue WHERE id='%i' LIMIT 1;", array($GameCP->whitelist($_REQUEST['qid'], "int")))) or die(mysql_error());
	$queueResult = mysql_fetch_row($result);
	$status=$queueResult[1];
	$mod=unserialize($queueResult[2]);
	$smarty->assign("queueResult",$queueResult[0]);
	$smarty->assign("fraud_results",json_decode($queueResult[3]));
	$smarty->assign("status",$status);
	$smarty->assign("qid",$_REQUEST['qid']);
	$smarty->assign("mod",$mod);
	$smarty->display("managequeue/queue-results.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>