<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('ttcategories');

$smarty->assign('page_title', $LNG_SUPPORT);

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){ 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license");
}

if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(isset($_REQUEST['tid'])) $_REQUEST['tid']=$GameCP->whitelist($_REQUEST['tid'], "int");


if ($mode == "remove") {
	sql_query($safesql->query("DELETE FROM ttcategorys WHERE id='%i'", array($GameCP->whitelist($_REQUEST['tid'], "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}

if ($mode == "update") { 
	sql_query($safesql->query("UPDATE ttcategorys SET title='%s' WHERE id='%i'", array($GameCP->whitelist($_REQUEST['title'], "clean"), $GameCP->whitelist($_REQUEST['tid'], "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}


if ($mode == "add") {
	sql_query($safesql->query("INSERT INTO ttcategorys SET title='%s'", array($GameCP->whitelist($_REQUEST['title'], "clean")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}



if ($mode == 'edit'){
	$result = sql_query("SELECT * FROM ttcategorys ORDER BY 'title'") or die(mysql_error());
	$list = array();
	while ($row = mysql_fetch_array($result)) $list[] = $row;
	$smarty->assign("categories",$list);
	$smarty->display("managetickets/managetickets-edit.tpl");
}
elseif ($mode == 'edit2'){
	$info = sql_query($safesql->query("SELECT * FROM ttcategorys WHERE id = '%i'", array($GameCP->whitelist($_REQUEST['tid'], "int")))) or die(mysql_error());
	$pinfo = mysql_fetch_row($info);
	$smarty->assign("tid",$_REQUEST['tid']);
	$smarty->assign("catname",$pinfo[1]);
	$smarty->display("managetickets/managetickets-new.tpl");

}elseif ($mode == 'new') $smarty->display("managetickets/managetickets-new.tpl");


require_once(path.'/includes/core/editable/footer.inc.php');

?>