/* modified plugin, do not replace with stock */
(function( $ ) {
		$.widget( "ui.combobox", {
			_create: function() {
				var self = this,
					select = this.element.hide(),
					selected = select.children( ":selected" ),
					value = selected.val() ? selected.text() : "";
					var input = this.input = $( "<input>" )
					.addClass( "autolistinput" )
					.addClass( this.element.attr('class') )
					.insertAfter( select )
					.val( value )
					.autocomplete({
						delay: 0,
						minLength: 0,
						source: function( request, response ) {
							var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
							response( select.children( "option" ).map(function() {
								var text = $( this ).text();
								if ( this.value && ( !request.term || matcher.test(text) ) )
									return {
										label: text.replace(
											new RegExp(
												"(?![^&;]+;)(?!<[^<>]*)(" +
												$.ui.autocomplete.escapeRegex(request.term) +
												")(?![^<>]*>)(?![^&;]+;)", "gi"
											), "$1" ),
										value: text,
										option: this
									};
							}) );
						},
						select: function( event, ui ) {
							if(self.element.attr('onchange')) eval(self.element.attr('onchange'));
							if(ui.item.option.value && select.attr('class') == 'cvarselect'){
								return false;
							}else{
								if(select.attr('id') == "userauto" && ui.item.option.value){
									$(".user_profile").attr('disabled', '');
									$(".user_profile").addClass('disabled');
									$('#username').val('');
								}
								if(select.attr('id') == "gamelist" && ui.item.option.value) showGameOptions(ui.item.option.value);
								
								ui.item.option.selected = true;
								self._trigger( "selected", event, {
									item: ui.item.option
								});
							}
						},
						change: function( event, ui ) {

							if ( !ui.item ) {
								var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( $(this).val() ) + "$", "i" ),
									valid = false;
								select.children( "option" ).each(function() {
									if ( $( this ).text().match( matcher ) ) {
										this.selected = valid = true;
										return false;
									}
								});
								if ( !valid ) {
									$( this ).val( "" );
									select.val( "" );
									input.data( "autocomplete" ).term = "";
									if(select.attr('id') == "userauto"){
										$(".user_profile").removeAttr('disabled', '');
										$(".user_profile").removeClass('disabled');
									}
									return false;
								}
							}

						}
					})
					.addClass( "autolist" );

				input.data( "autocomplete" )._renderItem = function( ul, item ) {
					return $( "<li></li>" )
						.data( "item.autocomplete", item )
						.append( "<a>" + item.label + "</a>" )
						.appendTo( ul );
				};

				this.button = $( "<button type='button' class='button "+this.element.attr('class')+"'>&darr;</button>" )
					.attr( "tabIndex", -1 )
					.attr( "title", "Show All Items" )
					.insertAfter( input )

					.addClass( "autolistbutton" )
					.click(function() {
						// close if already visible
						if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
							input.autocomplete( "close" );
							return;
						}

						// work around a bug (likely same cause as #5265)
						$( this ).blur();

						// pass empty string as value to search for, displaying all results
						input.autocomplete( "search", "" );
						input.focus();
					});
			},

			destroy: function() {
				this.input.remove();
				this.button.remove();
				this.element.show();
				$.Widget.prototype.destroy.call( this );
			}
		});
	})( jQuery );