<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$noheader=true;
require('../config.inc.php');

$GameCP->loadIncludes("game");
$GameCP->loadIncludes("cron");
$GameCP->loadIncludes("query");
$GameCP->loadIncludes("panel");
$GameCP->loadIncludes("email");

$Email=new Email();
$Panel=new Panel();
$Game=new Game();
$Cron=new Cron();
$Query=new Query();

if((isset($_SERVER['REQUEST_METHOD']) && !isset($_REQUEST['key'])) || (isset($_REQUEST['key']) && $Cron->CheckKey($_REQUEST['key']) == false)){
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

sql_query("UPDATE settings SET value='".time()."' WHERE name='ran_cache';");

if(repo_daily_ran =='') sql_query("UPDATE settings SET value='".time()."' WHERE name='repo_daily_ran';");
if(steam_daily_ran =='') sql_query("UPDATE settings SET value='".time()."' WHERE name='repo_daily_ran';");

require(path.'/includes/core/classes/games/repos.inc.php');
$Repos = new Repos();


if((time()-repo_daily_ran) > '86400'){
	sql_query("UPDATE settings SET value='".time()."' WHERE name='repo_daily_ran';");
	$Repos->ManageRepo(false, 'start');
}

if((time()-repo_daily_ran) > '3600' && (time()-repo_daily_ran) < '3900'){
	sql_query("UPDATE settings SET value='".(time()+3900)."' WHERE name='repo_daily_ran';");
	$Repos->ManageRepo(false, 'check');
}


if(steam_daily == '1'){
	require_once(path."/includes/core/classes/games/steamcmd.inc.php");
	$SteamCMD=new SteamCMD();

	if((time()-steam_daily_ran) > '43200'){
		sql_query("UPDATE settings SET value='".time()."' WHERE name='steam_daily_ran';");
		$SteamCMD->RunMachine();
	}

	if((time()-steam_daily_ran) > '3600' && (time()-steam_daily_ran) < '3900'){
		sql_query("UPDATE settings SET value='".(time()+3900)."' WHERE name='steam_daily_ran';");
		$result=$SteamCMD->RunMachine(null, 'check');
		$Event->EventLogAdd('', "SteamCMD Daily Ran: ".json_encode($result));
		sql_query("UPDATE settings SET value='".time()."' WHERE name='steam_daily_ran';");
	}
}

$result = mysql_query("SELECT id FROM usergames WHERE suspend !='' AND suspend < '".time()."' AND active !='2'") or die(mysql_error());
while ($row = mysql_fetch_array($result)){ 
	$GameCP->loadIncludes("suspend");
	$Suspend=new Suspend();
	$Suspend->Game($row['id']);
}

$result = mysql_query("SELECT id FROM users WHERE suspend !='' AND suspend < '".time()."' AND active !='0'") or die(mysql_error());
while ($row = mysql_fetch_array($result)){ 
	$GameCP->loadIncludes("suspend");
	$Suspend=new Suspend();
	$Suspend->User($row['id']);
}


if(inactivett > '0'){
	$inactive=time()-(inactivett*3600);
	$result = sql_query("UPDATE `ttsystem` SET status='Closed' WHERE `updated` !='' AND `updated` < '$inactive'") or die(mysql_error());
}

if(queue_mail == "1"){
	$result = sql_query("SELECT id FROM `emailqueue` WHERE queue='1' LIMIT 20") or die(mysql_error());
	while ($row = mysql_fetch_array($result)) {
		$Email->runqueue($row['id']);
	}
}

$result = sql_query("SELECT id, time FROM eventlogs WHERE time < ".(time() - CLEAREVENTLOGS) ."") or die(mysql_error());
while ($row = mysql_fetch_array($result)) sql_query("DELETE FROM eventlogs WHERE id='".$row[0]."'") or die(mysql_error());


$result = sql_query("SELECT UG.id as 'ugid', U.name, S.sid, UG.startserver, UG.status FROM users U, usergames UG, game G, iptable I, servers S WHERE U.id = UG.cid AND UG.gid = G.id AND U.active='1' AND UG.ip = I.ip AND I.sid = S.sid  AND (UG.status='4' OR UG.status='6');") or die(mysql_error());
while ($row = mysql_fetch_array($result)){
	if($row['status'] == "6"){
		$reinstall=true;
	} else $reinstall=false;
	$Game->CheckStatus($row['sid'], $row['ugid'], $row['name'], $row['startserver'], false,'','',$reinstall);
}
 

		
?>