<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

$noheader=true;
require_once('../config.inc.php');
require_once('../mysql.inc.php'); 

$GameCP->loadIncludes("cron");
$Cron=new Cron();

if(webcron == '0' && (!isset($_REQUEST['key']) || (isset($_REQUEST['key']) && $Cron->CheckKey($_REQUEST['key']) == false))){
    header( "HTTP/1.1 403 Forbidden" );
    die( "<html><body><h1>HTTP 403 - Forbidden</h1></body></html>" );
}

if(webcron == '1'){
	session_start();
	if($_SESSION['gamecp']['userinfo']['ulevel'] == '0') exit;
}

set_time_limit("999999999");

$result=array();
if($Cron->ExecTask('auto.php', "86400"))			$result[]= "Daily Billing Cron Ran";
if($Cron->ExecTask('queue.php', "300"))				$result[]= "Queue Cron Ran";
if($Cron->ExecTask('quota.php', "1900"))			$result[]= "Quota Check Cron Ran";
if($Cron->ExecTask('cache.php', "240"))				$result[]= "Cache Cron Ran";
if($Cron->ExecTask('imap.php', "300"))				$result[]= "Mail Import Cron Ran";
if($Cron->ExecTask('servermonitor.php', "300"))		$result[]= "Server Monitor Cron Ran";
if($Cron->ExecTask('scheduler.php', "120"))			$result[]= "Scheduler Cron Ran";

echo json_encode($result);

?>