<?php
/*
 * Smarty plugin
 * -------------------------------------------------------------
 * File:     function.gcp_bill_list.php
 * Type:     function
 * Name:     gcp_server_list
 * Purpose:  displays GameCP's bill list
 * -------------------------------------------------------------
 */

function paymentGateways(){
		$paymentMethods = sql_query("SELECT id, name, fullname FROM gateways WHERE status = '1'") or die(mysql_error());
		$gateways=array();
		$gi=0;
		while ($row = mysql_fetch_array($paymentMethods)){
			$gateways[$gi]=$row;
			$gi++;
		}
	return $gateways;
}


function smarty_function_gcp_bill_list($params, &$smarty)
{
 global $GameCP, $smarty, $cid, $safesql; 
// Server list
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

$pageTitle=$params['pageTitle'];

$status=$GameCP->whitelist($params['status'], 'clean');

if($status == "All"){
	$statusQ="";
} else $statusQ="B.status = '$status' AND";

$formName=$status;
if(!$formName)$formName="bill";
$jsCheckScript=$params['jsCheckScript'];

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1" || $_SESSION['gamecp']['userinfo']['ulevel'] == "2") { 
	$sql = "SELECT SQL_CALC_FOUND_ROWS B.date, B.id as 'bid', B.status, B.gross, B.fee, U.*, U.id as 'cid', B.daystill as 'daystill', B.taxtotal, U.taxed FROM billing B, users U WHERE $statusQ B.cid = U.id";
} else { 
	$sql = "SELECT SQL_CALC_FOUND_ROWS B.date, B.id as 'bid', B.status, B.gross, B.fee, U.*, U.id as 'cid', B.daystill as 'daystill', B.taxtotal, U.taxed FROM billing B, users U WHERE $statusQ B.cid = U.id AND cid='$cid'";
}

if(!$sql){ echo "Fatal Error: Missing MySQL query."; return false; }

if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
	$sql=str_replace("RSIDQUERY", "AND U.rsid='".$_SESSION['gamecp']['userinfo']['id']."'", $sql);
} else 	$sql=str_replace("RSIDQUERY", "", $sql);

if($_REQUEST['initial']) $sql=$sql." AND UPPER(LEFT(U.username,1)) LIKE '".$GameCP->whitelist($_REQUEST['initial'][0])."'"; 

if($_GET['idd'] && $_SESSION['gamecp']['userinfo']['ulevel'] == "1") $sql=$sql." AND U.id='".$GameCP->whitelist($_REQUEST['idd'], "int")."'";

if($_REQUEST['bid']) $sql=$sql." AND B.id='".$GameCP->whitelist($_REQUEST['bid'], "int")."'";

if($_REQUEST['searchcontent']){
	$sql.=" AND (B.id LIKE '%".$GameCP->whitelist($_REQUEST['searchcontent'])."' 
	OR U.name LIKE '%".$GameCP->whitelist($_REQUEST['searchcontent'])."'
	OR U.email LIKE '%".$GameCP->whitelist($_REQUEST['searchcontent'])."'
	OR U.payment LIKE '%".$GameCP->whitelist($_REQUEST['searchcontent'])."'
	) ";
}


$sql=$sql." ORDER BY date DESC";



	// Clear any old variabels.
	$smarty->clearAssign("billList"); 
	$smarty->clearAssign("completedTotal"); 
	$smarty->clearAssign("completedTotal2"); 
	$ServerList=array();
	$i = "0"; 


	$result=Smarty_PageControl($sql, $formName, $formName."Var");


	if( mysql_num_rows($result) == 0 ){ 
		$smarty->assign("status", $status);
		$smarty->display("billing/bill-list.tpl");
		return false;
	} else { 

		if(!isset($_REQUEST['noheader']) && !isset($_REQUEST['mini'])){
				/* display the Completed total for admin or client */
				if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1" ) { $compAdmin = ""; } else { $compAdmin = "cid='".$GameCP->whitelist($cid)."' AND"; }
				$completedGross = sql_query($safesql->query("SELECT sum(gross) FROM billing WHERE $compAdmin status='%s'", array($status))) or die(mysql_error());
				$completedFee = sql_query($safesql->query("SELECT sum(fee) FROM billing WHERE $compAdmin status='%s'", array($status))) or die(mysql_error());
				$completedGrossRes = mysql_fetch_array($completedGross); 
				$completedFeeRes = mysql_fetch_array($completedFee);

				if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1") { 
					$completedTotal = $completedGrossRes[0] - $completedFeeRes[0];
				} else { 
					$completedTotal =  $completedGrossRes[0]; 
				}


				$showtoday=date(dateformat, strtotime("now"));
				$montha_01=date(dateformat, strtotime("-1 month"));

				// display the Monthly total for admin or client [same as above but for month only]

				if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1") { 
					$compAdmin2 = "date <= '$showtoday' AND date > '$montha_01' AND"; 
				} else $compAdmin2 = "date <= '$showtoday' AND date > '$montha_01' AND cid='$cid' AND";
				
				$completedGross2 = sql_query($safesql->query("SELECT sum(gross) FROM billing WHERE $compAdmin2 status='Completed'", array())) or die(mysql_error());
				$completedFee2 = sql_query($safesql->query("SELECT sum(fee) FROM billing WHERE $compAdmin2 status='Completed'", array())) or die(mysql_error());
				$completedGrossRes2 = mysql_fetch_array($completedGross2); $completedFeeRes2 = mysql_fetch_array($completedFee2);
				if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1") { 
					$completedTotal2 = $completedGrossRes2[0] - $completedFeeRes2[0]; 
				} else $completedTotal2 =  $completedGrossRes2[0]; 
		}


		$i = "0";
		$BillInfo=array();

		while ($row = mysql_fetch_array($result)){		

			if($row['firstname'] || $row['lastname']){
				$name=$row['firstname'] .' '.  $row['lastname'];
			} elseif($row['email']){
				$name=$row['email'];
			} else $name=$row['name'];
			$bid = $row['bid'];
			$nbid = $row['bid'];
			if(!$row['gross'])$row['gross']="0.00";
			$daysTill = $row['daystill']; 	
			$theDate = strtotime($row['date']);
			//$dueDate  = date ('n/j/Y', mktime(0, 0, 0, date('m',$theDate), (date('d',$theDate)+$daysTill), date('Y',$theDate)));

			$package=array();
			$pi=0;

			$subBill = sql_query($safesql->query("SELECT gross, id as 'ubid', fee, pid, description FROM userbills WHERE bid = '%i';", array($nbid)), "gross bill payment $nbid");
						
			if(mysql_num_rows($subBill) > 0){
				while ($subrow = mysql_fetch_array($subBill)) {


					$packagInfoQ=sql_query("SELECT
								P.name, UP.name
								
								FROM 
								prices P,
								packages UP 
								
								WHERE 

								P.id = '".$subrow['pid']."' 
								AND P.pid = UP.id 
								
								ORDER BY P.name", "product name for $nbid &amp; ".$subrow['pid'])or die(mysql_error());
					$packagInfo = mysql_fetch_array($packagInfoQ);


					if(!$subrow['gross']) $subrow['gross']="0.00";
					if(!$packagInfo[1] && !$packagInfo[0]){
						$fullPackage="Other";
					} else $fullPackage=$packagInfo[1] . " - " .$packagInfo[0];

					$package[$pi] =array("package" => $fullPackage,
						"name" => $packagInfo[0], "gross" => $Panel->FormatNumber($subrow['gross']), "ubid" => $subrow['ubid'], "description" => $subrow['description'], "fee" => $subrow['fee']);
					$pi++;
				} // end subbill while
			}

			$payments=array();
			$pmi=0;
			$balance='';
			$totalpayment="";

			if($_SESSION['gamecp']['subuser']['id']){
				$bpsql="subid='".$_SESSION['gamecp']['subuser']['id']."' AND bid='$bid'";
			} else $bpsql="bid='$nbid'";
			$billPayment = sql_query($safesql->query("SELECT total, time, cid, subid FROM payments WHERE $bpsql;", array()), "total payments on $nbid");
			
			if(mysql_num_rows($billPayment) > 0){
				$GameCP->loadIncludes("panel");
				$Panel=new Panel();
				while ($payrow = mysql_fetch_array($billPayment)) {

					if($payrow['subid']){
						$userInfo=$Panel->GetUser($payrow['subid'], '', true);
					} else $userInfo=$Panel->GetUser($payrow['cid'], '');
					
					$balance=$balance+$payrow[0];
					$paidbyname=$userInfo['name'];
					$totalpayment=$totalpayment+$payrow[0];
					$payments[$pmi] =array("total" => $Panel->FormatNumber($payrow[0]), "time" => $payrow[1], "paidby" => $paidbyname);
					$pmi++;
				} 
			}

			if(!$totalpayment) $totalpayment = "0.00";
			$BillInfo[$i]['dueDate']=$dueDate;
			$BillInfo[$i]['name']=$name;
			$BillInfo[$i]['bid']=$bid;
			$BillInfo[$i]['nbid']=$nbid;
			$BillInfo[$i]['daysTill']=$daysTill;
			$BillInfo[$i]['date']=$row['date'];
			$BillInfo[$i]['status']=$row['status'];
			$BillInfo[$i]['cid']=$row['cid'];


			if(taxEnable == "yes" && $row['taxed'] == "1"){
				$BillInfo[$i]['gross']=$Panel->FormatNumber($row['gross']+$row['taxtotal'], $row['cid'], true);
			} else $BillInfo[$i]['gross']=$Panel->FormatNumber($row['gross'], $row['cid'], true);

			$BillInfo[$i]['fee']=$Panel->FormatNumber($row['fee'], $row['cid'], true);
			$BillInfo[$i]['packages']=$package;
			$BillInfo[$i]['payments']=$payments;
			$BillInfo[$i]['totalpayment']=$Panel->FormatNumber($totalpayment, $row['cid'], true);
			$BillInfo[$i]['balance']=$row['gross']-$balance;

			$i++;
		}  // End while.


		/* due date isnt part of MySQL so we need to array sort */
		if($status == "Pending"){
			$GameCP->loadIncludes("display");
			$Display=new Display();
			$BillInfo=$Display->ArraySort($BillInfo, "dueDate");
		}

		if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1"  && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && ($status == "Pending" || $status == "All") ) $smarty->assign("gateways", paymentGateways());

		$smarty->assign("completedTotal", $completedTotal);
		$smarty->assign("completedTotal2", $completedTotal2);

		$smarty->assign("billList", $BillInfo);
		$smarty->assign("showBillList", count($BillInfo)); 
	
		$smarty->assign("status", $status);
		$smarty->display("billing/bill-list.tpl");



	} // End else



}
?>