{strip}
<html>
<head>
	<title>{#LNG_INVOICE# nofilter} #{$mainBill.id}</title>
	{literal}
	<style type="text/css">
		body{
			font-family: arial;
		}
		.main, .main td{
			border: 1px solid black
		}
		.total{
			background: #ccc;
		}
		.title{
			background: #6699ff;
			color: #fff;
		}
	</style>
	{/literal}
	<meta http-equiv="Content-Type" content="text/html;charset={#LNG_CHARSET# nofilter}">
</head>
<body>
<table width="98%" align="center" cellpadding="4" cellspacing="0">
	<tr>
		<td>
			<img src="{$url}/billing/pdf/logo.gif">
		</td>
		<td align="right">
			<h3>{$domainName} {#LNG_INVOICE# nofilter} #{$mainBill.id}</h3>
			<table cellpadding="0" cellspacing="2">
				<tr>
					<td align="right">
			{if $mainBill.status != "Completed"}
				<strong>{#LNG_BILL_DUE_DATE# nofilter}:</strong></td><td align="left">{$dueDate}
			{else}
				<strong>{#LNG_STATUS# nofilter}:</strong></td><td align="left">{#LNG_PAID# nofilter}</td><tr><td align="right">
				<strong>{#LNG_DATE# nofilter}:</strong></td><td align="left">{$dueDate}
			{/if}
					</td>
				</tr>
				<tr>
					<td align="right"><strong>{#LNG_PAYMENTMETHOD# nofilter}:</strong></td><td align="left">{$userInfo.payment}</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td colspan="2">&nbsp;</td>
	</tr>
	<tr>
		<td width="50%" valign="top" style="padding-left: 20px;">
			<strong>Invoiced To</strong><br>
			{$userInfo.firstname} {$userInfo.lastname}<br>
			{$userInfo.address}{if $userInfo.address2} <br>{$userInfo.address2}{/if}<br>
			{$userInfo.city}<br>
			{$userInfo.state}<br>
			{$userInfo.zip}<br>
			{if $userInfo.country}{$userInfo.country}<br>{/if}
			{if $userInfo.taxid}{$userInfo.taxid}{/if}
		</td>

		<td valign="top" style="padding-left: 10px;">
			<strong>Invoiced From</strong><br>
			{if $INVOICEHEADER}
				{$INVOICEHEADER|nl2br nofilter}
			{/if}
		</td>
	</tr>
	<tr>
		<td colspan="2">
			<br>
			<table width="100%" align="center" cellpadding="4" cellspacing="0" class="main">
				<tr class="title">
					<td>{#LNG_DESCRIPTION# nofilter}</td>
					<td>{#LNG_DATE# nofilter}</td>
					<td>{#LNG_PRICE# nofilter}</td>
				</tr>

				{section name="p" loop=$package}
				<tr>
					<td>{$package[p].0}</td>
					<td>{$package[p].1}</td>
					<td align="center">{$Panel->FormatNumber($package[p].2, $cid, true)}</td>
				</tr>
				{/section}

				{if $taxEnable == "yes"}
					{if is_array($taxitems) && count($taxitems) > 0}
					{* just like in order - needs to cycle threw each tax item *}
						{section name='ti' loop=$taxitems}
						<tr class="total">
							<td colspan="2"  align="right">
								<strong>{if $taxitems[ti].description}{$taxitems[ti].description} ({$taxitems[ti].rate}%){else}{#LNG_TAX# nofilter}{/if}:</strong>
							</td>
							<td align="center">{if $taxitems[ti].total}{$Panel->FormatNumber($taxitems[ti].total, $cid, true)}{else}{$zero}{/if}</td>
						</tr>

						{/section}
					{else}
						<tr class="total">
							<td colspan="2"  align="right">
								<strong>{#LNG_TAX# nofilter}:</strong>
							</td>
							<td align="center">{$zero}</td>
						</tr>
					{/if}
				{/if}

				<tr class="total">
					<td colspan="2" align="right"><strong>{#LNG_TOTAL# nofilter}:</strong></td>
					<td align="center">{$total}</td>
				</tr>
			</table>
		</td>
	</tr>
</table>

</body>
</html>
{/strip}