{* jquery form validation *}
<script type="text/javascript" src="{$url}/includes/core/javascript/jquery/jquery.form.min.js"></script>
<script type="text/javascript" src="{$url}/includes/core/javascript/jquery/jquery.validate.min.js"></script>
<script type="text/javascript" src="{$url}/includes/gzip.php?uri=includes/core/javascript/forms/ajax.js"></script>
<script type="text/javascript" src="{$url}/includes/core/javascript/forms/forms.js"></script>

<script type="text/javascript" src="{$url}/includes/core/javascript/jquery/jquery.combobox.js"></script>
{if $voicetype != "ts3"}
<script type="text/javascript">{literal}
	$(document).ready(function() {

		submitValid('#ts2BanAdd');

		$("#formTeamspeak").validate({
			rules: {
				fpassword: {
					required: true,
					minlength: 5
				},
				fpassword2: {
					required: true,
					minlength: 5,
					equalTo: "#fpassword"
				},
				messages: {
					fpassword: {
						required: "Please provide a password",
						minlength: "Your password must be at least 5 characters long"
					},
					fpassword2: {
						required: "Please provide a password",
						minlength: "Your password must be at least 5 characters long",
						equalTo: "Please enter the same password as above"
					}
				}
			},
			submitHandler: function(form) { ajaxSubmitPage('#formTeamspeak', '#formReply'); }

		});
	});
{/literal}
</script>
{else}
<script type="text/javascript">
	ajaxSubmitValid('#formTeamspeak');
</script>
{/if}

{$GameCP->generateNavigationStats()}
<div class="pageHeader pageHeaderLarge">
	<h3>{#LNG_VOICEMANAGEMENT# nofilter}</h3>
	<div class="pageSubList">
		<ul class="listTab">
			<li title="{#LNG_SETTINGS# nofilter}" {if $loadban != "true"}class="tabLit"{/if} onclick="javascript: loadRegularTab('ts2settings', this);">{#LNG_SETTINGS# nofilter}</li>
			<li title="Bans" {if $loadban == "true"}class="tabLit"{/if} onclick="javascript: loadRegularTab('ts2bans', this);">Bans</li>
		</ul>
	</div>
</div>
<div class="pageSubHeader">
	<strong>{#LNG_EDITING# nofilter}:</strong> {$serverInfo.ip}:{$serverInfo.port}
</div>
<div class="pageNavigation">
	{if $sessionUserLevel == "1" || $sessionUserLevel == "5"}
		<a class="button icon add" href="{$url}/manage/newservice.php?idd={$ucid}">{#LNG_CREATESERVICE# nofilter}</a> 
	{/if}
	{if $GameCP->activeVoice > 0} <a href="{$url}/system/voice.php" title="Stop/start/restart voice servers">{#LNG_CONTROLVOICESERVERS# nofilter}</a>{/if}
</div>

<div class="clear"></div>

<div id="altsavediv">{#LNG_SAVED# nofilter}</div>

<div id="formReply"></div>
<div class="inner_content">
{if $sessionUserLevel == "1" || $sessionUserLevel == "2" || $sessionUserLevel == "4"}
<form id="formTeamspeak" name="formTeamspeak" method="post" action="voice.php?noheader=true">
{/if}
<table id="ts2settings" class="bgb tabBg {if $loadban == "true"}ui-helper-hidden{/if}" width="100%" align="center" cellpadding="2" cellspacing="0" >
	<tr class="tableTop">
		<td colspan="5" class="tableTitle">
			{#LNG_SETTINGS# nofilter}
		</td>
	</tr>
	<tr>
		<td colspan="5">
			&nbsp;
		</td>
	</tr>
{if $sessionUserLevel == "1"}
	<tr>
		<td align="right">{#LNG_USER# nofilter}</td>
		<td colspan="4">
			<select name="cid" id="userauto">
				<option value="">{#LNG_SELECTUSER# nofilter}
				{section name=userListRow loop=$userList}
					<option value="{$userList[userListRow].id}" {if $serverInfo.cid == $userList[userListRow].id}selected="selected"{/if}>{$userList[userListRow].name}</option>
				{/section}
			</select>
			<script type="text/javascript" >$("#userauto").combobox();
			{literal}
				$(".autolistinput").bind("keypress", function(e) {
					if (e.keyCode == 34||e.keyCode == 13) return false;
				});
			{/literal}
			</script>

		</td>
	</tr>
{/if}
{if $voicetype != "ts3"}
	<tr>
		<td align="right">{#LNG_NEWPWD# nofilter}:</td>
		<td>
			<input id="fpassword" type="password" name="fpassword" value="{$serverInfo.pass}" class="required">		
		</td>
		<td>&nbsp;</td>
		<td align="right">{#LNG_NEWPWD2# nofilter}:</td>
		<td>
			<input id="fpassword2" type="password" name="fpassword2" value="{$serverInfo.pass}" class="required">		
		</td>
	</tr>
{else}
	<tr>
		<td align="right">Token:</td>
		<td>
			<input id="fpassword" type="hidden" name="fpassword" value="{$serverInfo.pass}">		
			<input type="text" name="token" value="{$serverInfo.ts3token}"><input type="button" value="New token" onclick="window.location='?mode=newtoken&amp;vid={$vid}';">
		</td>
		<td colspan="3">&nbsp;</td>
	</tr>

{/if}
{if $sessionUserLevel == "1" || $sessionUserLevel == "2" || $sessionUserLevel == "4"}
	<tr>
		<td width="40%" align="right">{#LNG_MAXCLIENTS# nofilter}:</td>
		<td>
			<input type="text" name="fmaxclients" value="{$serverInfo.maxclients}" class="required">		
		</td>
		<td colspan="3">&nbsp;</td>
	</tr>	
	<tr>
		<td valign="top" align="right">
			{#LNG_BILLINGID# nofilter}:</td>
			<td><input type="text" name="billingid" value="{$billingid}">
		</td>
		<td colspan="3">&nbsp;</td>
	</tr>
{/if}
	<tr>
		<td colspan="5">&nbsp;</td>
	</tr>
	<tr>
		<td colspan="5" align="center"><div class="button-group">
{if $sessionUserLevel == "1" || $sessionUserLevel == "2" || $sessionUserLevel == "4"}
			<input type="hidden" name="mode" value="teamspeak">
			<input type="hidden" name="option" value="changepass">
			<input type="hidden" name="vid" value="{$vid}">
			<input type="hidden" name="tssid" value="{$tssid}">
			<input type="submit" value="{#LNG_SAVE# nofilter}" class="button">
{/if}
			<input type="button" onclick="window.location='{$url}/system/voice.php';" value="{#LNG_BACKTOLIST# nofilter}" class="button"></div>

		</td>
	</tr>
	<tr>
		<td colspan="5">&nbsp;</td>
	</tr>
	<tr class="tableBottom">
		<td colspan="5">&nbsp;</td>
	</tr>
</table>
{if $sessionUserLevel == "1" || $sessionUserLevel == "2" || $sessionUserLevel == "4"}
</form>
{/if}

<form id="ts2BanAdd" method="post" action="voice.php">
<table id="ts2bans" class="bgb tabBg {if $loadban != "true"}ui-helper-hidden{/if}" width="100%" align="center" cellpadding="2" cellspacing="0">
	<tr class="tableTop">
		<td class="tableTitle">
			Bans
		</td>
		<td align="right">
			<a class="button" href="?mode=removeallbans&amp;vid={$vid}&amp;tssid={$tssid}" onclick="return confirm('{#LNG_AREYOUSUREREMOVE# nofilter} all bans?');">Clear all bans</a>  
			<input type="hidden" name="mode" value="addban">
			<input type="hidden" name="vid" value="{$vid}">
			<input type="hidden" name="tssid" value="{$tssid}">
			<input type="text" name="banip" class="required"><input type="submit" value="{#LNG_SAVE# nofilter}" class="button">
		</td>
	</tr>
	<tr>
		<td colspan="2" class="nopadd">
			<table class="bgbfull" width="100%" align="center" cellpadding="2" cellspacing="0">
				<thead>
					<tr class="bgc" style="text-align:left">
						<th style="width: 80px">&nbsp;</th>
						<th style="width: 50px">{#LNG_ID# nofilter}</th>
						<th>{#LNG_IP# nofilter}</th>
						<th>{#LNG_DATE# nofilter}</th>
						<th>{#LNG_BANNED_BY# nofilter}</th>
					</tr>
				</thead>
{if $voicetype != "ts3"}
				{section name='bl' loop=$banList}
					<tr class="{cycle values='even, odd'}">
						<td>
							<a class="button danger" href="?mode=removeban&amp;banid={$banList[bl].0}&amp;vid={$vid}&amp;tssid={$tssid}"  onclick="return confirm('{#LNG_AREYOUSUREREMOVE# nofilter} {$banList[bl].1}?');">{#LNG_REMOVE#}</a>
						</td>
						<td>{$banList[bl].0}</td>
						<td>{$banList[bl].1}</td>
						<td>{$banList[bl].2}</td>
						<td>{$banList[bl].4|replace:'"':''}</td>
					</tr>
				{sectionelse}
					<tr class="even">
						<td colspan="5">{#LNG_NORESULTS# nofilter}</td>
					</tr>
				{/section}
{else}
				{section name='bl' loop=$banList}
					<tr class="{cycle values='even, odd'}">
						<td>
							<a class="button danger" href="?mode=removeban&amp;banid={$banList[bl].banid}&amp;vid={$vid}&amp;tssid={$tssid}"  onclick="return confirm('{#LNG_AREYOUSUREREMOVE# nofilter} {$banList[bl].ip}?');">{#LNG_REMOVE#}</a>
						</td>
						<td>{$banList[bl].banid}</td>
						<td>						
						{if $banList[bl].ip}<b>{#LNG_IP#}</b>: {$banList[bl].ip}<br>{/if}
						{if $banList[bl].name}<b>{#LNG_NAME#}:</b> {$banList[bl].name}<br>{/if} 
						{if $banList[bl].uuid}<b>UUID:</b> {$banList[bl].uuid}{/if}
</td>
						<td>{$banList[bl].created|date_format:"%m/%d %H:%M %a"}</td>
						<td>{$banList[bl].invokername}</td>
					</tr>
				{sectionelse}
					<tr class="even">
						<td colspan="5">{#LNG_NORESULTS# nofilter}</td>
					</tr>
				{/section}
{/if}
			</table>
		</td>
	</tr>
	<tr class="tableBottom">
		<td valign="top" colspan="2">&nbsp;</td>
	</tr>
</table>
</form>
</div>