<textarea style="width: 99%; height: 370px;" rows="15" cols="100">
1. ACCEPTANCE OF TERMS 

1.1 Read these Terms of Use ("Terms") carefully before You ("You") accept these Terms by: (a) placing an order through gamecp.com and/or (b) use the gamecp.com website ("Website") in any other manner. If You do not agree to all of these terms, do not use this Website. 

1.2 The Terms are entered into by and between GameCP, Inc. ("GameCP") and You. If you are using the Services on behalf of Your employer, You represent that You are authorized to accept these Terms on Your employer's behalf. GameCP provides the GameCP online store and other on-line resources accessible via gamecp.com (the "Services") to You, subject to the Terms. Unless explicitly stated otherwise, the Terms will govern Your use of any new features that augment or enhance the current Services, including the release of new GameCP resources. In addition to the Terms and unless otherwise noted, the GameCP Standard License governs purchases You make through gamecp.com, unless You have currently in effect a separate written purchase or license agreement with GameCP for that product, in which case that separate agreement governs. If there is a conflict between: (a) these Terms, and (b) either the GameCP Standard License or other applicable purchase or license agreement, the latter prevail. 

2. INTELLECTUAL PROPERTY RIGHTS 

2.1 The Services and any software (including any downloads available at the Website or otherwise provided by GameCP) used in connection with the Services ("Software") contain proprietary and confidential information that is protected by applicable intellectual property and other laws. Content contained in third-party advertisements or information presented to You through the Services or advertisers is protected by copyrights, trademarks, service marks, patents, publicity rights, or other proprietary rights and laws. Except as expressly authorized by GameCP or advertisers, You agree not to modify, rent, lease, loan, sell, distribute or create derivative works based on the Services or the Software, in whole or in part. 

2.2 You may use the Software and related Services only subject to the agreement or license that accompanies such Software or Services. You may use Services only during their specified term, for the enumerated number of times, for the specified number of individuals, or as otherwise limited in the applicable agreement or license. Services involving an update, version release, product release, maintenance release, patch or derivative work of a licensed Software or Service may be used only: (a) on systems for which such Software or Service were specifically licensed; and (b) subject to the license and warranty term governing the original product or Service. 

2.3 You must not modify, decompile, or reverse engineer any Software GameCP discloses to You, and must not remove, overprint, or deface any notice of copyright, trademark, logo, legend, or other notice of ownership from any originals or copies of Software or Information from the Services. 

2.4 "GameCP Trademarks" means all names, marks, brands, logos, designs, trade dress and other designations GameCP uses in connection with Products or Services. Customer may not remove or alter any GameCP Trademarks. Customer acknowledges GameCP's rights in GameCP Trademarks. Customer agrees not to incorporate any GameCP Trademarks into Customer's trademarks, service marks, company names, Internet addresses, domain names, or any other similar designations. 

2.5 GameCP is committed to respecting others' intellectual property rights, and we ask our users to do the same. GameCP may, in its sole discretion, terminate the accounts or access rights of users who infringe or otherwise violate others' intellectual property rights. If You believe that Your work has been copied in a way that constitutes copyright infringement on our Website, please contact our copyright agent as described in our copyright policy. 

2.6 All Content provided on this Website is provided by or to GameCP by its respective manufacturers, authors, developers and vendors (the "Third Party Providers") and is the copyrighted work of GameCP and/or the Third Party Providers. Except as stated herein, none of the Content may be copied, reproduced, distributed, republished, downloaded, displayed, posted or transmitted in any form or by any means, including, but not limited to, electronic, mechanical, photocopying, recording, or otherwise, without the prior express written permission of GameCP or the Third Party Provider. No part of the Website, including logos, graphics, sounds or images, may be reproduced or retransmitted in any way, or by any means, without the prior express written permission of GameCP. You also may not, without GameCP's prior express written permission, "mirror" any Content contained on this Website on any other server. 

2.7 Nothing on this Website shall be construed as conferring any license under any of GameCP's or any Third Party Provider's intellectual property rights, whether by estoppel, implication, or otherwise. You acknowledge sole responsibility for obtaining any such licenses. 

2.8 Permission is granted to display, copy, distribute and download GameCP's Content on this Website provided that: (1) both the copyright notice identified below and this permission notice appear in the Content, (2) the use of such Content is solely for personal, non-commercial and informational use and will not be copied or posted on any networked computer or broadcast in any media, except as explicitly permitted by valid license covering such materials, and (3) no modifications of any of the Content are made. This permission terminates automatically without notice if You breach any of these terms or conditions. Upon termination, You must immediately destroy any downloaded and printed Content. 

2.9 Any unauthorized use of any Content contained on this Website may violate copyright laws, trademark laws, the laws of privacy and publicity, and communications regulations and statutes. 

2.10 Content provided by Third Party Providers has not been independently authenticated in whole or in part by GameCP. GameCP does not provide, sell, license, or lease any of the Content other than those specifically identified as being provided by GameCP. 

3. DISCLAIMER OF WARRANTIES 

3.1 YOUR USE OF THE SERVICES AND ANY SOFTWARE IS AT YOUR SOLE RISK. THE SOFTWARE, SERVICES AND INFORMATION ARE PROVIDED ON AN "AS IS" AND "AS AVAILABLE" BASIS. THE CONTENT ON THE WEBSITE IS PROVIDED "AS IS", "WITH ALL FAULTS," AND IS FOR COMMERCIAL USE ONLY. GameCP DISCLAIMS ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS, AND WARRANTIES OF ANY KIND, INCLUDING ANY IMPLIED WARRANTY OR CONDITION OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE, QUIET ENJOYMENT OR NONINFRINGEMENT. GameCP MAKES NO REPRESENTATIONS, WARRANTIES, CONDITIONS OR GUARANTIES AS TO THE QUALITY, SUITABILITY, TRUTH, ACCURACY OR COMPLETENESS OF ANY OF THE CONTENT CONTAINED ON THE WEBSITE. GameCP MAY MAKE AVAILABLE ON THE WEBSITE CONTENT AVAILABLE FOR DOWNLOADING WHICH HAS BEEN SUBMITTED BY THIRD-PARTY USERS OF THE WEBSITE. ANY QUESTIONS REGARDING THE CONTENT SHOULD BE DIRECTED TO THE PROVIDERS OF SUCH CONTENT. IN NO EVENT WILL GameCP OR ITS SUPPLIERS BE LIABLE FOR THE ACCURACY OR COMPLETENESS OF THE CONTENT OR INFORMATION FROM THE WEBSITE. 

3.2 GameCP MAKES NO WARRANTY OR CONDITION THAT: (i) THE SOFTWARE OR SERVICES WILL MEET YOUR REQUIREMENTS, (ii) THE SERVICES WILL BE UNINTERRUPTED, TIMELY, SECURE, OR ERROR-FREE, (iii) THE RESULTS THAT MAY BE OBTAINED FROM THE USE OF THE SOFTWARE OR SERVICES WILL BE ACCURATE OR RELIABLE, (iv) THE QUALITY OF ANY PRODUCTS, SOFTWARE, SERVICES, INFORMATION, OR OTHER MATERIAL PURCHASED OR OBTAINED BY YOU THROUGH THE SERVICES WILL MEET YOUR EXPECTATIONS, OR THAT (v) ANY ERRORS IN THE SOFTWARE WILL BE CORRECTED. 

3.3 ANY MATERIAL DOWNLOADED OR OTHERWISE OBTAINED THROUGH THE USE OF THE SERVICES IS DONE AT YOUR OWN DISCRETION AND RISK AND YOU ARE SOLELY RESPONSIBLE FOR ANY DAMAGE TO YOUR COMPUTER SYSTEM OR LOSS OF DATA THAT RESULTS FROM THE DOWNLOAD OF ANY SUCH MATERIAL, INCLUDING ANY DAMAGES RESULTING FROM COMPUTER VIRUSES. 

3.4 NO ADVICE OR INFORMATION, WHETHER ORAL OR WRITTEN, OBTAINED BY YOU FROM GameCP OR THROUGH OR FROM THE SERVICES WILL CREATE ANY WARRANTY OR CONDITION NOT EXPRESSLY STATED IN THE TERMS. GameCP'S EMPLOYEES ARE NOT AUTHORIZED TO VARY THESE TERMS. 

4. LIMITATION OF LIABILITY 

4.1 TO THE EXTENT NOT PROHIBITED BY APPLICABLE LAW, GameCP IS NOT LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, CONSEQUENTIAL, PUNITIVE, OR EXEMPLARY DAMAGES, INCLUDING BUT NOT LIMITED TO, DAMAGES FOR LOSS OF PROFITS, REVENUE, GOODWILL, USE, DATA, ELECTRONICALLY TRANSMITTED ORDERS, OR OTHER ECONOMIC ADVANTAGE (EVEN IF GameCP HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES), HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, WHETHER IN CONTRACT (INCLUDING FUNDAMENTAL BREACH), TORT (INCLUDING NEGLIGENCE) OR OTHERWISE, ARISING OUT OF OR RELATED TO: (i) THE USE OF OR THE INABILITY TO USE THE SOFTWARE OR SERVICES; (ii) THE COST OF PROCUREMENT OF SUBSTITUTE GOODS AND SERVICES RESULTING FROM ANY GOODS, DATA, SOFTWARE, INFORMATION OR SERVICES PURCHASED OR OBTAINED OR MESSAGES RECEIVED OR TRANSACTIONS ENTERED INTO THROUGH OR FROM THE SERVICES; (iii) UNAUTHORIZED ACCESS TO OR ALTERATION OF YOUR TRANSMISSIONS OR DATA; (iv) STATEMENTS OR CONDUCT OF ANY THIRD PARTY ON THE SERVICES AND THE WEBSITE; OR (v) ANY OTHER MATTER RELATING TO THE SERVICES, INCLUDING CONTENT YOU MAY DOWNLOAD, USE, MODIFY OR DISTRIBUTE FROM THE WEBSITE. 

4.2 YOU HAVE SOLE RESPONSIBILITY FOR ADEQUATE PROTECTION AND BACKUP OF DATA AND/OR EQUIPMENT USED IN CONNECTION WITH THE WEBSITE AND WILL NOT MAKE A CLAIM AGAINST GameCP FOR LOST DATA, RE-RUN TIME, INACCURATE OUTPUT, WORK DELAYS OR LOST PROFITS RESULTING FROM THE USE OF THE CONTENT. 

4.3 YOU AGREE TO HOLD GameCP HARMLESS FROM, AND YOU COVENANT NOT TO SUE GameCP FOR, ANY CLAIMS BASED ON USING THE WEBSITE, WHETHER IN CONTRACT (INCLUDING FUNDAMENTAL BREACH), TORT (INCLUDING NEGLIGENCE) OR OTHERWISE. Some jurisdictions do not allow the exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not apply to You. 

5. REFUNDS 


We offer no refunds on any service or goods sold. 
Terms and conditions on refunds are located in the refund policy. 

6. LICENSE TERMS 

Licenses are non-transferable. 
</textarea>