<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


if(isset($_REQUEST['mode']) && $_REQUEST['mode'] == "update") $noheader=true;
require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('admins');

$smarty->assign('page_title', $LNG_CLIENTMANAGEMENT);

if(!isset($_REQUEST['mode']) || (isset($_REQUEST['mode']) && $_REQUEST['mode'] == '')) $_REQUEST['mode']='edit';

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "0" || ($_REQUEST['mode'] !='edit2' && !isset($_SESSION['gamecp']['user']['mainadmin']) || $_SESSION['gamecp']['user']['mainadmin'] != "1")) { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(isset($_REQUEST['idd'])){
	$_REQUEST['idd']=$GameCP->whitelist($_REQUEST['idd'], "int");
	$idd=$_REQUEST['idd'];
}
 

switch($_REQUEST['mode']){
	case "update":
		if(DEMO == "yes") die("Demo restricted.");

		if($idd == $_SESSION['gamecp']['userinfo']['id'] && $femail) $_SESSION['gamecp']['userinfo']['email']=$GameCP->whitelist($_REQUEST['femail'], "clean");
		if($idd == $_SESSION['gamecp']['userinfo']['id'] && $_REQUEST['lang']) $_SESSION['gamecp']['lang']=$GameCP->whitelist($_REQUEST['lang'], "useredit");
		
		if(!isset($fmainadmin)) $fmainadmin="0";
		if(!isset($fadvedit)) $fadvedit="0";
		if(!isset($flimit)) $flimit="0";

		if(isset($_POST['uservers'])){
			$uservers=serialize($_POST['uservers']);
		} else $uservers="";
		if(isset($_POST['ugames'])){
			$ugames=serialize($_POST['ugames']);
		} else $ugames="";
		if(!isset($portrange)) $portrange ="";

		if(!isset($fslots)) $fslots = "0";

		$q=$safesql->query("UPDATE users SET 
							name = '%s',
							firstname = '%s', 
							lastname = '%s',
							phone = '%s',
							email = '%s',
							smsaddress='%s',
							address = '%s',
							address2 = '%s',
							city = '%s',
							state = '%s',
							zip = '%s',
							country = '%s',
							extranotes = '%s',
							signature='%s',
							lang='%s',
							`limit`='%i',
							active = '%s',
							username = '%s',
							userlevel = '%i',
							mainadmin='%s',
							advedit='%s',
							games='%s',
							portrange='%s',
							servers='%s',
							theme='%s',
							style='%s',
							slotlimit='%i',
							apiaccess='%s',
							permissions='%s'
						WHERE id = '%i'", array(strtolower($fname),$firstname, $lastname, $phone, $femail, $fsmsemail, $address, $address2, $city, $state, $zip, $country, $extrainfo,$signature , $_REQUEST['lang'], $flimit, $factive, strtolower($fname), $_REQUEST['userlevel'], $fmainadmin, $fadvedit, $ugames, $portrange, $uservers, $usertheme, $userstyle, $fslots, $apiaccess,serialize($permissions), $idd));
		mysql_query($q);
		echo "Saved";
	break;

	case "new": 
		$smarty->display('manageusers/newuser.tpl');
	break;

	case "add":
		if(DEMO == "yes") die("Demo restricted.");
		$uname = sql_query($safesql->query("SELECT name FROM users where name='%s' LIMIT 1;", array($fname))) or die(mysql_error()); $uname = mysql_fetch_row($uname);

		
		if ($fname == $uname[0]) die("User already exists, not adding.");
		if ($fname == "root")  die("Panel User of Root is not allowed.");
		if ($fname == "admin") die("Panel User of Admin is not allowed."); 
		if ($fname == "")  die("Missing field name, not adding.");


		if(!$fpassword){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$fpassword=$Panel->RandomPassword();
		}

		sql_query($safesql->query("INSERT INTO users SET name = '%s', email = '%s', username = '%s', userlevel = '%s', active = '1', phone = '%s', address = '%s',  city = '%s', state = '%s', country = '%s', zip = '%s', extranotes = '%s', firstname = '%s', lastname = '%s', address2 = '%s', joindate = '%s', indexsort='%s'",
			array(strtolower($fname),$femail,$fname,$fuserlevel,$phone,$address,$city,$state,$country,$zip,$extrainfo,$firstname,$lastname,$address2,time(),indexAdmin))) or die(mysql_error());
		$cid = mysql_insert_id();

		mysql_query("UPDATE users SET permissions='a:46:{s:7:\"payment\";s:1:\"1\";s:9:\"donations\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"taxes\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"promotions\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:8:\"products\";a:7:{s:4:\"view\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:10:\"newproduct\";s:1:\"1\";s:8:\"addprice\";s:1:\"1\";s:8:\"newprice\";s:1:\"1\";s:7:\"reorder\";s:1:\"1\";s:12:\"viewpackages\";s:1:\"1\";}s:13:\"productaddons\";a:4:{s:6:\"remove\";s:1:\"1\";s:10:\"removetype\";s:1:\"1\";s:4:\"save\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";}s:8:\"gateways\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"currencies\";a:7:{s:11:\"updaterates\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:17:\"billingcategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"update\";a:2:{s:3:\"run\";s:1:\"1\";s:8:\"download\";s:1:\"1\";}s:12:\"ttcategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"tools\";a:15:{s:6:\"custom\";s:1:\"1\";s:6:\"autoip\";s:1:\"1\";s:12:\"submitautoip\";s:1:\"1\";s:3:\"sql\";s:1:\"1\";s:9:\"submitsql\";s:1:\"1\";s:6:\"backup\";s:1:\"1\";s:8:\"backupv2\";s:1:\"1\";s:4:\"cron\";s:1:\"1\";s:7:\"cleanup\";s:1:\"1\";s:8:\"optimize\";s:1:\"1\";s:12:\"run_optimize\";s:1:\"1\";s:7:\"phpinfo\";s:1:\"1\";s:8:\"phpinfo2\";s:1:\"1\";s:9:\"portcheck\";s:1:\"1\";s:9:\"checkport\";s:1:\"1\";}s:8:\"terminal\";s:1:\"1\";s:8:\"settings\";a:5:{s:4:\"edit\";s:1:\"1\";s:4:\"logs\";s:1:\"1\";s:8:\"testmail\";s:1:\"1\";s:18:\"disableMaintenance\";s:1:\"1\";s:6:\"update\";s:1:\"1\";}s:8:\"schedule\";a:2:{s:6:\"remove\";s:1:\"1\";s:4:\"save\";s:1:\"1\";}s:6:\"portal\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"orders\";a:8:{s:4:\"edit\";s:1:\"1\";s:3:\"run\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:7:\"pending\";s:1:\"1\";s:5:\"fraud\";s:1:\"1\";s:4:\"paid\";s:1:\"1\";s:5:\"saveq\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";}s:6:\"online\";s:1:\"1\";s:6:\"notify\";a:6:{s:4:\"edit\";s:1:\"1\";s:11:\"sendmasspre\";s:1:\"1\";s:8:\"sendmass\";s:1:\"1\";s:4:\"send\";s:1:\"1\";s:7:\"sendpre\";s:1:\"1\";s:7:\"sendall\";s:1:\"1\";}s:10:\"newservice\";a:2:{s:3:\"new\";s:1:\"1\";s:3:\"add\";s:1:\"1\";}s:4:\"news\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:10:\"newmachine\";a:2:{s:3:\"add\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:8:\"machines\";a:21:{s:4:\"edit\";s:1:\"1\";s:9:\"syncvoice\";s:1:\"1\";s:10:\"updateftpd\";s:1:\"1\";s:11:\"installcron\";s:1:\"1\";s:13:\"updatebackend\";s:1:\"1\";s:9:\"massremip\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:8:\"removeip\";s:1:\"1\";s:8:\"updateip\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:8:\"addrange\";s:1:\"1\";s:5:\"addip\";s:1:\"1\";s:6:\"editip\";s:1:\"1\";s:6:\"graphs\";s:1:\"1\";s:7:\"migrate\";s:1:\"1\";s:8:\"migrate2\";s:1:\"1\";s:8:\"migrate3\";s:1:\"1\";s:8:\"migrate4\";s:1:\"1\";s:10:\"directions\";s:1:\"1\";s:10:\"viewdetail\";s:1:\"1\";}s:12:\"installgames\";s:1:\"1\";s:11:\"gameupdates\";a:6:{s:6:\"remove\";s:1:\"1\";s:6:\"manage\";s:1:\"1\";s:3:\"run\";s:1:\"1\";s:4:\"view\";s:1:\"1\";s:7:\"addedit\";s:1:\"1\";s:8:\"doupdate\";s:1:\"1\";}s:5:\"games\";a:9:{s:6:\"export\";s:1:\"1\";s:6:\"import\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:10:\"removeGame\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"emails\";a:9:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:4:\"add2\";s:1:\"1\";s:5:\"edit3\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:8:\"sendtest\";s:1:\"1\";}s:13:\"configbuilder\";a:4:{s:11:\"updateitems\";s:1:\"1\";s:10:\"removeitem\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";}s:8:\"commands\";a:5:{s:3:\"pre\";s:1:\"1\";s:4:\"save\";s:1:\"1\";s:8:\"sendsave\";s:1:\"1\";s:4:\"send\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";}s:6:\"admins\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:6:\"addons\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:15:\"addoncategories\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}s:5:\"voice\";a:11:{s:9:\"removeban\";s:1:\"1\";s:13:\"removeallbans\";s:1:\"1\";s:6:\"addban\";s:1:\"1\";s:9:\"unsuspend\";s:1:\"1\";s:7:\"suspend\";s:1:\"1\";s:9:\"teamspeak\";s:1:\"1\";s:7:\"control\";s:1:\"1\";s:10:\"managevent\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:8:\"savevent\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";}s:8:\"services\";a:17:{s:12:\"taskschedule\";s:1:\"1\";s:12:\"timeschedule\";s:1:\"1\";s:4:\"mass\";s:1:\"1\";s:6:\"fastdl\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"backup\";s:1:\"1\";s:9:\"saveSched\";s:1:\"1\";s:11:\"deleteSched\";s:1:\"1\";s:10:\"changeuser\";s:1:\"1\";s:9:\"unsuspend\";s:1:\"1\";s:7:\"suspend\";s:1:\"1\";s:14:\"restoreconfigs\";s:1:\"1\";s:8:\"editgame\";s:1:\"1\";s:8:\"addaddon\";s:1:\"1\";s:9:\"addaddon2\";s:1:\"1\";s:8:\"newgame2\";s:1:\"1\";}s:7:\"support\";a:13:{s:10:\"massupdate\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:4:\"view\";s:1:\"1\";s:5:\"viewc\";s:1:\"1\";s:9:\"viewreply\";s:1:\"1\";s:10:\"viewactive\";s:1:\"1\";s:3:\"all\";s:1:\"1\";s:14:\"deletetmpfiles\";s:1:\"1\";s:8:\"download\";s:1:\"1\";s:10:\"uploadfile\";s:1:\"1\";}s:4:\"maps\";a:2:{s:7:\"install\";s:1:\"1\";s:9:\"uninstall\";s:1:\"1\";}s:7:\"clients\";a:22:{s:8:\"changepw\";s:1:\"1\";s:13:\"removesubuser\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:3:\"add\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"clone\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:9:\"updatesub\";s:1:\"1\";s:14:\"editsubaccount\";s:1:\"1\";s:13:\"newsubaccount\";s:1:\"1\";s:6:\"export\";s:1:\"1\";s:6:\"import\";s:1:\"1\";s:13:\"resetpassword\";s:1:\"1\";s:10:\"addsubacct\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:6:\"cancel\";s:1:\"1\";s:8:\"moveuser\";s:1:\"1\";s:5:\"move2\";s:1:\"1\";s:5:\"move3\";s:1:\"1\";s:9:\"swapshell\";s:1:\"1\";s:14:\"viewsubaccount\";s:1:\"1\";}s:9:\"dashboard\";s:1:\"1\";s:5:\"files\";a:14:{s:8:\"download\";s:1:\"1\";s:4:\"wget\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:6:\"upload\";s:1:\"1\";s:9:\"doextract\";s:1:\"1\";s:11:\"quickmanage\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:2:\"cd\";s:1:\"1\";s:6:\"rename\";s:1:\"1\";s:5:\"mkdir\";s:1:\"1\";s:6:\"mkfile\";s:1:\"1\";s:11:\"addshortcut\";s:1:\"1\";s:14:\"removeshortcut\";s:1:\"1\";s:12:\"Save Changes\";s:1:\"1\";}s:7:\"console\";s:1:\"1\";s:12:\"serverstatus\";s:1:\"1\";s:7:\"process\";s:1:\"1\";s:7:\"configs\";a:10:{s:3:\"add\";s:1:\"1\";s:3:\"new\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:7:\"execute\";s:1:\"1\";s:6:\"update\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:11:\"editconfigs\";s:1:\"1\";s:7:\"builder\";s:1:\"1\";s:11:\"builderedit\";s:1:\"1\";s:10:\"builderrun\";s:1:\"1\";}s:10:\"cmdbackend\";a:4:{s:4:\"mass\";s:1:\"1\";s:12:\"submitscreen\";s:1:\"1\";s:7:\"viewlog\";s:1:\"1\";s:11:\"downloadlog\";s:1:\"1\";}s:7:\"billing\";a:2:{s:5:\"print\";s:1:\"1\";s:4:\"view\";s:1:\"1\";}s:7:\"modules\";a:6:{s:6:\"update\";s:1:\"1\";s:4:\"edit\";s:1:\"1\";s:6:\"action\";s:1:\"1\";s:6:\"remove\";s:1:\"1\";s:5:\"edit2\";s:1:\"1\";s:3:\"new\";s:1:\"1\";}}' WHERE userlevel cid ='$cid'");
	

		$GameCP->loadIncludes("user");
		$User=new User();
		$GameCP->SetPassword($cid, $fpassword);

		$smarty->assign("showSaved", "true");
		$idd=$cid;
		$_REQUEST['showSaved']="true";
		$_REQUEST['idd']=$idd;
		if(debugging =="0") {
			$mode="edit2";
		} else echo "Saved";
	break;

	case "remove":
		if(DEMO == "yes") die("Demo restricted.<br>"); 
		echo "Removing from users table.<br>";
		sql_query($safesql->query("DELETE FROM users WHERE id='%i'", array($idd))) or die(mysql_error()); 	

		echo "User removed.";
		if(debugging =="0") { echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=" . $url . "/manage/admins.php?mode=edit\">"; }
	break;

	case "edit":
		if(!isset($_REQUEST['displayType']) || (isset($_REQUEST['displayType']) && !$_REQUEST['displayType'])) { 
			if(!isset($_SESSION['gamecp']['admin_display'])) $displayType = "Active";
		}else $_SESSION['gamecp']['admin_display']=$GameCP->whitelist($_REQUEST['displayType']);
		
		if(isset($_SESSION['gamecp']['admin_display'])) $displayType=$_SESSION['gamecp']['admin_display'];

		/* if their not an admin they cant see system users, period */
		if($_SESSION['gamecp']['user']['mainadmin'] !='1' && $displayType == "System") $displayType = "Active";

		/* remember we wanted to see all, right? */
		if(isset($_REQUEST['view']) && $_REQUEST['view'] == "all"){
			$_SESSION['gamecp']['view']['manageclients']="all";
		}elseif(isset($_REQUEST['do']) && $_REQUEST['do'] == "reset") $_SESSION['gamecp']['view']['manageclients']="";
		if(isset($_SESSION['gamecp']['view']['manageclients']) && $_SESSION['gamecp']['view']['manageclients'] == "all") $_REQUEST['view']="all";


		if($displayType == "SystemInactive") {
			$smarty->assign("displayType", "System");
			$sysQuery="AND userlevel >= '1' AND userlevel !='10'";
			$clientActive = "0";
		} else $clientActive = "1";


		/* search */
		if(isset($_REQUEST['do']) && $_REQUEST['do'] == "reset") $_SESSION['searchcontent'] = '';
		if(isset($_POST['searchcontent']) && $_POST['searchcontent'] != "Search Clients") $_SESSION['searchcontent']=$_POST['searchcontent'];

		if(isset($_SESSION['searchcontent']) && $_SESSION['searchcontent']){
			$searchAll ="name LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR email LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR firstname LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll .=" OR lastname LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";

			$searchAll.=" OR clan LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR phone LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR address LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR address2 LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR city LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR state LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR zip LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR website LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";
			$searchAll.=" OR payment LIKE '%".$GameCP->whitelist($_SESSION['searchcontent']) ."%'";

			$viewQ = "AND($searchAll)";
		} else $viewQ='';
		
		$activeQ="active='".$GameCP->whitelist($clientActive)."'";

		if($_SESSION['gamecp']['user']['mainadmin'] != "1"){
			$adminQ = " AND mainadmin != '1'";
		} else $adminQ='';


		/* select */
		$rowUserDetailsQ1 = "SELECT SQL_CALC_FOUND_ROWS *
		FROM users
		WHERE 
		userlevel !='0' AND

		$activeQ 
		$viewQ 
		$adminQ 
		
		ORDER BY username";


		$GameCP->loadIncludes("user");
		$User=new User();

		$UserList=array();
		$rowUserDetailsQ=Smarty_PageControl($rowUserDetailsQ1, "userPage", "userPage");
		while ($rowUserDetails = mysql_fetch_array($rowUserDetailsQ)){
			if($rowUserDetails['firstname'] || $rowUserDetails['lastname']){
				$rowUserDetails['displayname']=$rowUserDetails['firstname'] .' '.$rowUserDetails['lastname'];
			} else $rowUserDetails['displayname']=$rowUserDetails['name'];

			$UserList[]=array(
				"id" => $rowUserDetails['id'],
				"email" => $rowUserDetails['email'],
				"userlevel" => $rowUserDetails['userlevel'],
				"username" => $rowUserDetails['name'], 
				"displayname" => $rowUserDetails['displayname'], 
				"name" => $rowUserDetails['name'],
				"address" => $rowUserDetails['address'],
				"address2" => $rowUserDetails['address2'],
				"city" => $rowUserDetails['city'],
				"state" => $rowUserDetails['state'],
				"zip" => $rowUserDetails['zip'],
				"country" => $rowUserDetails['country'],
				"password" => $User->Password($rowUserDetails['id'])

			);
		}

		if($UserList && count($UserList) > 0)$smarty->assign('rowUserDetails', $UserList);

		$smarty->display("manageusers/manageclients-list-admin.tpl");
	break;
}


if($mode == "edit2"){
	if ($_SESSION['gamecp']['user']['mainadmin'] == "1") {
		$specialid = $idd; 
	} else $specialid = $_SESSION['gamecp']['userinfo']['id']; 

	$resultClient = sql_query($safesql->query("SELECT * FROM users WHERE id='%i' LIMIT 1;", array($specialid))) or die(mysql_error()); 
	$clientInfo=mysql_fetch_array($resultClient);

	if ($clientInfo['userlevel'] == "5" || $clientInfo['userlevel'] == "4") {
		$GameCP->loadIncludes("display");
		$Display=new Display();

		$serversdoh=array();
		$serversowned=unserialize($clientInfo['servers']);
		$serversdoh=$Display->MachineIPList(true, $serversowned);

		$gamesdoh=array();
		$gamesowned=unserialize($clientInfo['games']);

		$result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			if(is_array($gamesowned)){
				if(in_array($row['id'], $gamesowned)){
					$selb="SELECTED";
				} else $selb ="";
			}else $selb='';
			$gamesdoh[]="<option value=\"". $row['id'] ."\" $selb>". $row['name']."</option>";
		}
	}

	if(!$clientInfo['theme']) $clientInfo['theme']=THEME;
	if(!$clientInfo['style']) $clientInfo['style']=styleadmin;

	if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->GetThemes($clientInfo['theme'], $clientInfo['style']);
	}

	$GameCP->loadIncludes("user");
	$User=new User();
	$pw=$GameCP->Password($specialid);
	$clientInfo['password']=$pw;
	$smarty->assign("servers", @$serversdoh);
	$smarty->assign("ugames", @$gamesdoh);

	$smarty->assign("clientInfo", $clientInfo);
	$smarty->assign("gcplang", $clientInfo['lang']);
	$smarty->assign("usrpassword", $pw);
	$smarty->assign("defaultperms", $GameCP->AdminPermissions());

	$smarty->assign("userInfoextranotes", $clientInfo['extranotes']);
	$smarty->assign("userInfousername", $clientInfo['name']);
	$smarty->assign("userperms", unserialize($clientInfo['permissions']));
	$smarty->assign("userInfolastlogin", $clientInfo['lastlogin']);

	$smarty->display('manageusers/edituser.tpl');
}


if(!isset($_REQUEST['mode']) || isset($_REQUEST['mode']) &&  $_REQUEST['mode'] != "update") require_once(path.'/includes/core/editable/footer.inc.php');

?>