<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";
 
$GameCP->CheckPermissions('billingcategories');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (categories)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (categories)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}


if ($mode == "update" && DEMO != "yes") { 
	sql_query($safesql->query("UPDATE categories SET 
					rank='%i',
					name='%s',
					img='%s',
					status='%i',
					description='%s'
					WHERE id='%i'", array(
					$GameCP->whitelist($rank, "int"),	
					$GameCP->whitelist($name, "clean"),	
					$GameCP->whitelist($img, "clean"),	
					$GameCP->whitelist($status, "clean"),	
					$GameCP->whitelist($description, "web"),	
					$GameCP->whitelist($catid, "int")))) or die(mysql_error());
	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "add" && DEMO != "yes") {
	sql_query($safesql->query("INSERT INTO categories SET 
					rank='%i',
					name='%s',
					img='%s',
					status='%i',
					description='%s'", array(
					$GameCP->whitelist($rank, "i"),	
					$GameCP->whitelist($name, "clean"),	
					$GameCP->whitelist($img, "clean"),	
					$GameCP->whitelist($status, "int"),	
					$GameCP->whitelist($description, "web")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";

}

if ($mode == "remove" && DEMO != "yes") {
	sql_query($safesql->query("DELETE FROM categories WHERE id='%i' LIMIT 1", array($GameCP->whitelist($catid, "int")))) or die(mysql_error());
	$smarty->assign("showSaved", true);
	$mode = "edit";
}


if($mode == "edit") { 
	$categories=array();
	$result = sql_query("SELECT * FROM categories ORDER BY rank") or die(mysql_error());
	while ($row = mysql_fetch_array($result)) $categories[]=$row;
	$smarty->assign("categoryList",$categories);
	$smarty->display("categories/category-list.tpl");
} 


if($mode == "edit2") {
	$info = sql_query($safesql->query("SELECT * FROM categories WHERE id = '%i' LIMIT 1", array($GameCP->whitelist($catid, "int")))) or die(mysql_error());
	$categoryInfo = mysql_fetch_array($info);


	$smarty->assign("categoryInfo",$categoryInfo);
	$smarty->assign("catid",$catid);

	$smarty->display("categories/category-edit.tpl");
}

if($mode =="new"){ 
	$smarty->display("categories/category-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>