<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('currencies');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (currencies)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (currencies)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}


if($mode == "updaterates" && DEMO != "yes"){
	$basename=strtoupper(currencyName);
	$result = sql_query("SELECT * FROM currencies") or die(mysql_error());

	while ($row = mysql_fetch_array($result)){
		$data=$GameCP->Send('https://www.google.com/ig/calculator?hl=en&q=1'.$basename.'=?'.strtoupper($row['code']), array(), 'GET');


		if($data){
			$res = explode('"', $data); 
			$converted_amount = explode(' ', $res[3]);
			$exchange = $converted_amount[0];
			if($exchange){ sql_query($safesql->query("UPDATE currencies SET 
					rate='%s' WHERE id='%i'", array(
					$GameCP->whitelist(round($exchange, 6), "clean"),	
					$GameCP->whitelist($row['id'], "int")))) or die(mysql_error());
			}
		}
	}
	$mode="edit";

}

if ($mode == "update" && DEMO != "yes") { 
	sql_query($safesql->query("UPDATE currencies SET 
					code='%s',
					prefix='%s',
					suffix='%s',
					format='%s',
					rate='%s' WHERE id='%i'", array(
					$GameCP->whitelist($code, "clean"),	
					$GameCP->whitelist($prefix, "clean"),	
					$GameCP->whitelist($suffix, "clean"),	
					$GameCP->whitelist($format, "clean"),	
					$GameCP->whitelist($rate, "clean"),
					$GameCP->whitelist($curid, "int")))) or die(mysql_error());
	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "add" && DEMO != "yes") {
	sql_query($safesql->query("INSERT INTO currencies SET 
					code='%s',
					prefix='%s',
					suffix='%s',
					format='%s',
					rate='%s'", array(
					$GameCP->whitelist($code, "clean"),	
					$GameCP->whitelist($prefix, "clean"),	
					$GameCP->whitelist($suffix, "clean"),	
					$GameCP->whitelist($format, "clean"),	
					$GameCP->whitelist($rate, "clean")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";

}

if ($mode == "remove" && DEMO != "yes") {
	sql_query($safesql->query("DELETE FROM currencies WHERE id='%i' LIMIT 1", array($GameCP->whitelist($curid, "int")))) or die(mysql_error());
	$smarty->assign("showSaved", true);
	$mode = "edit";
}


if($mode == "edit") { 
	$currencies=array();
	$result = sql_query("SELECT * FROM currencies") or die(mysql_error());
	while ($row = mysql_fetch_array($result)) $currencies[]=$row;
	$smarty->assign("currencyList",$currencies);
	$smarty->display("currencies/currency-list.tpl");
} 


if($mode == "edit2") {
	$info = sql_query($safesql->query("SELECT * FROM currencies WHERE id = '%i' LIMIT 1", array($GameCP->whitelist($curid, "int")))) or die(mysql_error());
	$currencyInfo = mysql_fetch_array($info);


	$smarty->assign("currencyInfo",$currencyInfo);
	$smarty->assign("curid",$curid);

	$smarty->display("currencies/currency-edit.tpl");
}

if($mode =="new"){ 
	$smarty->display("currencies/currency-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>