<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";
 
$GameCP->CheckPermissions('gateways');

if(usebilling != "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (gateways)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (gateways)");
}

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}



if ($mode == "update") { 
	if(DEMO == "yes") die("Demo restricted.<br>");
	sql_query($safesql->query("UPDATE gateways SET name='%s', fullname='%s', status='%s', testing='%s', 
	value1='%s', 
	value2='%s',
	value3='%s',
	value4='%s',
	value5='%s',
	value6='%s',
	value7='%s',
	value8='%s',
	value9='%s',
	value10='%s'
	
	WHERE id='%i'", array(
		$GameCP->whitelist($fname, "clean"),
		$GameCP->whitelist($fullname, "clean"),
		$GameCP->whitelist($status, "clean"),
		$GameCP->whitelist($testing, "clean"),
		$GameCP->whitelist($value1, "clean"),
		$GameCP->whitelist($value2, "clean"),
		$GameCP->whitelist($value3, "clean"),
		$GameCP->whitelist($value4, "clean"),
		$GameCP->whitelist($value5, "clean"),
		$GameCP->whitelist($value6, "clean"),
		$GameCP->whitelist($value7, "clean"),
		$GameCP->whitelist($value8, "clean"),
		$GameCP->whitelist($value9, "clean"),
		$GameCP->whitelist($value10, "clean"),
		$GameCP->whitelist($gid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";
}

if ($mode == "add") {
	if(DEMO == "yes") die("Demo restricted.<br>");
	sql_query($safesql->query("INSERT INTO gateways SET name='%s', fullname='%s', status='%s', testing='%s', value1='%s', value2='%s', value3='%s',
			value4='%s',
	value5='%s',
	value6='%s',
	value7='%s',
	value8='%s',
	value9='%s',
	value10='%s'
		", array(	
		$GameCP->whitelist($fname, "clean"),
		$GameCP->whitelist($fullname, "clean"),
		$GameCP->whitelist($status, "clean"),
		$GameCP->whitelist($testing, "clean"),
		$GameCP->whitelist($value1, "clean"),
		$GameCP->whitelist($value2, "clean"),
		$GameCP->whitelist($value3, "clean"),
		$GameCP->whitelist($value4, "clean"),
		$GameCP->whitelist($value5, "clean"),
		$GameCP->whitelist($value6, "clean"),
		$GameCP->whitelist($value7, "clean"),
		$GameCP->whitelist($value8, "clean"),
		$GameCP->whitelist($value9, "clean"),
		$GameCP->whitelist($value10, "clean")
		))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	if(debugging == "0"){
		$mode = "edit";
	} else echo "Saved";

}

if ($mode == "remove") {
	if(DEMO == "yes") die("Demo restricted.<br>");
	sql_query($safesql->query("DELETE FROM gateways WHERE id='%i' LIMIT 1", array($GameCP->whitelist($gid, "int")))) or die(mysql_error());

	$smarty->assign("showSaved", true);
	$mode = "edit";

}


if($mode == "edit") { 

	$gateways=array();
	$result = sql_query("SELECT * FROM gateways ORDER BY 'fullname'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){
		$gateways[]=$row;
	} 
	$smarty->assign("gatewayList",$gateways);
	$smarty->display("managegateways/gateways-list.tpl");


} // end edit ng price

if($mode == "edit2") {

	$info = sql_query($safesql->query("SELECT * FROM gateways WHERE id = '%i' LIMIT 1", array($GameCP->whitelist($gid, "int")))) or die(mysql_error());
	$gatewayInfo = mysql_fetch_array($info);

	$smarty->assign("gatewayName",$gatewayInfo['name']);
	$smarty->assign("gatewayFullName",$gatewayInfo['fullname']);
	$smarty->assign("gatewayActive",$gatewayInfo['status']);
	$smarty->assign("gatewayTesting",$gatewayInfo['testing']);
	$smarty->assign("value1",$gatewayInfo['value1']);
	$smarty->assign("value2",$gatewayInfo['value2']);
	$smarty->assign("value3",$gatewayInfo['value3']);
	$smarty->assign("value4",$gatewayInfo['value4']);
	$smarty->assign("value5",$gatewayInfo['value5']);
	$smarty->assign("value6",$gatewayInfo['value6']);
	$smarty->assign("value7",$gatewayInfo['value7']);
	$smarty->assign("value8",$gatewayInfo['value8']);
	$smarty->assign("value9",$gatewayInfo['value9']);
	$smarty->assign("value10",$gatewayInfo['value10']);

	$smarty->assign("gid",$gid);

	$smarty->display("managegateways/gateways-edit.tpl");

} // end edit ng price

if($mode =="new"){ 
	$smarty->display("managegateways/gateways-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>