<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/
if (isset($_REQUEST['mode']) && ($_REQUEST['mode'] == "print" || $_REQUEST['mode'] == "remove" || $_REQUEST['mode'] == "removesub" ||  $_REQUEST['mode'] == "addsub" || $_REQUEST['mode'] == "updatecharge" || $_REQUEST['mode'] == "removecharge" || $_REQUEST['mode'] == "addcharge")) $noheader=true;
$billingPage=true;
require('../../includes/core/includes/user/session.inc.php');
require('../../includes/config.inc.php');

if(usebilling != "1"){
	if(isset($noheader)) exit;
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled. (billing)");
}

if(isset($_SESSION['gamecp']['basic']) && $_SESSION['gamecp']['basic'] == "1"){
	if(isset($noheader)) exit;
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("This feature is not enabled with the current license. (billing)");
}

if(isset($_SESSION['gamecp']['subaccount']) && !in_array('8', $_SESSION['gamecp']['subuser']['perms'])){
	if(isset($noheader)) exit;
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3" && $_SESSION['gamecp']['userinfo']['ulevel'] != "5") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$smarty->assign("billingPage", "true");

$GameCP->loadIncludes("billing");
$Billing=new Billing();

if(isset($gmid))$gmid=$GameCP->whitelist($gmid,"int");
if(isset($idd))$idd=$GameCP->whitelist($idd,"int");
if(isset($bid))$bid=$GameCP->whitelist($bid,"int");

if($mode == "edit2") $mode="edit"; 

if($mode =="getprice"){
	$packageInfo = sql_query($safesql->query("SELECT cost, fee, name, quarterly, semiannualy, annauly, 2years FROM prices WHERE id='%i'", array($GameCP->whitelist($pid, "int")))) or die(mysql_error());
	$package = mysql_fetch_array($packageInfo);
	$term="cost";
	if($term == "31") $term="cost";
	if($term == "91") $term="quarterly";
	if($term == "182") $term="semiannualy";
	if($term == "365") $term="annauly";
	if($term == "730") $term="2years";

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	echo $Panel->FormatNumber($package[$term], $_REQUEST['cid']);
}

if($mode =="notifycreated"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	$userInfo=$Panel->GetUser($idd);

	$billQ = sql_query($safesql->query("SELECT * FROM billing WHERE id = '%i'", array($GameCP->whitelist($bid, "int")))) or die(mysql_error());
	$bill = mysql_fetch_assoc($billQ);


	$GameCP->loadIncludes("email");

	$Email->templatename = "Billing-Add";

	$Email->userid = $idd;
	$Email->GetTemplateStuff();

	$Email->ubillid = $bid;


	$Email->usegamedata = true;
	$Email->usevoicedata = true;
	$Email->usebilldata = true;

	$extravars=array();
	$extravars[]=array("var" => "\$Var1", "value" => $bid);
	$extravars[]=array("var" => "\$Var2", "value" => $bill['gross']);
	$extravars[]=array("var" => "\$Var3", "value" => $bill['fee']);
	$Email->ReplaceStuff($extravars);

	$Email->send();

	$Panel->ErrorHeader("Notified ".$userInfo['email']);
	header("location: $url/manage/billing/index.php?mode=edit&bid=$bid&idd=$idd&showSaved=true");
}

if($mode =="notify"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	$userInfo=$Panel->GetUser($idd);

	$billQ = sql_query($safesql->query("SELECT * FROM billing WHERE id = '%i'", array($GameCP->whitelist($bid, "int")))) or die(mysql_error());
	$bill = mysql_fetch_assoc($billQ);

	$notifybill= $Billing->DateDifference($bill['date'], date(dateformat, strtotime('now')));
	if($notifybill > 0){
		$templatename="Billing-Past";
	} else $templatename="Billing-Pre";

	$GameCP->loadIncludes("email");
	$Email=new Email();
	$Email->emailto = $userInfo['email'];

	$Email->templatename=$templatename;
	$Email->GetTemplateStuff();
	$Email->userid = $idd;
	$Email->ubillid=$bid;
	$Email->usegamedata = true;
	$Email->usevoicedata = true;
	$Email->usebilldata = true;

	$Email->BillDaysTill=$notifybill;
	$Email->ReplaceStuff();
	$Email->send();
	
	$Panel->ErrorHeader("Notified ".$userInfo['email']);
	header("location: $url/manage/billing/index.php?mode=edit&bid=$bid&idd=$idd&showSaved=true");
}

if($mode == "refund"){
	$Billing->Refund($bid, $refundtotal, $refundtype, $refundpayments);
	echo "Saved";
	if(debugging == "0") header("location: $url/manage/billing/index.php?mode=edit&bid=$bid&idd=$idd&showSaved=true");
}

if ($mode == "addcredit") { 
	$Billing->Credit($bid, $_REQUEST['credit']);
	unset($_SESSION['gamecp']['payment']['credit']);
	echo "Saved";
	if(debugging == "0") header("location: $url/manage/billing/index.php?mode=edit&bid=$bid&idd=$idd&showSaved=true");
} 

if ($mode == "addpayment") { 
	if(!$payment['notify']){
		$notify=false;
	} else $notify=true;
	$Billing->AddPayment($bid, $payment['paid'], '', $payment['transactionid'], $payment['gateway'], $payment['fee'],$payment['date'], $payment['ip'],$notify);
	echo "Saved";
	if(debugging == "0") header("location: $url/manage/billing/index.php?mode=edit&bid=$bid&idd=$idd&showSaved=true");
} 

if ($mode == "addcharge") { 	
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	sql_query($safesql->query("INSERT INTO charges SET date='%s' , sum='%s' , reason='%s'", array(
		$GameCP->whitelist($date, "clean"),
		$GameCP->whitelist($Panel->RemFormatNumber($gross), "clean"),
		$GameCP->whitelist($reason, "clean")))) or die(mysql_error());
	echo "Saved";
	if(debugging == "0") header("location: $url/billing/index.php?view=showall&showSaved=true");
} 

if ($mode == "removecharge") { 	
	sql_query($safesql->query("DELETE FROM charges WHERE id='%i'", array($GameCP->whitelist($chid, "int")))) or die(mysql_error()); 	
	header("location: $url/billing/index.php?view=showall&showSaved=true");
} 

if ($mode == "updatecharge") {	
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	sql_query($safesql->query("UPDATE charges SET date ='%s', sum ='%s', reason='%s' WHERE id='%i'", array(
		$GameCP->whitelist($date, "clean"),
		$GameCP->whitelist($Panel->RemFormatNumber($gross), "clean"),
		$GameCP->whitelist($reason, "clean"),
		$GameCP->whitelist($chid, "clean")))) or die(mysql_error()); 	
	if(debugging == "0"){
			header("location: $url/billing/index.php?view=showall&showSaved=true");
	} else echo "Saved";
} 

if($mode == "charge") { 
	$smarty->assign("getCharge", array("1" => date(dateformat, time())));
	$smarty->display("billing/managecharges.tpl");
}

if($mode == "editcharge") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$getCharge = sql_query($safesql->query("SELECT id, date, sum, reason FROM charges WHERE id = '%i'", array($GameCP->whitelist($chid, "int")))) or die(mysql_error());
	$getCharge = mysql_fetch_row($getCharge);
	$getCharge[2]=$Panel->FormatNumber($getCharge[2]);
	
	$smarty->assign("getCharge", $getCharge);

	$smarty->display("billing/managecharges.tpl");
}

if ($mode == "addmaster") { 	
	/* validate & clean */
	if(!$idd) die("Missing a required field.");

	$status=$GameCP->whitelist($status, "text");
	$subscr_id=$GameCP->whitelist($subscr_id, "useredit");
	$update=$GameCP->whitelist($update, "useredit");
	$date=$GameCP->whitelist($date, "useredit");
	if(!$suspend) $suspend="0";
	if($daystill == "") $daystill = "0";

	sql_query($safesql->query("INSERT INTO billing SET cid='%i', date='%s', status='%s', `update`='%s', daystill='%s', subscr_id='%s', suspend='%i';",
					array($idd, $date, $status, $update, $daystill, $subscr_id, $suspend))) or die(mysql_error());
	$bid=mysql_insert_id();

	echo "Saved";
	if(debugging == "0") header("location: $url/manage/billing/index.php?mode=edit&idd=$idd&bid=$bid");
} 

if ($mode == "addsub") { 	
	if(!$pid) $pid="";

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	/* insert the bills package */
	sql_query($safesql->query("INSERT INTO userbills SET cid='%i' , bid='%i' , pid='%i' , gross='%s', fee='%s', description='%s', taxed='%i'", array(
		$GameCP->whitelist($idd, "int"),
		$GameCP->whitelist($bid, "int"),
		$GameCP->whitelist($pid, "int"),
		$GameCP->whitelist($Panel->RemFormatNumber(str_replace(",", '', $gross)), "clean"),
		$GameCP->whitelist($Panel->RemFormatNumber(str_replace(",", '', $fee)), "clean"),
		$GameCP->whitelist($description, "clean"),
		$GameCP->whitelist($taxed, "int")))) or die(mysql_error());

	/* update the bills overall total */
	$Billing->updateBillTotals($bid);


	/* new! notify users when bill was created, wewt! */
	if($_POST['notify'] == "1"){

		$GameCP->loadIncludes("email");

		$Email->templatename = "Billing-Add";

		$Email->userid = $idd;
		$Email->GetTemplateStuff();

		$Email->ubillid = $bid;


		$Email->usegamedata = true;
		$Email->usevoicedata = true;
		$Email->usebilldata = true;

		$extravars=array();
		$extravars[]=array("var" => "\$Var1", "value" => $bid);
		$extravars[]=array("var" => "\$Var2", "value" => $gross);
		$extravars[]=array("var" => "\$Var3", "value" => $fee);
		$Email->ReplaceStuff($extravars);

		$Email->send();

	}

	echo "Saved";
	if(debugging == "0") header("location: $url/manage/billing/index.php?mode=view&idd=$idd");
}

if ($mode == "updateub") {	
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$ub=$_REQUEST['ub'];
	foreach($ub as $ubb => $uba){
		if($ubb == "new"){
			$newinsert=$ub['new'];
			unset($ub['new']);
		} else sql_query($safesql->query("UPDATE userbills SET 
						description='%s',
						gross='%s',
						fee='%s',
						pid='%s',
						taxed='%i'
						WHERE id='%i';",
							array($GameCP->whitelist($uba['description'],'clean'),$GameCP->whitelist(str_replace(",", '', $Panel->RemFormatNumber($uba['gross'], $cid)),'int'),$GameCP->whitelist(str_replace(",", '', $Panel->RemFormatNumber($uba['fee'], $cid)),'int'),$GameCP->whitelist($uba['pid'],'int'),$GameCP->whitelist(@$uba['taxed'],'int'), $ubb )));

	}
	if($newinsert){
		$uba=$newinsert;
		if($uba['description'] || $uba['gross'] || $uba['fee']) sql_query($safesql->query("INSERT INTO userbills SET 
				description='%s',
				gross='%s',
				fee='%s',
				bid='%s',
				cid='%s',
				pid='%s',
				taxed='%s';",
					array($GameCP->whitelist($uba['description'],'clean'),$GameCP->whitelist(str_replace(",", '', $Panel->RemFormatNumber($uba['gross'], $cid)),'int'),$GameCP->whitelist(str_replace(",", '', $Panel->RemFormatNumber($uba['fee'], $cid)),'int'), $GameCP->whitelist($bid,'int'),$GameCP->whitelist($idd,'int'), $GameCP->whitelist($uba['pid'],'int'),$GameCP->whitelist(@$uba['taxed'],'int')   )))or die(mysql_error());

	}
	$Billing->updateBillTotals($bid);
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}

if ($mode == "update") {	
	if(!$suspend) $suspend="0";
	if(!isset($services)) $services=array();
	if(!isset($recurring)) $recurring="1";
	if($recurring == "yes"){
		$recurring="0";
	} else $recurring="1";

	$services=serialize($services);
	sql_query($safesql->query("UPDATE billing SET status='%s', date='%s', subscr_id='%s', daystill='%s', suspend='%s', services='%s', `update`='%i' WHERE id='%s'", array(
		$GameCP->whitelist($status, "clean"),
		$GameCP->whitelist($date, "clean"),
		$GameCP->whitelist($subscr_id, "clean"),
		$GameCP->whitelist($daystilldate, "clean"),
		$GameCP->whitelist($suspend, "clean"),
		$services,
		$GameCP->whitelist($recurring, "int"),
		$GameCP->whitelist($bid, "int")))) or die(mysql_error()); 
	
	if(isset($alt_gross) || isset($alt_fee)) sql_query($safesql->query("UPDATE billing SET gross='%s', fee='%s' WHERE id = '%i'", array(
		$GameCP->whitelist(@$alt_gross, "clean"),
		$GameCP->whitelist(@$alt_fee, "clean"),
		$GameCP->whitelist($bid, "int"))), "updating bill totals 3") or die(mysql_error());

	if(debugging == "0"){
		if(@$_SESSION['gamecp']['view']['userbill'] != ""){
			$mode="view";
			$idd=$_SESSION['gamecp']['view']['userbill'];
		} else $mode="edit";
	} else echo "Saved";
}

if ($mode == "remove") { 	
	$Billing->Remove($bid);
	if(@$_SESSION['gamecp']['view']['userbill'] != ""){
		header("location: $url/manage/billing/index.php?mode=view&idd=".$_SESSION['gamecp']['view']['userbill']."");
	} else header("location: $url/billing/index.php?view=".$_SESSION['gamecp']['view']['billview']);
} 

if ($mode == "removesub") { 
	if(!$bid){ 
		echo "Bill id required."; 
	}elseif(!$subid){
		echo "Sub-Bill id required."; 
	} else {
		$BillInfoQ=sql_query($safesql->query("SELECT * FROM userbills WHERE id='%i'", array($GameCP->whitelist($subid, "int")))) or die(mysql_error()); 	
		$BillInfo=mysql_fetch_array($BillInfoQ);
		$bcid=$BillInfo['cid'];

		sql_query($safesql->query("DELETE FROM userbills WHERE id='%i'", array($GameCP->whitelist($subid, "int")))) or die(mysql_error()); 	
		$Billing->updateBillTotals($bid);
	}

	if(@$_SESSION['gamecp']['view']['userbill'] != ""){
		header("location: $url/manage/billing/index.php?mode=view&idd=".$_SESSION['gamecp']['view']['userbill']."");
	} else header("location: $url/billing/index.php?view=showall");
}

if ($mode == "removepayment") { 
	if(!$payid){ 
		echo "Bill id required."; 
	} else {
		sql_query($safesql->query("DELETE FROM payments WHERE id='%i'", array($GameCP->whitelist($payid, "int")))) or die(mysql_error()); 	
		$Billing->updateBillTotals($bid);
	}
}

if($mode == "view") { 
	if(!isset($view)) $view='';
	 if($view == "overview") { 
		if($idd){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$smarty->assign("userInfo", $Panel->GetUser($idd));
			$smarty->assign("billingInfo", $Billing->GetUserTotals($idd));
			$smarty->assign("nextbills", $Billing->GetUserNextBills($idd));
		}
		$smarty->assign("view", $view);
		$smarty->display("billing/user-overview.tpl");

	 } else {
		if(isset($_REQUEST['idd'])) $_SESSION['gamecp']['view']['userbill'] = $_REQUEST['idd'];
		$_SESSION['gamecp']['view']['billview'] = $view;
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		
		if($idd)$smarty->assign("userInfo", $Panel->GetUser($idd));

		if(!$view)$view="showall";
		$smarty->assign("view", $view);


		$smarty->display("billing/user-bills.tpl");
	 }
}

if($mode == "add1") {
	$resultClient = sql_query("SELECT * FROM users  WHERE active='1' AND userlevel != '1' AND userlevel != '2' AND userlevel != '3'  AND userlevel != '1'  AND userlevel != '4'  AND userlevel != '5' ORDER BY name ASC") or die(mysql_error());
	$i="0";
	$users=array();
	while ($row = mysql_fetch_array($resultClient)) {
		$users[$i]['id']=$row['id'];
		$users[$i]['name']=$row['name'];
		$i++;
			
	}
	$smarty->assign("users", $users);
	$smarty->assign("today", date(dateformat, time()));
	
	$smarty->display("billing/add-master.tpl");
}

if($mode == "edit") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	$i="0";
	$userInfo=array();
	$resultClient = sql_query($safesql->query("SELECT U.name, B.date, B.status, B.subscr_id, B.daystill, B.suspend, B.promo, B.services, U.id as 'cid', B.gross, B.fee, B.taxtotal, B.taxes, B.update, U.credit, U.email,U.firstname, U.lastname FROM billing B, users U WHERE B.cid='%i' AND B.id='%i' AND B.cid = U.id ORDER BY `date` DESC", array($GameCP->whitelist($idd, "int"),$GameCP->whitelist($bid, "int")))) or die(mysql_error());
	$row = mysql_fetch_array($resultClient);
	$userInfo[$i]['date']=$row['date'];
	$userInfo[$i]['name']=$row['name'];
	$userInfo[$i]['firstname']=$row['firstname'];
	$userInfo[$i]['lastname']=$row['lastname'];
	$userInfo[$i]['status']=$row['status'];
	$userInfo[$i]['daystill']=$row['daystill'];
	$userInfo[$i]['subscr_id']=$row['subscr_id'];
	$userInfo[$i]['suspend']=$row['suspend'];
	$userInfo[$i]['gross']=$row['gross'];
	$userInfo[$i]['fee']=$row['fee'];
	$userInfo[$i]['credit']=$row['credit'];
	$userInfo[$i]['update']=$row['update'];
	$userInfo[$i]['email']=$row['email'];
	$smarty->assign("cid", $row['cid']);
	$smarty->assign("Panel", $Panel);
	$daysTill = $row['daystill']; 	
	$theDate = $row['date'];
	$cid=$row['cid'];
	



	if($theDate) $dueDate = strtotime(date(dateformat, strtotime($theDate)) . " +".$daysTill." day");

	$userInfo[$i]['duedate']=$dueDate;

	$prom=unserialize($row['promo']);
	$promo=array();
	if(is_array($prom)) foreach($prom as $p => $mo) $promo[]=array("name" => $p, "id" => $mo['id'], "total" => $mo['total']);

	$userbill = sql_query($safesql->query("SELECT * FROM userbills WHERE bid='%i'", array($GameCP->whitelist($bid, "int"))), "updating bill totals") or die(mysql_error());
	$ub=array();
	while($ubq = mysql_fetch_array($userbill)){
		$pName = sql_query("SELECT P.name, UP.name FROM packages P, prices UP WHERE UP.id = '".$ubq['pid']."' AND UP.pid = P.id") or die(mysql_error());
		$pName = mysql_fetch_row($pName);
		$ubq['pname']=$pName[0];
		$ubq['name']=$pName[1];
		$ubq['gross']=$Panel->FormatNumber($ubq['gross'], $row['cid'], false);
		$ubq['fee']=$Panel->FormatNumber($ubq['fee'], $row['cid'], false);
		$ub[]=$ubq;
	}
	$smarty->assign("userbills", $ub);


	$total = sql_query($safesql->query("SELECT sum(gross), sum(fee) FROM userbills WHERE bid='%i'", array($GameCP->whitelist($bid, "int")))) or die(mysql_error());
	$total = mysql_fetch_array($total);
	$totalGross = $Panel->FormatNumber($total[0]);
	$totalFee = $Panel->FormatNumber($total[1]);

	$smarty->assign("subtotal", $totalGross);
	$smarty->assign("totalFee", $totalFee);
	$smarty->assign("taxitems", unserialize($row['taxes']));
	$smarty->assign("totaltax", $row['taxtotal']);

	$smarty->assign("totalGross", $Panel->FormatNumber($Panel->RemFormatNumber($totalGross)+$Panel->RemFormatNumber($row['taxtotal']), $row['cid'], true));


	$currentServices=unserialize($row['services']);
	if(!is_array($currentServices)) $currentServices=array();
	$clientServices=array();
	$servicesQ = sql_query($safesql->query("SELECT UG.id, G.name FROM usergames UG, game G WHERE UG.cid='%i' AND UG.gid = G.id;", array($GameCP->whitelist($idd, "int"))));
	while($services = mysql_fetch_array($servicesQ)){
		$services['type']="game";
		if(in_array("game".$services['id'], $currentServices)) $services['selected'] = true;
		$clientServices[]=$services;
	}

	$servicesQ = sql_query($safesql->query("SELECT id, voicetype as 'name' FROM uservoice WHERE cid='%i'", array($GameCP->whitelist($idd, "int"))));
	while($services = mysql_fetch_array($servicesQ)){
		$services['type']="voice";
		if($services['name']=="ts3")$services['name']="Teamspeak 3";
		if($services['name']=="ts2")$services['name']="Teamspeak 2";
		if($services['name']=="vent")$services['name']="Ventrilo";
		if(in_array("voice".$services['id'], $currentServices)) $services['selected'] = true;
		$clientServices[]=$services;
	}

	$servicesQ = sql_query($safesql->query("SELECT UG.id, G.name FROM module_services UG, prices G WHERE UG.cid='%i' AND UG.pid = G.id;", array($GameCP->whitelist($idd, "int"))));
	while($services = mysql_fetch_array($servicesQ)){
		$services['type']="module";
		if(in_array("module".$services['id'], $currentServices)) $services['selected'] = true;
		$clientServices[]=$services;
	}


	$smarty->assign("userInfo", $userInfo);
	$smarty->assign("clientServices", $clientServices);
	$smarty->assign("promo", $promo);
	$smarty->assign("idd", $idd);
	$smarty->assign("bid", $bid);
	if(isset($_REQUEST['SERVER_URI'])) $smarty->assign("uri", $_REQUEST['SERVER_URI']);

	$payments=array();
	$pmi=0;
	$balance='';


	if(isset($_SESSION['gamecp']['subuser']['id'])){
		$billPayment = sql_query($safesql->query("SELECT total, time, cid, subid, ip, id, transactionid, gateway, fee FROM payments WHERE subid='%i' AND bid='%i';", array($GameCP->whitelist($_SESSION['gamecp']['subuser']['id'], "int"),$GameCP->whitelist($bid, "clean"))), "total payments on $bid");
	} else $billPayment = sql_query($safesql->query("SELECT total, time, cid, subid, ip, id, transactionid, gateway, fee FROM payments WHERE bid='%i';", array($GameCP->whitelist($bid, "int"))), "total payments on $bid");

	$payTotal="";
	if(mysql_num_rows($billPayment) > 0){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		while ($payrow = mysql_fetch_array($billPayment)) {

			if($payrow['subid']){
				$userInfo=$Panel->GetUser($payrow['subid'], '', true);
			} else $userInfo=$Panel->GetUser($payrow['cid'], '');
			
			$balance=$Panel->RemFormatNumber($balance)+$Panel->RemFormatNumber($payrow[0]);
			$paidbyname=$userInfo['name'];
			$payTotal=$Panel->RemFormatNumber($payTotal)+$Panel->RemFormatNumber($payrow[0]);

			$payments[$pmi] =array("total" => $Panel->FormatNumber($payrow[0], $row['cid'], true),"fee" => $Panel->FormatNumber($payrow['fee'], $row['cid'], true), "time" => $payrow[1], "ip" => $payrow[4], "id" => $payrow[5], "paidby" => $paidbyname, "cid"=>$row['cid'], "transactionid" => $payrow['transactionid'], "gateway" => $payrow['gateway']);
			$pmi++;
		} 
	}
	$smarty->assign("payTotal", $Panel->FormatNumber($payTotal));
	$smarty->assign("paymentList", $payments);

	
	$gateways=array();
	$result = sql_query("SELECT * FROM gateways WHERE status ='1' ORDER BY 'fullname'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)) $gateways[]=$row;
	$smarty->assign("gatewayList",$gateways);


	$smarty->assign("zero", $Panel->FormatNumber("0.00", $cid, true));

	$smarty->display("billing/edit-master.tpl");
}

if($mode == "getpackages"){
	$sql = "SELECT SQL_CALC_FOUND_ROWS * FROM packages WHERE name !=''";
	$result=Smarty_PageControl($sql, 'billpackage', 'billpackageVar', '8');
	$p=array();
	while ($pg = mysql_fetch_assoc($result)) $p[]=$pg;
	$smarty->assign("p", $p);
	$smarty->display("billing/bill-product.tpl");
}

if($mode == "getprices"){
	$sql = $safesql->query("SELECT SQL_CALC_FOUND_ROWS UP.*, P.name as 'pname' FROM prices UP, packages P WHERE UP.pid='%i' AND P.id='%i'", array($_REQUEST['pid'], $_REQUEST['pid']));
	$result=Smarty_PageControl($sql, 'billpackage', 'billpackageVar');
	$p=array();
	while ($pg = mysql_fetch_assoc($result)){
		if($daystill == "31"){
			$pg['total']=$pg['cost'];
		} elseif($daystill == "91"){
			$pg['total']=$pg['quarterly'];
		} elseif($daystill == "182"){
			$pg['total']=$pg['semiannualy'];
		} elseif($daystill == "365"){
			$pg['total']=$pg['annauly'];
		} elseif($daystill == "730"){
			$pg['total']=$pg['2years'];
		} elseif($daystill == "0") $pg['total']=$pg['cost'];
		$p[]=$pg;
	}
	$smarty->assign("p", $p);
	$smarty->display("billing/bill-product.tpl");
}


if($mode == "new") { 
	$clientInfo = sql_query($safesql->query("SELECT name, id FROM users WHERE id='%i'", array($GameCP->whitelist($idd, "int")))) or die(mysql_error());
	$row = mysql_fetch_array($clientInfo); 
	$idd = $row['id'];
	$ncid = $row['name'];

	$smarty->assign("ncid", $ncid);
	$smarty->assign("idd", $idd);
	$smarty->assign("today", date(dateformat, time()));

	$smarty->display("billing/add-master.tpl");
}

if($mode == "newsub") { 
	if(!$idd) die("User required.");

	$clientInfo = sql_query($safesql->query("SELECT name, id FROM users WHERE id='%i'", array($GameCP->whitelist($idd, "int")))) or die(mysql_error());
	$row = mysql_fetch_array($clientInfo); $idd = $row['id']; $ncid = $row['name'];
				
	$billInfo = sql_query($safesql->query("SELECT date, daystill, status, `update` FROM billing WHERE id='%i'", array($GameCP->whitelist($bid, "int")))) or die(mysql_error());
	$billInfo = mysql_fetch_array($billInfo); 
	
	$idd = $row['id']; $ncid = $row['name'];
	
	$daysTill = $billInfo['daystill']; 	
	$theDate = $billInfo['date'];
	$theDate = strtotime($theDate);
	$dueDate=date(dateformat, strtotime($billInfo['date']." +$daysTill days"));

	$game = sql_query("SELECT id, name FROM packages ORDER BY name") or die(mysql_error());
	$i="0";
	$packages=array();
	while ($row = mysql_fetch_array($game)) {
		$packages[$i]['id']=$row['id'];
		$packages[$i]['name']=$row['name'];
		$i++;
			
	}
	if($daystill == "0") $billInfo['update']='';

 	$smarty->assign("daystill", $daystill);
 	$smarty->assign("ncid", $ncid);
	$smarty->assign("idd", $idd);
	$smarty->assign("bid", $bid);
	$smarty->assign("today", date(dateformat, time()));
	$smarty->assign("billInfo", $billInfo);
	$smarty->assign("dueDate", $dueDate);
	$smarty->assign("packages", $packages);

	$smarty->display("billing/new-subbill.tpl");
}

if($mode == "newsub1") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$pName = sql_query($safesql->query("SELECT P.name FROM packages P, prices UP WHERE UP.pid = '%i' AND UP.pid = P.id", array($GameCP->whitelist($gmid, "int")))) or die(mysql_error());
	$pName = mysql_fetch_row($pName); $packageName = $pName[0];


	$game = sql_query($safesql->query("SELECT id, name, cost FROM prices WHERE pid = '%i'", array($GameCP->whitelist($gmid, "int")))) or die(mysql_error());
	$i="0";
	$products=array();
	while ($row = mysql_fetch_array($game)) {
		$products[$i]['id']=$row['id'];
		$products[$i]['name']=$row['name']." - " . currencyChar.$Panel->FormatNumber($row['cost']).currencyChar2;
		$i++;
	}

 	$smarty->assign("ncid", $ncid);
	$smarty->assign("idd", $idd);
	$smarty->assign("bid", $bid);
	$smarty->assign("packageName", $packageName);
	$smarty->assign("dueDate", $dueDate);
	$smarty->assign("products", $products);

	$smarty->display("billing/new-subbill1.tpl");
}

if($mode == "newsub2") { 
	if(!$gmid){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorHeader("Product required.");
		exit;
	}
	$packageInfo = sql_query($safesql->query("SELECT cost, fee, name, quarterly, semiannualy, annauly, 2years FROM prices WHERE id='%i'", array($GameCP->whitelist($gmid, "int")))) or die(mysql_error());
	$package = mysql_fetch_array($packageInfo);
	$subPackageName = $package['name']; 

	$smarty->assign("ncid", $ncid);
	$smarty->assign("idd", $idd);
	$smarty->assign("bid", $bid);
	$smarty->assign("gmid", $gmid);
	$smarty->assign("subPackageName", $subPackageName);
	$smarty->assign("package", $package);

	$smarty->display("billing/new-subbill2.tpl");
}


require_once(path.'/includes/core/editable/footer.inc.php');

?>