<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('commands');

$smarty->assign('page_title', $LNG_COMMAND_CENTER);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

require_once(path.'/includes/core/classes/commands/class.inc.php');
$Command=new Command();

if(!isset($cmd)) $cmd='';

$_SESSION['gamecp']['command'] = $cmd;

if(!isset($mode) || isset($mode) && !$mode) $mode="";
if(!isset($cmdid)) $cmdid="";
if(!isset($uid)) $uid="";
if(!isset($gid)) $gid="";
if(!isset($pulevel)) $pulevel="0";
if(!isset($pos)) $pos="";
if(!isset($cmd)) $cmd="";
if(!isset($cmdname)) $cmdname="";
$rehtml='';

if($mode == "pre"){
	$preInfoQ = sql_query($safesql->query("SELECT id, name, cmd, ulevel, os FROM cmdcenter WHERE id = '%i' LIMIT 1;", array($cmdid))) or die(mysql_error());
	$preInfo = mysql_fetch_array($preInfoQ);

	$cmdid = $preInfo[0];
	$cmdname = $preInfo[1];
	$cmd = $preInfo[2];
	$pulevel = $preInfo[3];
	$pos = $preInfo[4];

	$_SESSION['gamecp']['command'] = $cmd;
}

if ($mode == "save" || $mode == "sendsave")  {
	if($cmdname == ""){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("Please insert a command name."); 
	 }


	$doIt=sql_query($safesql->query("SELECT id FROM cmdcenter WHERE name='%s';", array($cmdname))) or die(mysql_error());
	if(mysql_num_rows($doIt)== "0"){
		$cmdid=sql_query($safesql->query("INSERT INTO cmdcenter SET cmd='%s', name='%s', ulevel='%s', os='%s';", array($cmd, $cmdname, $pulevel, $pos))) or die(mysql_error());
	} else {
		sql_query($safesql->query("UPDATE cmdcenter SET cmd='%s', name='%s', ulevel='%s', os='%s' WHERE name='%s';", array($cmd, $cmdname, $pulevel, $pos, $cmdname))) or die(mysql_error()); 
		$dq=mysql_fetch_array($doIt);
		$cmdid=$dq[0];
	}
}

if ($mode == "sendsave")  {
	if($cmdname == ""){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("Please insert a command name."); 
	 }
	$mode = "send";
}

if ($mode == "remove")  {
	if($cmdid == ""){ 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("Pick a command to remove."); 
	} else sql_query($safesql->query("DELETE FROM cmdcenter WHERE id = '%s'", array($cmdid)));
}

if ($mode == "send" && DEMO != "yes"){
	if($cmd == "") {
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("Please insert a command."); 
	}
	if($uid != "" && $gid != "" ) { 
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("You may only select one command at a time."); 
	}

	/* USERS */
	if($_REQUEST['cmduser_id'] != "")  {
		if($pos == "1"){
			$pq=" S.os='1'";
		} else $pq=" S.os !='1'";

		if($_REQUEST['cmduser_id'] == "all" || $_REQUEST['cmduser_id']=="allactive" || $_REQUEST['cmduser_id'] == "allinactive"){
			if($_REQUEST['cmduser_id'] == "all"){
				$uq="";
			} elseif($_REQUEST['cmduser_id'] =="allactive"){
				$uq="AND U.active='1'";
			} elseif($_REQUEST['cmduser_id'] =="allsuspended"){
				$uq="AND U.active='2'";
			} elseif($_REQUEST['cmduser_id'] =="allinactive") $uq="AND U.active='0'";
			$result = sql_query("SELECT U.name, S.sid, S.winport, UG.ip as 'ugip', UG.port, UG.subdirectory, UG.id as 'ugid' FROM users U, servers S, iptable I, usergames UG WHERE U.userlevel='0' AND I.ip=UG.ip AND I.sid=S.sid AND UG.cid=U.id $uq AND $pq") or die(mysql_error());
			while ($uinfo = mysql_fetch_array($result)) { 
				$fname = $uinfo[0];
				$sid = $uinfo[1];
				$winport = $uinfo[2];
				$fip = $uinfo['ugip'];
				$fport = $uinfo['port'];
				$ugid = $uinfo['ugid'];
				$subdirectory = $uinfo['subdirectory'];

				if($subdirectory == "yes"){ 
					if(ipsubdir == "true"){
						$thesubdir=$fip."-".$fport;
					} else $thesubdir="service".$ugid;
				} 
				$runcmd=$cmd;
				if($fname) $rehtml.="<li>". $Command->Run($fname, $sid, $runcmd, $winport, $pos, $pulevel, $thesubdir, $ugid)."</li>";			
			}
		} else { 
			$result = sql_query($safesql->query("SELECT U.name, S.sid, S.winport, UG.ip as 'ugip', UG.port, UG.subdirectory, UG.id as 'ugid' FROM users U, servers S, iptable I, usergames UG WHERE U.id = '%i' AND I.ip=UG.ip AND I.sid=S.sid AND UG.cid=U.id AND $pq LIMIT 1;", array($_REQUEST['cmduser_id']))) or die(mysql_error());
			$uinfo = mysql_fetch_array($result);
			$fname = $uinfo[0];
			$sid = $uinfo[1];
			$winport = $uinfo[2];
			$fip = $uinfo['ugip'];
			$fport = $uinfo['port'];
			$ugid = $uinfo['ugid'];
			$subdirectory = $uinfo['subdirectory'];

			if($subdirectory == "yes"){ 
				if(ipsubdir == "true"){
					$thesubdir=$fip."-".$fport;
				} else $thesubdir="service".$ugid;
			}
			if($fname) $rehtml.="<li>". $Command->Run($fname, $sid, $cmd, $winport, $pos, $pulevel, $thesubdir, $ugid)."</li>";			
		}

	/* GAMES */
	} else if($gid != "") {
		if($pos == "1"){ 
			$pq=" S.os='1'";
		} else $pq=" S.os !='1'";

		$rehtml="";
		$result = sql_query($safesql->query("SELECT DISTINCT(U.name),
									S.sid,
									S.winport,
									UG.ip as 'ugip',
									UG.port,
									UG.subdirectory ,
									UG.id as 'ugid'
								FROM users U, usergames UG, servers S, iptable I 
								WHERE U.id = UG.cid AND UG.gid = '%i' 
									AND U.userlevel = '0' 
									AND U.active='1'
									AND I.sid=S.sid 
									AND I.ip=UG.ip 
									AND $pq", array($gid))) or die(mysql_error());
			while ($uinfo = mysql_fetch_array($result)) { 
				$fname = $uinfo[0];
				$sid = $uinfo[1];
				$winport = $uinfo[2];

				/* new cd to sub dir */
				$fip = $uinfo['ugip'];
				$fport = $uinfo['port'];
				$ugid = $uinfo['ugid'];
				$subdirectory = $uinfo['subdirectory'];

				if($subdirectory == "yes"){ 
					if(ipsubdir == "true"){
						$thesubdir=$fip."-".$fport;
					} else $thesubdir="service".$ugid;
				}  
				$runcmd=$cmd;
				$rehtml.="<li>". $Command->Run($fname, $sid, $runcmd, $winport, $pos, $pulevel, $thesubdir, $ugid)."</li>";			
			}


	/* SERVERS */
	} else if($sid != "") {
		$rehtml="";
		
		if($pos == "1"){ $pq=" os='1'";
		} else $pq=" os !='1'";

		if($sid == "all"){
			/* all servers */
			$result = sql_query("SELECT sid, name, os, winport FROM servers WHERE active='1' AND $pq") or die(mysql_error());
			while ($row = mysql_fetch_array($result)){ 
				$sid=$row[0];
				$os=$row[2];
				$winport=$row[3];
				if($sid) $rehtml.="<li>". $Command->Run('', $sid, $cmd, $winport, $os, '1', '', '')."</li>";			
			}

		} elseif($sid == "games"){

			$result = sql_query("SELECT sid, name, os, winport FROM servers WHERE gamehost='yes' AND active='1' AND $pq") or die(mysql_error());
			while ($row = mysql_fetch_array($result)){ 
				$sid=$row[0];
				$os=$row[2];
				$winport=$row[3];
				if($sid) $rehtml.="<li>". $Command->Run('', $sid, $cmd, $winport, $os, '1', '', '')."</li>";			
			}

		} else {
			/* based on server id */
			$result = sql_query($safesql->query("SELECT sid, name, os, winport FROM servers WHERE sid='%s' AND active='1' AND $pq LIMIT 1;", array($sid))) or die(mysql_error());
			$row = mysql_fetch_array($result);
			$sid=$row[0];
			$os=$row[2];
			$winport=$row[3];
			if($sid) $rehtml.="<li>". $Command->Run('', $sid, $cmd, $winport, $os, '1', '', '')."</li>";				
		}

	} else { 
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			$Panel->Error("Please select a game, user or machine."); 
	}


	if($rehtml=="") $rehtml="<li>Command was not executed. Check your OS and Send Command To settings</li>";

	$smarty->assign("rehtml", $rehtml);
	$smarty->display("manageaddons/cmdcontrol-run.tpl");
}

// display
$savedCommands="";
$result = sql_query("SELECT id, name FROM cmdcenter ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)){ 
	if(isset($cmdid) && $cmdid == $row['id']) { 
		$sel="selected=selected";
	} else $sel="";
	$savedCommands.="<option value=\"". $row['id'] ."\" $sel>". $row['name']."</option>";
}

$gameListQuery="";
$result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result))$gameListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";

$machineListQuery="";
$result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $machineListQuery.="<option value=\"". $row['sid'] ."\">". $row['name']."</option>"; 

$userListQuery="";
$result = sql_query("SELECT * FROM users WHERE userlevel = '0' AND active='1' ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $userListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>"; 

$smarty->assign("machineList",$machineListQuery);
$smarty->assign("gameList",$gameListQuery);
$smarty->assign("userList",$userListQuery);
$smarty->assign("savedList",$savedCommands);

$smarty->assign("cmdid",$cmdid);
$smarty->assign("pulevel",$pulevel);
$smarty->assign("pos",$pos);
$smarty->assign("cmd",$_SESSION['gamecp']['command']);
$smarty->assign("cmdname",$cmdname);

$smarty->display("manageaddons/cmdcontrol.tpl");

require_once(path.'/includes/core/editable/footer.inc.php');

?>