<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


$billingPage=true;
require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('configbuilder');

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if($mode == "updateitems" && DEMO != "yes"){
	if(!$builderid || !$_REQUEST['row'] || !is_array($_REQUEST['row'])) exit;

	foreach($_REQUEST['row'] as $r => $o){
		if(!isset($o['required'])) $o['required']='0';
		if(!isset($o['editable'])) $o['editable']='0';
		
		if(isset($o['id'])){
			$info = sql_query($safesql->query("SELECT * FROM config_builderitems WHERE id = '%i'", array($GameCP->whitelist($o['id'], "int")))) or die(mysql_error());
			if(mysql_num_rows($info) > '0'){
				$s="UPDATE";
				$e=$safesql->query(" WHERE id='%i'", array($GameCP->whitelist($o['id'], "int")));
			} else {
				$s="INSERT INTO";
				$e='';
			}
		} else {
			$s="INSERT INTO";
			$e='';
		}

		$q=$safesql->query("$s config_builderitems SET 
			builderid='%i',
			name='%s',
			type='%s',
			cvar='%s',
			editable='%i',
			required='%i',
			rank='%i',
			`value`='%s',
			`regexp`='%s',
			`label`='%s', 
			`description`='%s', 
			`maxlength`='%s',
			`width`='%s', 
			`rows`='%s',
			`wrap`='%s',
			`mode`='%s', 
			`onval`='%s',
			`offval`='%s', 
			`denychars`='%s',
			`delimiter`='%s',
			`prefix`='%s', 
			`suffix`='%s', 
			`seperator`='%s'				
			
			$e", array(
			$GameCP->whitelist($builderid, "int"),	
			$GameCP->whitelist(@$o['name'], "clean"),
			$GameCP->whitelist(@$o['type'], "clean"),
			$GameCP->whitelist(@$o['cvar'], "clean"),
			$GameCP->whitelist(@$o['editable'], "int"),
			$GameCP->whitelist(@$o['required'], "int"),
			$GameCP->whitelist(@$o['rank'], "int"),
			$GameCP->whitelist(@$o['value'], "clean"),
			$GameCP->whitelist(@$o['regexp'], "clean"),
			$GameCP->whitelist(@$o['label'], "clean"),
			$GameCP->whitelist(@$o['description'], "clean"),
			$GameCP->whitelist(@$o['maxlength'], "clean"),
			$GameCP->whitelist(@$o['width'], "clean"),
			$GameCP->whitelist(@$o['rows'], "clean"),
			$GameCP->whitelist(@$o['wrap'], "clean"),
			$GameCP->whitelist(@$o['mode'], "clean"),
			$GameCP->whitelist(@$o['onval'], "clean"),
			$GameCP->whitelist(@$o['offval'], "clean"),
			$GameCP->whitelist(@$o['denychars'], "clean"),
			$GameCP->whitelist(@$o['delimiter'], "clean"),
			$GameCP->whitelist(@$o['prefix'], "clean"),
			$GameCP->whitelist(@$o['suffix'], "clean"),
			$GameCP->whitelist(@$o['seperator'], "clean")
		));
		
		echo $o['name']."<br>";
		sql_query($q) or die(mysql_error());
	}
}

if($mode == "removeitem" && DEMO != "yes"){
	if($itemid && $itemid != ''){
		sql_query($safesql->query("DELETE FROM config_builderitems WHERE id='%i' LIMIT 1", array($GameCP->whitelist($itemid, "int")))) or die(mysql_error());
		sql_query($safesql->query("DELETE FROM config_buildersave WHERE itemid='%i'", array($GameCP->whitelist($itemid, "int")))) or die(mysql_error());
	}
}


if($mode == "edit2"){
	if($configid){
		$smarty->assign("builderid",$configid);

		$cbitems=array();
		$info = sql_query($safesql->query("SELECT * FROM config_builderitems WHERE builderid = '%i' ORDER BY `rank`", array($GameCP->whitelist($configid, "int")))) or die(mysql_error());
		while($builderInfoItems = mysql_fetch_array($info)) $cbitems[]=$builderInfoItems;
		$builderInfo['items']=$cbitems;

		$smarty->assign("builderInfo",$builderInfo);

		$smarty->display("configbuilder/builder-edit.tpl");
	}
}

require_once(path.'/includes/core/editable/footer.inc.php');

?>