<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('emails');

$smarty->assign('page_title', $LNG_EMAILSYSTEM);

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";
 
if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if($mode == "sendtest"){
	if(!emailSendFrom){
		echo "Missing email send from in GameCP Settings";
	} else {
		echo "Sending test email to ". emailNotify;
		$GameCP->loadIncludes("email");	 
		$GameCP->loadIncludes("user");
		$User=new User();

		$Email->emailto = emailNotify;
		$Email->templatename = $eid;
		$Email->GetTemplateStuff();
		$Email->userid = $User->Random();
		$Email->usegamedata = true;
		$Email->usevoicedata = true;
		$Email->usebilldata = true;
		$Email->ReplaceStuff();
		$Email->send();

		$mode = "edit2";
	}
}

if($mode == "remove") {
	sql_query($safesql->query("DELETE FROM emails WHERE id='%i'", array($GameCP->whitelist($eid, "int")))) or die(mysql_error());
	if(debugging == "0"){
		$mode="edit";
	} else echo "Saved";
}

if($mode == "add2") {

	sql_query($safesql->query("INSERT INTO emails (`title`, `subject`, `body`, `sms`) VALUES('%s', '%s', '%s', '')", array(
		$GameCP->whitelist($title, "clean"),
		$GameCP->whitelist($subject, "clean"),
		$body))) or die(mysql_error());

	$eid=mysql_insert_id();
	if(debugging == "0"){
		$mode="edit2";
	} else echo "Saved";
}

if($mode == "edit3") {
	sql_query($safesql->query("UPDATE emails SET subject='%s' , title='%s', body='%s', sms='%s' WHERE id='%i'", array(
		$GameCP->whitelist($subject, "clean"),
		$GameCP->whitelist($title, "clean"),
		$body,
		$GameCP->whitelist($smsemail, "clean"),
		$GameCP->whitelist($eid, "int")))) or die(mysql_error());

	if(debugging == "0"){
		$mode="edit2";
	} else echo "Saved";
}

if($mode == "add" || $mode == "edit2" || $mode == "edit") { 
	/* generate email list */
	$result = sql_query("SELECT * FROM emails ORDER BY title") or die(mysql_error());
	$list = array();
	while ($row = mysql_fetch_array($result)){
		$list[] = $row;
	}
	$smarty->assign("emails",$list);
}

if($mode == "add") { 
	$smarty->display("manageemails/manageemails-add.tpl");
} 

if($mode == "edit2") {
	$emailDataQ = sql_query($safesql->query("SELECT * FROM emails WHERE id ='%i'", array($GameCP->whitelist($eid, "int")))) or die(mysql_error());
	$emailData = mysql_fetch_row($emailDataQ);
	$subject = $emailData[2];
	$email = $emailData[3];
	$smsemail = $emailData[4];
	$smarty->assign("eid",$eid);
	$smarty->assign("emailData",$emailData);
	$smarty->assign("email",$email);
	$smarty->assign("smsemail",$smsemail);
	$smarty->assign("subject",$subject);

	$smarty->display("manageemails/manageemails-edit2.tpl");
} 

if($mode == "edit") { 
	if(isset($eid)) $smarty->assign("eid",$eid);
	$smarty->display("manageemails/manageemails-edit.tpl");
}

require_once(path.'/includes/core/editable/footer.inc.php');

?>