<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

if(!isset($_REQUEST['mode'])){
	$_REQUEST['mode']="edit";
	$mode="edit";
}
if ($_REQUEST['mode'] && ($_REQUEST['mode'] == "update" || $_REQUEST['mode'] == "export")) $noheader=true;

require('../includes/core/includes/user/session.inc.php');

if($_REQUEST['mode'] != "edit" && $_REQUEST['mode'] != "edit2" && $_REQUEST['mode'] != "new" && $_REQUEST['mode'] != "clone" && $_REQUEST['mode'] != "removeGame" && $_REQUEST['mode'] != "import")$noheader=true;
require('../includes/config.inc.php');

$GameCP->CheckPermissions('games');


$smarty->assign('page_title', $LNG_GAMEMANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(isset($_REQUEST['gmid'])){
	$_REQUEST['gmid']=$GameCP->whitelist($_REQUEST['gmid'], "int");
	$gmid=$_REQUEST['gmid'];
}

$sortG=""; $sortS=""; $cQuery=""; $sQuery=""; $sortQ=""; $viewQ="";

function GameConfigs($gmid){
	global $GameCP, $smarty, $safesql;

	$cfgInfo=array();
	$configInfoQ = sql_query($safesql->query("SELECT configdir, configfile, config, install, id, winconfigdir, name, defaultconfig, hideconfig, edittype, autoexec, fencoding, editable, configbuilder FROM gameconfigs WHERE gid='%i'", array($gmid))) or die(mysql_error());
	while($configInfo = mysql_fetch_array($configInfoQ)) $cfgInfo[]=$configInfo;
		
	$smarty->assign("configInfo",$cfgInfo);
	$smarty->assign("configRows",mysql_num_rows($configInfoQ));
}


  if($mode == "export"){
	$GameCP->loadIncludes("game");
	$Game=new Game();
	header('Content-type: text/plain'); 
	header("Content-Disposition: attachment; filename=Game-$gmid-export.json"); 
	echo $Game->Export($gmid);
	exit;
}

if($mode == "import"){
	if(isset($action) && $action =="upload"){
		$data=file_get_contents($_FILES['file']['tmp_name']);
		if(is_file($_FILES['file']['tmp_name'])) unlink($_FILES['file']['tmp_name']);
		$GameCP->loadIncludes("game");
		$Game=new Game();
		$gmid=$Game->Import($data);
		 die("<meta http-equiv=\"Refresh\" content=\"0;url=" . $url . "/manage/games.php?mode=edit2&gmid=".$GameCP->whitelist($gmid)."\">"); 
	}
	$smarty->display("managegames/importgame.tpl");
}


if($mode == "clone"){
	$GameCP->loadIncludes("game");
	$Game=new Game();
	$data=$Game->Export($gmid);
	$gmid=$query=$Game->Import($data);
	$mode="edit2";
	die("<meta http-equiv=\"Refresh\" content=\"0;url=" . $url . "/manage/games.php?mode=edit2&gmid=".$GameCP->whitelist($gmid)."\">"); 
}

if ($mode == "removeGame" && DEMO != "yes") {
	$hasUsersQ=sql_query($safesql->query("SELECT * FROM usergames WHERE gid='%i'", array($gmid))) or die(mysql_error());
	$hasProductsQ=sql_query($safesql->query("SELECT * FROM packages WHERE gid='%i'", array($gmid))) or die(mysql_error());
	if(mysql_num_rows($hasUsersQ) > 0){ 
		$smarty->assign("remerror", "1");
		$smarty->display("managegames/remove-error.tpl");
	} elseif(mysql_num_rows($hasProductsQ) > 0 && !$_REQUEST['override']){ 
		$smarty->assign("gmid", $gmid);
		$smarty->display("managegames/remove-error.tpl");
	} else {
		$gameconfigsq = sql_query($safesql->query("SELECT id FROM gameconfigs WHERE gid='%i'", array($gmid))) or die(mysql_error());
		while($gameconfigs = mysql_fetch_assoc($gameconfigsq)){
			sql_query($safesql->query("DELETE FROM config_builderitems WHERE builderid='%i'", array($gameconfigs['id']))) or die(mysql_error());
			sql_query($safesql->query("DELETE FROM config_buildersave WHERE builderid='%i'", array($gameconfigs['id']))) or die(mysql_error());
		}
		
		sql_query($safesql->query("DELETE FROM gameconfigs WHERE gid='%i'", array($gmid))) or die(mysql_error());

		sql_query($safesql->query("DELETE FROM game WHERE id='%i'", array($gmid))) or die(mysql_error());
		$mode="edit";
		$_REQUEST['mode']="edit";
	}
}

if ($mode == "update" && DEMO != "yes") {


	if(!$gmid) die("Error: missing game id");
	if(!isset($quickConfig)) $quickConfig=array();
	if(!isset($installedon)) $installedon=array();
	if(!isset($ports)) $ports=array();

		$tmpwinappdir = substr($winappdir, -1, 1);
		if($tmpwinappdir == "/" || $tmpwinappdir == "\\") $winappdir = substr($winappdir, 0, -1);
	
		$quickConfig=serialize($quickConfig);
		$installedon=serialize($installedon);
		$ports=serialize($ports);

		$quickmod="";
		if(isset($_POST['quickmods']) && is_array($_POST['quickmods']) && count($_POST['quickmods']) > 0 ){
			foreach($_POST['quickmods'] as $gid => $sci) { 
				$sci=str_replace("&nbsp;", "", $sci);
				if($gid != "0" && trim($sci)){ $quickmod .= "::"; }
				if(trim($sci)){ $quickmod .= $sci; }
			}
		}

		$scontrolname="scontrol-".$fsgame;

		if(!isset($lsofcheck)) $lsofcheck="0";
		if(!isset($userreinstall)) $userreinstall="1";
		if(!isset($userupdate)) $userupdate="1";
		if(!isset($deleteinstall)) $deleteinstall='0';
		if(!isset($disableconfigs)) $disableconfigs='0';
		if(!isset($disableconsole)) $disableconsole='0';
		if(!isset($disableftp)) $disableftp='0';
		if(!isset($disablefirewall)) $disablefirewall='0';
		if(!isset($brandingon)) $brandingon='0';
		if(!isset($fastdl_enable)) $fastdl_enable='0';
		if(!isset($fastdl_sync)) $fastdl_sync='';
		if(!$maxplayers2) $maxplayers2=$maxplayers;
		if(isset($_REQUEST['item'])){
			$items=$_REQUEST['item'];
		} else $items=array();

		sql_query($safesql->query("UPDATE game SET `vars`='%s',
			name='%s',
			fsgame='%s',
			gcode='%s',
			game='%s',
			install='%s',
			protocol='%s',
			installfile='%s',
			scontrolname='%s',
			startmode='%s',
			premode='%s',
			map ='%s',
			port='%s',
			queryport='%s',
			maxplayers='%s',
			config='%s',
			active='%s',
			hostname='%s',
			website='%s',
			motd='%s',
			winexec='%s',
			winparams='%s',
			mapdir='%s',
			usermapdir='%s',
			winmapdir='%s', 
			winusermapdir='%s',
			remove='%s',
			quickmod='%s',
			wininstall='%s',
			winappdir='%s',
			winpremode='%s',
			quickconfig='%s',
			mapextension='%s',
			installLine='%s',
			updateline='%s',
			reinstall='%s',
			installedon='%s',
			userupdate='%s',
			basepath='%s',
			gamemonitor='%i',
			logfile='%s',
			deleteinstall='%i',
			gameQcode='%s',
			postmode='%s',
			stopmode='%s',
			winpostmode='%s',

			wininstallLine='%s',
			winupdateline='%s',
			winremove='%s',
			files='%s',
			branding='%s',
			brandingon='%i',
			maxplayers2='%i',
			mapimgdir='%s',
			pidstop='%s',
			exestop='%s',
			exedir='%s',
			altinstall='%s',
			altinstallwin='%s',
			disableconsole='%i',
			lsofcheck='%i',
			stopconsole='%s',
			winstopmode='%s',
			winstopconsole='%s',
			disableconfigs='%i',
			disableftp='%i',
			disablefirewall='%i',
			fastdl_compression='%s',
			fastdl_sync='%i',
			fastdl_include='%s',
			fastdl_exclude='%s',
			fastdl_enable='%i',
			ports='%s',
			steamid='%i',
			steammod='%s'


			WHERE id='%s'", array($GameCP->whitelist(serialize($cvars), 'serialize', 'useredit'),
				$GameCP->whitelist($gmname, "useredit"), $GameCP->whitelist($fsgame, "useredit"),
				$GameCP->whitelist($gcode, "useredit"), $GameCP->whitelist($gamename, "useredit"), 
				$GameCP->whitelist($gameinstall, "useredit"), $GameCP->whitelist($proto, "useredit"),
				$GameCP->whitelist($installfile, "useredit"), $GameCP->whitelist($scontrolname, "useredit"),
				$GameCP->whitelist($startmode, "useredit"), $GameCP->whitelist($premode, "clean"), 
				$GameCP->whitelist($map, "useredit"), $GameCP->whitelist($port, "int"), $GameCP->whitelist($queryport, "int"),
				$GameCP->whitelist($maxplayers, "int"), $GameCP->whitelist($fconfig, "useredit"),
				$GameCP->whitelist($active, "int"), $GameCP->whitelist($hostname, "useredit"), 
				$GameCP->whitelist($fwebsite, "useredit"), $GameCP->whitelist($motd, "useredit"), 
				$GameCP->whitelist($winexec, "useredit"),
				$GameCP->whitelist($winparams, "useredit"),
				
			
				$GameCP->whitelist($mapdir, "useredit"),
				$GameCP->whitelist($usermapdir, "useredit"), 
				$GameCP->whitelist($winmapdir, "useredit"),
				$GameCP->whitelist($winusermapdir, "useredit"),
				$GameCP->whitelist($removeLine, "useredit"),
				$quickmod,
				$GameCP->whitelist($wininstall, "useredit"), 
				$GameCP->whitelist($winappdir, "useredit"), 
				$GameCP->whitelist($winpremode, "clean"), 
				
				$quickConfig,
				$GameCP->whitelist($mapextension, "useredit"),
				$GameCP->whitelist($installLine, "useredit"),
				$GameCP->whitelist($updateline, "useredit"),
				$GameCP->whitelist($userreinstall, "useredit"),
				$GameCP->whitelist($installedon, "serialize","clean"),
				$GameCP->whitelist($userupdate, "useredit"), 
				$GameCP->whitelist($basepath, "useredit"), 
				$GameCP->whitelist($gamemonitor, "int"), 
				$GameCP->whitelist($logfile, "useredit"), 
				$GameCP->whitelist($deleteinstall, "int"), 
				$GameCP->whitelist($gameQcode, "useredit"), 
				$GameCP->whitelist($postmode, "useredit"), 
				$GameCP->whitelist($stopmode, "useredit"), 
				$GameCP->whitelist($winpostmode, "useredit"), 

					
				$GameCP->whitelist($wininstallLine, "useredit"),
				$GameCP->whitelist($winupdateline, "useredit"),
				$GameCP->whitelist($winremoveLine, "useredit"),
				serialize($items),
				$GameCP->whitelist($fbranding, "useredit"),
				$GameCP->whitelist($brandingon, "int"),
				$GameCP->whitelist($maxplayers2, "int"),
				$GameCP->whitelist($mapimgdir, "useredit"),
				$GameCP->whitelist($pidstop, "useredit"),
				$GameCP->whitelist($exestop, "useredit"),
				$GameCP->whitelist($exedir, "useredit"),
				$GameCP->whitelist($altinstall, "useredit"),
				$GameCP->whitelist($altinstallwin, "useredit"),
				$GameCP->whitelist($disableconsole, "useredit"),
				$GameCP->whitelist($lsofcheck, "useredit"),

				$GameCP->whitelist($stopconsole, "useredit"), 
				$GameCP->whitelist($winstopmode, "useredit"), 
				$GameCP->whitelist($winstopconsole, "useredit"), 

				$GameCP->whitelist($disableconfigs, "int"),
				$GameCP->whitelist($disableftp, "int"),
				$GameCP->whitelist($disablefirewall, "int"),
				$GameCP->whitelist($fastdl_compression, "clean"),
				$GameCP->whitelist($fastdl_sync, "int"),
				$GameCP->whitelist($fastdl_include, "clean"),
				$GameCP->whitelist($fastdl_exclude, "clean"),
				$GameCP->whitelist($fastdl_enable, "int"),
				$ports,
				$GameCP->whitelist($steamid, "int"), 
				$GameCP->whitelist($steammod, "clean"), 

				$GameCP->whitelist($gmid, "int")
			
				))) or die(mysql_error());
		if($_POST['customconf']){
			foreach($_POST['customconf'] as $value) {
				$configdir=$value['cfgdir'];
				$winconfigdir=$value['wincfgdir'];
				$configfile=$value['cfgfile'];
				$gconfig=$value['contents'];
				$edittype=@$value['edittype'];
				$configInstall=$value['autoinstall'];
				if(isset($value['defaultconfig'])){
					$defaultconfig=$value['defaultconfig'];
				} else $defaultconfig='';
				if(isset($value['cfgid'])){
					$cfgid=$value['cfgid'];
				} else $cfgid='';
				if(isset($value['remove'])){
					$remove=$value['remove'];
				} else $remove='0';
				$cfgname=$value['cfgname'];
				if(isset($value['hideconfig'])){
					$hideconfig=$value['hideconfig'];
				} else $hideconfig='';
				if(isset($value['autoexec'])){
					$autoexec=$value['autoexec'];
				} else $autoexec='';

				$fencoding=@$value['fencoding'];
				if(isset($value['editable'])){
					$editable=$value['editable'];
				} else $editable='';
				if(isset($value['configbuilder'])){
					$configbuilder=$value['configbuilder'];
				} else $configbuilder='';

				if(!$editable) $editable="0";
				if(!$configbuilder) $configbuilder="0";
				if(!$hideconfig) $hideconfig="0";
				if(!$defaultconfig) $defaultconfig="0";
				if(!$autoexec) $autoexec="0";
				if(@$value['delete'] == "1") $remove="yes";

				$GameCP->loadIncludes("game");
				$Game=new Game();
				$Game->ConfigSQL($gmid, $configdir, $winconfigdir, 
									$configfile, $gconfig, $configInstall, 
									$installfile, $cfgid, $remove, 
									$cfgname, $hideconfig, $defaultconfig, 
									$edittype, $autoexec, $fencoding,
									$editable, $configbuilder);
			}
		}
		if(isset($_POST['customgame'])){
			foreach($_POST['customgame'] as $value) {
				//$gmid=$value['gid'];
				$sgid=$value['sgid'];
				$hostname=$value['hostname'];
				$maxplayers=$value['maxplayers'];
				$autoinstall=$value['autoinstall'];
				$cfgid=$value['cfgid'];
				$remove=$value['remove'];
				$pubpriv=$value['pubpriv'];
				$flimit=$value['flimit'];
				$subdir=$value['subdir'];

				if(!$maxplayers) $maxplayers = "16";
				if(!$hostname) $hostname = "Default Hostname";

				$GameCP->loadIncludes("game");
				$Game=new Game();
				$Game->SubGame($gmid, $sgid, $hostname, $maxplayers, $autoinstall, $cfgid, $remove, $pubpriv, $flimit, $subdir);
			}
		}
		if(isset($mumserver) && $mumserver == "1"){
			$aaq=sql_query("SELECT id FROM game WHERE id='1004' LIMIT 1;");
			if(mysql_num_rows($aaq) == 0){
				sql_query($safesql->query("UPDATE game SET id='1004' WHERE id='%i'", array($gmid)));
				sql_query($safesql->query("UPDATE gameconfigs SET gid='1004' WHERE gid='%i'", array($gmid)));
				echo '<script>window.location="'. url .'/manage/games.php?mode=edit2&gmid=1004";</script>';
			}
		}
	GameConfigs($gmid);
	$smarty->display('managegames/configs.tpl');
}

if ($mode == "add") { 

	$updateinsert=sql_query($safesql->query("SELECT id FROM game WHERE name='%s' LIMIT 1;", array($gmname)));
	//$config=preg_quote($config, "'");

	if(mysql_num_rows($updateinsert) > 0){
		$dataQ=mysql_fetch_array($updateinsert);
		$iiid=$dataQ['id'];
		$cmd="UPDATE";
		$cmdextra=" AND id='$iiid'";
	} else{ 
		$cmdextra="";
		$cmd="INSERT INTO";
	}

	if(!isset($maxplayers)) $maxplayers="16";

	sql_query($safesql->query("$cmd game SET name = '%s', fsgame = '%s', 
	gcode = '%s', startmode ='%s',
	game = '%s', install = '%s', protocol = '%s',
	installfile = '%s', scontrolname = '%s',
	premode = '%s',  port = '%s',
	queryport = '%s', maxplayers = '%s',
	map = '%s', config = '%s',  active = '%s',
	hostname='%s', website='%s', motd='%s',
	winexec='%s', winparams='%s', 
	mapdir='%s', usermapdir='%s', remove='%s', quickmod='', wininstall='' $cmdextra;", array($GameCP->whitelist($gmname, "useredit"), 
		$GameCP->whitelist($fsgame, "useredit"), 
		$GameCP->whitelist($gcode, "useredit"), 
		$GameCP->whitelist(@$startmode, "useredit"), 

		$GameCP->whitelist($gamename, "useredit"),
		$GameCP->whitelist(@$gameinstall, "useredit"), 
		$GameCP->whitelist(@$proto, "useredit"), $GameCP->whitelist($installfile, "useredit"),
		$GameCP->whitelist($scontrolname, "useredit"), 
		$GameCP->whitelist(@$premode, "useredit"), 
		$GameCP->whitelist($port, "useredit"),
		$GameCP->whitelist($queryport, "useredit"),
		$GameCP->whitelist($maxplayers, "useredit"),
		$GameCP->whitelist(@$map, "useredit"),
		$GameCP->whitelist(@$fconfig, "useredit"),
		$GameCP->whitelist(@$active, "useredit"),
		$GameCP->whitelist(@$hostname, "useredit"),
		$GameCP->whitelist(@$fusereditsite, "useredit"),
		$GameCP->whitelist(@$motd, "useredit"),
		$GameCP->whitelist(@$winexec, "useredit"),
		$GameCP->whitelist(@$winparams, "useredit"),
		$GameCP->whitelist(@$mapdir, "useredit"),
		$GameCP->whitelist(@$usermapdir, "useredit"),
		$GameCP->whitelist(@$remove, "useredit")
		))) or die(mysql_error());

	if($iiid){ $gmid=$iiid; } else $gmid=mysql_insert_id();
	
	/* these ids are reserved for voice only - do not allow games on them! */
	if($gmid == "1000" || $gmid == "1001" || $gmid == "1002" || $gmid == "1003" || $gmid == "1004"){
		sql_query($safesql->query("UPDATE game SET id='1010' WHERE id='%i'", array($gmid)));
		$gmid="1010";
	}		
	if(debugging == "0"){
		header("location: $url/manage/games.php?mode=edit2&gmid=$gmid");
	} else echo "Saved";

}

if($mode == "edit") { 

	$gameList="";
	$resultClient = sql_query("SELECT id, name FROM game ORDER BY `name` ASC") or die(mysql_error());
	while ($row = mysql_fetch_array($resultClient)){
		if(isset($_REQUEST['gmid']) && $_REQUEST['gmid'] == $row['id']){
			$sele ="selected='selected'";
		} else $sele ="";
		$gameList.= "<option value=\"". $row['id'] ."\" $sele>". $row['name']."</option>";
	}

	$smarty->assign("gameSelect",$gameList);


	$sql="SELECT SQL_CALC_FOUND_ROWS * FROM game ORDER BY id DESC";

	$result=Smarty_PageControl($sql, "gamelist", "gamelist");

	$list = array();
	$GameCP->loadIncludes("ftp");
	$FTP=new FTP();

	while ($row = mysql_fetch_array($result)){
		
		$hasUsersQ=sql_query($safesql->query("SELECT * FROM usergames WHERE gid='%i'", array($row['id']))) or die(mysql_error());
		$row['hasgames']=mysql_num_rows($hasUsersQ);
		

		/* extract right path if the install is ftp */
		$wininstall=$FTP->CheckFTP($row['wininstall'], true);
		if(is_array($wininstall)){
			$path=$wininstall['path'];
			if(substr($path, 0, 1) == "/") $path=substr($path, 1);
			$row['wininstall']=$path;
		}

		$linuxinstall=$FTP->CheckFTP($row['installfile'], true);
		if(is_array($linuxinstall)){
			$path=$linuxinstall['path'];
			if(substr($path, 0, 1) == "/") $path=substr($path, 1);
			$row['installfile']= $path;
		}

		if(isset($_SESSION['gamecp']['download'])) $row['servers']=serialize($_SESSION['gamecp']['download'][$row['id']]['servers']);
		$list[] = $row;
	}

	$smarty->assign("gameInfo",$list);
			
	$smarty->display("managegames/managegames-list.tpl");


  } // end list

  
  if($mode == "edit2") {
	
	$gameList="";
	$resultClient = sql_query("SELECT id, name FROM game ORDER BY `name` ASC") or die(mysql_error());
	while ($row = mysql_fetch_array($resultClient)){
		if($_REQUEST['gmid'] == $row['id']){
			$sele ="selected='selected'";
		} else $sele ="";
		$gameList.= "<option value=\"". $row['id'] ."\" $sele>". $row['name']."</option>";
	}
	$GameCP->loadIncludes("game");
	$Game=new Game();


	$smarty->assign("gameSelect",$gameList);
	$smarty->assign("gmid",$gmid);

	$gInfo = sql_query($safesql->query("SELECT * FROM game WHERE id ='%i' LIMIT 1;", array($gmid))) or die(mysql_error());
	$row = mysql_fetch_array($gInfo);

	if($row['ports']){
		$row['ports']=unserialize($row['ports']);
		$n=array();
		foreach($row['ports'] as $id => $p) $n[]=$p;
		$smarty->assign("ports",$n);
	}

	$cvars=unserialize($row['vars']);
	$newcv=array();
	if(is_array($cvars)){
		foreach($cvars as $c => $var){
			$newcv[]=$var;
		}
	}

	$GameCP->loadIncludes("display");
	$Display=new Display();

	$smarty->assign("machineList",$Display->MachineIPList(true, unserialize($row['installedon']), '','','', "no"));
	$smarty->assign("cvars",$newcv);

	$installname=$row['installfile'];
	$quickMod=$row['quickmod'];
	$quickMod=explode("::", $quickMod);
	$quickConfig=unserialize($row['quickconfig']);
	$filelist=$row['files'];

	$smarty->assign("gameDetails",$row);



	/* game configs */
	GameConfigs($gmid);

	/* game "quick config" select list */
	$arrayLength = count($quickConfig);
	$quickCfg="";
	if($arrayLength > 0){
		for ($i = 0; $i < $arrayLength; $i++){
		  if(trim($quickConfig[$i]) != "") $quickCfg.= "<option value=\"". trim(str_replace(" ", "&nbsp;", $quickConfig[$i])) ."\" id=\"quickConfig".$i ."\">". $quickConfig[$i] ."</option>"; 
		}
	} else $quickCfg.= "<option value=\"\">&nbsp;</option>";

	$smarty->assign("quickConfig",$quickCfg);


	/* game "quick mod" select list */
	$arrayLength = count($quickMod);

	$quickMd="";
	if(count($arrayLength) > 0){
		for ($i = 0; $i < $arrayLength; $i++){
		  if(trim($quickMod[$i]) != "") $quickMd.= "<option value=". trim(str_replace(" ", "&nbsp;", $quickMod[$i])) .">".$quickMod[$i]."</option>"; 
		}
	}
	$smarty->assign("quickMods",$quickMd);


	
	/* game select list */
	$gameSelect2="";
	$resultClient = sql_query("SELECT id, name FROM game ORDER BY `name` ASC") or die(mysql_error());
		while ($b = mysql_fetch_array($resultClient)){
			/*if($configInfo['sgid'] == $row['id']){
				$selected="selected=selected";
			} else */$selected="";
		$gameSelect2.= "<option value=\"". $b['id'] ."\" $selected>". $b['name']."</option>";
	}

	$smarty->assign("gameSelect2",$gameSelect2);


	$subGame=array();
	$configInfoQ = sql_query($safesql->query("SELECT * FROM gamesubinstalls WHERE gid='%i'", array($gmid))) or die(mysql_error());
	while($configInfo = mysql_fetch_array($configInfoQ)){
		$glist="";
		$resultClient = sql_query("SELECT id, name FROM game ORDER BY `name` ASC") or die(mysql_error());

		while ($glist2 = mysql_fetch_array($resultClient)){
			if($configInfo['sgid'] == $glist2['id']){
				$selected="selected=selected";
			} else $selected="";
			
			$glist.= "<option value=\"". $glist2['id'] ."\" $selected>". $glist2['name']."</option>";
		}

		$configInfo['gameList']=$glist;
		$subGame[]=$configInfo;
	}
	$smarty->assign("subGame",$subGame);
	$smarty->assign("files",unserialize($filelist));


	require_once(path.'/includes/core/classes/gameq2/GameQ.php');
	$protocols_path = path.'/includes/core/classes/gameq2/gameq/protocols/';
	$dir = dir($protocols_path);
	$gq = array();
	while (false !== ($entry = $dir->read()))
	{
		if(!is_file($protocols_path.$entry) || $entry == ".." || $entry == "." || $entry == ".noencode")
		{
			continue;
		}

		// Figure out the class name
		$class_name = 'GameQ_Protocols_'.ucfirst(pathinfo($entry, PATHINFO_FILENAME));

		// Lets get some info on the class
		$reflection = new ReflectionClass($class_name);

		// Check to make sure we can actually load the class
		if(!$reflection->IsInstantiable())
		{
			continue;
		}

		// Load up the class so we can get info
		$class = new $class_name;

		// Add it to the list
		$gq[] = array(
			'name' => $class->name_long(),
			'protocol' => $class->name()
		);
		unset($class);
	}

	unset($dir);
	ksort($gq);


	
	$smarty->assign("gcodes",$gq);
	$smarty->display("managegames/managegames-edit.tpl");
}

if($mode =="new"){ 
	$smarty->display("managegames/managegames-new.tpl");
} 


if($_REQUEST['mode'] != "showfiles" && $_REQUEST['mode'] != "update") require_once(path.'/includes/core/editable/footer.inc.php');

?>