<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

$loadIndex=true;
require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('dashboard');

$GameCP->SetURLCookie();

$smarty->assign('page_title', $LNG_HOME);

if(isset($_SESSION['gamecp']['license']['trial']) && $_SESSION['gamecp']['license']['trial'] == "true"){
	$smarty->assign("trialNotification", true);
	 if(isset($_REQUEST['mode']) && $_REQUEST['mode'] =="emailgamecp"){
		if($_POST['comments']){
			$GameCP->loadIncludes("email");
			$Email->emailto = "support@gamecp.com";
			$Email->emailsubject = 'GameCP Demo Contact';
			$Email->emailbody = $_POST['comments'];
			$Email->send();
		}
	}
}

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "1"){

	if(isset($_REQUEST['mode']) && $_REQUEST['mode']=="closehowto") sql_query("UPDATE settings SET value='1' WHERE name='howtoran';");
	
	if(isset($_REQUEST['mode']) && $_REQUEST['mode']=="regkey"){
		sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='gcplickey';", array($GameCP->whitelist($_REQUEST['lickey'], "web"))));
		sql_query("UPDATE settings SET value='' WHERE name='gcplocalkey';");
		if(isset($_SESSION['gamecp']['nav_control'])) unset($_SESSION['gamecp']['nav_control']);
		if(isset($_SESSION['gamecp']['constant_settings'])) unset($_SESSION['gamecp']['constant_settings']);
		header("location: ".url."?mode=logout");
	}

	if(is_dir(path."/installer")) $smarty->assign("installerfolder", true);

	$report="";
	if(ini_get('magic_quotes') == 1 || ini_get('magic_quotes') == "yes" || ini_get('magic_quotes') == "Yes") $report.= "<li>PHP magic_quotes is enabled, please disable</li>";
	if(is_dir("installer")) $report.= "<li>Remove the 'installer' folder to secure your installation</li>";
	if((int)ini_get('register_globals') == 1) $report.="<li>PHP register_globals is enabled, please disable</li>";
	

	$strictQ=sql_query("SELECT @@sql_mode;");
	$strict=mysql_fetch_assoc($strictQ);
	if(preg_match("/STRICT/i", $strict['@@sql_mode']))$report.= "<li>MySQL strict mode is enabled, please disable.</li>";

	$timeError='';
	if(!ran_cache|| time()-ran_cache > '129600') $timeError.="<li>cache.php</li>";
	if(!ran_monitor||time()-ran_monitor > '129600') $timeError.="<li>servermonitor.php</li>";
	if(!ran_auto||time()-ran_auto > '129600') $timeError.="<li>auto.php</li>";
	if(!ran_quota||time()-ran_quota > '129600') $timeError.="<li>quota.php</li>";
	if(imapuser && (!ran_imap||time()-ran_imap > '129600')) $timeError.="<li>imap.php</li>";
	if(!ran_queue||time()-ran_queue > '129600') $timeError.="<li>queue.php</li>";

	$smarty->assign("timeError", $timeError);
	$smarty->assign("installVerifierCode", $report);

	$loadIndex= "adminindex";
}

if ($_SESSION['gamecp']['userinfo']['ulevel'] == "0"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit('Invalid Access');
}
if ($_SESSION['gamecp']['userinfo']['ulevel'] == "2") $loadIndex= "managerindex";
if ($_SESSION['gamecp']['userinfo']['ulevel'] == "3") $loadIndex= "supportindex"; 
if ($_SESSION['gamecp']['userinfo']['ulevel'] == "4") $loadIndex= "resellerindex"; 
if ($_SESSION['gamecp']['userinfo']['ulevel'] == "5") $loadIndex= "ownerindex"; 

if(isset($_REQUEST['loadItem'])){
	$loaditem=$GameCP->whitelist(str_replace("sort_", "", $_REQUEST['loadItem']));	
	$smarty->display('index/sort/'.$loaditem.'.tpl');
} else $smarty->display('index/'.$loadIndex.'.tpl');

/* clear mini and noheads cause this page loads sub pages and over-rides what we want for footer */
if(isset($_REQUEST['noheader'])) unset($_REQUEST['noheader']);
if(isset($_REQUEST['mini'])) unset($_REQUEST['mini']);

require(path.'/includes/core/editable/footer.inc.php');

?>