<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

if(isset($_REQUEST['altupdate']) && $_REQUEST['altupdate'] == "true") $noheader=true;
require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');
 
if(!isset($mode) || isset($mode) && !$mode) $mode="edit";

$GameCP->CheckPermissions('machines');

$smarty->assign('page_title', $LNG_MACHINE_MANAGEMENT);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") {
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

$cQuery="";


/* these are funky but needed on each page for the list */
$serverlist="";
$locallist="";

$result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $serverlist.= "<option value=\"". $row['sid'] ."\">". $row['name']."</option>"; 

$result = sql_query("SELECT distinct(location) FROM servers ORDER BY 'location'") or die(mysql_error());
while ($row = mysql_fetch_array($result)){ 
	$lname=$row['location'];
	if(!$lname) $lname="&nbsp;";
	$locallist.= "<option value=\"". $row['location'] ."\">". $lname."</option>"; 
}

$smarty->assign("serverlist", $serverlist);
$smarty->assign("locallist", $locallist);


if($mode == "steamcheck"||$mode == "steamauth"||$mode == "steamstatus"){
	require_once(path."/includes/core/classes/games/steamcmd.inc.php");
	$SteamCMD=new SteamCMD();
}

if($mode == "steamcheck"){
	$SteamCMD->RunMachine(@$_REQUEST['mid']);
	$smarty->assign("mid", @$_REQUEST['mid']); 
	$smarty->display("managemachines/steamcmd-complete.tpl");
}

if($mode == "steamauth"){
	$result=$SteamCMD->RunMachine(@$_REQUEST['mid'], 'auth');
	$smarty->assign("result", $result); 
	$smarty->display("managemachines/steamcmd-auth.tpl");

}

if($mode == "steamstatus"){
	$result=$SteamCMD->RunMachine(@$_REQUEST['mid'], 'check');

	if(isset($_REQUEST['mid']) && $_REQUEST['mid'] != ''){
		if($result[$_REQUEST['mid']]['status'] == "completed"){
			echo "Update completed.";
		} else echo $result[$_REQUEST['mid']]['log'];
	} else {
		$completed=true;
		foreach($result as $i => $r)if($r['status'] !='completed') $completed=false;
		if($completed){
			echo "Update completed.";
		} else {
			foreach($result as $i => $r){
				if($r['log']) echo "<strong>#$i Log</strong> - ". $r['log']."<br>";
			}
		}
	}
}

if($mode == "synclicense"){
	$res='';
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$result = sql_query("SELECT * FROM servers WHERE active='1'") or die(mysql_error());
	while ($row = mysql_fetch_array($result)){ 
		$cmd=trim($Backend->QueryResponse($row['sid'], '', "lic_addip:_:"));
		if($cmd == "addip"){
			$res.=$row['sid']." synced<br>";
		} else $res.=$row['sid'] ." failed<br>";
	}
	$Panel->ErrorHeader($res);
	$mode="edit";
}

if($mode == "syncvoice" || $mode == "dosyncts3"){
	$GameCP->loadIncludes("voice");
	$Voice=new Voice();

	if($mode == "dosyncts3"){
		$smarty->assign("results", $Voice->SyncTS3($mid, $_REQUEST['data']));
	}

	$tsdata=$Voice->SyncTS3GetData($mid);

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$serverDetails=$Panel->GetServer('','',$mid);

	$smarty->assign("ip", $serverDetails['ip']);
	$smarty->assign("data", $tsdata);
	$smarty->display("managemachines/syncts3.tpl");
}

if($mode == "updateftpd"){
		
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$Backend->UpdateFTP($msid);
}

if($mode == "installcron" && DEMO != "yes"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$serverDetails=$Panel->GetServer($msid);
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	if($serverDetails['os'] == "1"){

		$folder=str_replace("/","\\", path."/includes/cron");
		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-monitor.bat:_:cd $folder && php servermonitor.php");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /mo 10 /tn \"GameCP System Monitor\" /tr \$MAINDIR\gamecp-monitor.bat");

		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-cache.bat:_:cd $folder && php cache.php");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /mo 3 /tn \"GameCP Cache\" /tr \$MAINDIR\gamecp-cache.bat");

		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-billing.bat:_:cd $folder && php auto.php 1");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /sc daily /tn \"GameCP Daily Billing\" /tr \$MAINDIR\gamecp-billing.bat");

		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-scheduler.bat:_:cd $folder && php scheduler.php");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /mo 2 /tn \"GameCP Scheduler\" /tr \$MAINDIR\gamecp-scheduler.bat");

		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-queue.bat:_:cd $folder && php queue.php");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /mo 2 /tn \"GameCP Queue\" /tr \$MAINDIR\gamecp-queue.bat");
	
		$Backend->Query($msid, '', "writefile:_:\$MAINDIRgamecp-quota.bat:_:cd $folder && php quota.php");
		$Backend->Query($msid, '', "schtasks:_:/create /sc minute /mo 10 /tn \"GameCP Quota Monitor\" /tr \$MAINDIR\gamecp-quota.bat");

	} else {
		$cron="#!/bin/bash\ncd ".path."/includes/cron ; ".phpexec." auto.php 1 >> /var/log/gamecp-billing";
		$Backend->Query($msid, '', "writefile:_:/etc/cron.daily/gamecp-daily:_:$cron"); 
		$Backend->Query($msid, '', "command:_:chmod +x /etc/cron.daily/gamecp-daily"); 

		$cron2="*/10  * * * * root cd ".path."/includes/cron ; ".phpexec." servermonitor.php >> /var/log/gamecp-monitor\n";
		$cron2.="*/3  * * * * root cd ".path."/includes/cron ; ".phpexec." cache.php >> /var/log/gamecp-cache\n";
		$cron2.="*/2  * * * * root cd ".path."/includes/cron ; ".phpexec." scheduler.php >> /var/log/gamecp-scheduler\n";
		$cron2.="*/2  * * * * root cd ".path."/includes/cron ; ".phpexec." queue.php >> /var/log/gamecp-queue\n";
		$cron2.="*/10  * * * * root cd ".path."/includes/cron ; ".phpexec." quota.php >> /var/log/gamecp-quota\n";
		$Backend->Query($msid, '', "command:_:echo \"$cron2\" >> /etc/crontab ; /etc/init.d/cron reload"); 

	}

	$Event->EventLogAdd('', "Machine ". $msid. " had cron installed by ".$_SESSION['gamecp']['userinfo']['name']);
	echo "GameCP CRON Jobs installed.";
}

if($mode == "updatebackend" && DEMO != "yes") { 
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	echo "Your server is being updated, please wait...<br>";
	$Backend->Query($msid, '', "update:_:"); 

	$Event->EventLogAdd('', "Machine ". $msid. " was updated by ".$_SESSION['gamecp']['userinfo']['name']);

	$gmid=$msid;
	$mode="edit2";	
}

if($mode == "massremip" && DEMO != "yes"){
	$Event->EventLogAdd('', "Machine ". $msid. " had ips ".serialize($_POST['users'])." removed by ".$_SESSION['gamecp']['userinfo']['name']);

	foreach($_POST['users'] as $id => $ip) { 
		if($ip){
			$ip=$GameCP->whitelist($ip);
			if($scimode == "assign" || $scimode == "unassign"){
				if($scimode == "assign"){
					 $assign="1";
				} else $assign="0";

				echo "Updating: " .$ip."<br>";
				sql_query($safesql->query("UPDATE iptable SET assigned='%s' WHERE ip='%s';", array($assign, $ip))) or die(mysql_error());
			}

			if($scimode == "remove"){
				$ipGamesQ = sql_query($safesql->query("SELECT * FROM usergames UG, iptable I WHERE UG.ip = I.ip AND I.ip = '%s'", array($GameCP->whitelist($ip, "clean")))) or die(mysql_error());
				$ipGames=mysql_num_rows($ipGamesQ);

				if($ipGames == "0"){
					echo "Removing: " .$ip."<br>";
					sql_query($safesql->query("DELETE FROM iptable WHERE ip='%s'", array($ip))) or die(mysql_error());
				} else echo "Not Removing: " .$ip.", remove games first.<br>";

			}
		}
	}
	if(debugging =="0") { echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/manage/machines.php?mode=edit2&amp;gmid=".$GameCP->whitelist($msid)."\">"; }
}

if($mode == "remove" && DEMO != "yes") { 
	$oid=$mid;
	$sidQ=sql_query($safesql->query("SELECT sid, os FROM servers WHERE id='%s'", array($GameCP->whitelist($mid, "clean")))) or die(mysql_error());
	$sid=mysql_fetch_array($sidQ);
	$mid=$sid[0];
	$os=$sid[1];

	$ipQ=sql_query($safesql->query("SELECT ip FROM iptable WHERE sid='%s'", array($GameCP->whitelist($mid, "clean")))) or die(mysql_error());
	$ips=array();
	while($ipaddresses=mysql_fetch_array($ipQ)){
		$ips[]=$ipaddresses['ip'];
	}

	$gameQ=sql_query("SELECT id, installedon FROM game WHERE installedon != ''") or die(mysql_error());
	while($cg=mysql_fetch_array($gameQ)){
		$gm=unserialize($cg['installedon']);
		if(is_array($gm)){
			$changed=false;
			foreach($gm as $g => $m){
				if(in_array($m, $ips) || $m == $mid){
					unset($gm[$g]);
					$changed=true;
				}
			}
			if($changed==true) sql_query($safesql->query("UPDATE game SET installedon = '%s' WHERE id='%i'", array(serialize($gm),$cg['id'])));
		}
	}

	$statsdir=path."/includes/stats/machines/$mid";
	if(is_dir($statsdir)) {
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->RemoveRecursiveDir($statsdir);
	}

	sql_query($safesql->query("DELETE FROM servers WHERE id='%i'", array($oid))) or die(mysql_error());
	sql_query($safesql->query("DELETE FROM iptable WHERE sid='%s'", array($mid))) or die(mysql_error());

	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$lic_api=$Backend->QueryResponse($mid, '', "lic_removeip:_:");

	$Event->EventLogAdd('', "Machine ". $oid. " was removed by ".$_SESSION['gamecp']['userinfo']['name'] ."<br><br>".$lic_api);

	echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/manage/machines.php?mode=edit\">";
} 

if($mode == "removeip" && DEMO != "yes") { 
	$Event->EventLogAdd('', "Machine ". $msid. " had ip $mid removed by ".$_SESSION['gamecp']['userinfo']['name']);
	sql_query($safesql->query("DELETE FROM iptable WHERE id='%s'", array($GameCP->whitelist($mid, "clean")))) or die(mysql_error());
	$GameCP->loadIncludes("ip");
	$IP=new IP();
	$IP->UpdateIPUse($msid);
} 

if($mode == "updateip" && DEMO != "yes") { 
	if($altupdate == "true"){
		$mid = str_replace(' ', '', $_REQUEST['id']);
		if(isset($_REQUEST['updateUse']) || isset($_REQUEST['updateAssigned']) == true || isset($_REQUEST['updateIp']) == true){
			$minternal = str_replace(' ', '', $_REQUEST['value']);
			if($minternal == "yes"){
				echo "Yes";
				$minternal="1";

			} elseif($minternal == "no"){
				echo "No";
				$minternal="0";
			}

			if(isset($_REQUEST['updateAssigned'])){
				sql_query($safesql->query("UPDATE iptable SET assigned='%s' WHERE id='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($mid, "clean")))) or die(mysql_error());
			} elseif(isset($_REQUEST['updateIp']) == true){
				$existingq=sql_query($safesql->query("SELECT ip FROM iptable WHERE id='%s' LIMIT 1", array($GameCP->whitelist($mid, "clean")))) or die(mysql_error());
				$existing=mysql_fetch_array($existingq);

				$gamesQ=sql_query("SELECT id, installedon FROM game WHERE installedon !=''");
				while($games = mysql_fetch_assoc($gamesQ)){
					$servers=unserialize($games['installedon']);
					if(is_array($servers) && in_array($existing[0], $servers)){
						$servers[$existing[0]]=$minternal;
						sql_query($safesql->query("UPDATE game SET installedon='%s' WHERE id='%s'", array(serialize($servers), $GameCP->whitelist($games['id'], "int")))) or die(mysql_error());
					}
				}

				sql_query($safesql->query("UPDATE iptable SET ip='%s' WHERE id='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($mid, "clean")))) or die(mysql_error());
				sql_query($safesql->query("UPDATE usergames SET ip='%s' WHERE ip='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($existing[0], "clean")))) or die(mysql_error());
				sql_query($safesql->query("UPDATE uservoice SET ip='%s' WHERE ip='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($existing[0], "clean")))) or die(mysql_error());
				echo $minternal;
			} else sql_query($safesql->query("UPDATE iptable SET useinternal='%s' WHERE id='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($mid, "clean")))) or die(mysql_error());
		} else {
			$minternal = str_replace(' ', '', $_REQUEST['value']);
			sql_query($safesql->query("UPDATE iptable SET internal='%s' WHERE id='%s'", array($GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($mid, "clean")))) or die(mysql_error());
			echo $minternal;
		}
	} else {
		$msid = str_replace(' ', '', $msid);
		$mip = str_replace(' ', '', $mip);
		$minternal = str_replace(' ', '', $minternal);

		sql_query($safesql->query("UPDATE iptable SET sid='%s', ip='%s', assigned='%s', internal='%s', useinternal='%s' WHERE id='%s'", array($GameCP->whitelist($msid, "clean"), $GameCP->whitelist($mip, "clean"), $GameCP->whitelist($massigned, "clean"), $GameCP->whitelist($minternal, "clean"), $GameCP->whitelist($museinternal, "clean"), $GameCP->whitelist($mid, "clean")))) or die(mysql_error());

		echo "Saved";
		$Event->EventLogAdd('', "Machine ". $msid. " had ip $mid updated by ".$_SESSION['gamecp']['userinfo']['name']);
		if(debugging =="0") { echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/manage/machines.php?mode=edit2&amp;gmid=".$GameCP->whitelist($msid)."\">";} 
	}

	$GameCP->loadIncludes("ip");
	$IP=new IP();
	$IP->UpdateIPUse($sid);
}

if($mode == "update" && DEMO != "yes") { 
	if(!isset($msshport)) $msshport="22";
	if(!isset($shownotes)) $shownotes="0";
	if($master == "yes"){ 
		$checkMaster = sql_query($safesql->query("SELECT * FROM servers WHERE master = 'yes' AND sid != '%s'", array($GameCP->whitelist($msid, "clean"))));
		$isMaster=mysql_num_rows($checkMaster);
		if($isMaster != "0") { echo "Master server already exists.<br>Server ".$GameCP->whitelist($msid). " not set as master.<br>"; } else  { $cQuery = ", master='$master'"; }
	} else $cQuery = ", master='$master'"; 
	if(!isset($mvent)) $mvent="0";

	if(isset($os) && $os != "0" && $os != "2" && $winuser){
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		if($winuser != "LocalSystem" && $winuser != "System") $logongranted=$Backend->QueryResponse($msid, $winport, "\$MAINDIRbin\\ntrights.exe:_:-u $winuser +r SeServiceLogonRight");
		if (!preg_match("/successful/i", $logongranted)) echo "Unable to grant the admin user, ".$GameCP->whitelist($winuser)." , logon rights.<br>You will want to login to this server and set service logon rights for this user.<br>";
	}

	$mip = str_replace(' ', '', $mip);

	if($os=="1"){
		$reponame='masterrepowin';
	} else $reponame='masterrepolinux';
	if($masterrepo) sql_query($safesql->query("UPDATE settings SET value='%s' WHERE name='$reponame'", array($masterrepo)));


	sql_query($safesql->query("UPDATE servers SET  
			ip='%s',
			sid='%s',
			name='%s',
			quota='%s',
			cost='%s',
			ts2='%s',
			vent='%s',
			location='%s',
			os='%s',
			winport='%s',
			winuser='%s',
			winadminpass = '%s',
			alias='%s',
			timeout='%i',
			ftpport='%s',
			sshport='%s',
			tsadmin='%s',
			tspass='%s',
			gamehost='%s',
			slotquota='%s',
			ftpmotd='%s',
			ftpadminport='%s',
			ftpadminpass='%s',
			ftpd='%s', 
			mumble='%i', 
			mohawk='%i', 
			ts3host='%i', 
			ts3pass='%s', 
			ts3admin='%s',
			position='%s',
			servernotes='%s',
			shownotes='%i',
			iptablesconf='%s',
			eacdir='%s', 
			cvars='%s', 
			active='%i',
			webroot='%s',
			webrooturl='%s',
			ts2port='%s',
			ts3port='%s',
			parent='%s',
			repo='%s',
			dashboard='%i',
			webservices='%s'
			$cQuery WHERE id='%s'", array($GameCP->whitelist($mip, "clean"), $GameCP->whitelist($mip, "clean"), $GameCP->whitelist($mname, "clean"), $GameCP->whitelist($mquota, "clean"), $GameCP->whitelist($mcost, "clean"), $GameCP->whitelist($mts2, "clean"), $GameCP->whitelist($mvent, "clean"), $GameCP->whitelist($mlocation, "clean"), $GameCP->whitelist($mos, "clean"), $GameCP->whitelist($winport, "clean"), $GameCP->whitelist(@$winuser, "clean"), $GameCP->whitelist(@$winadminpass, "clean"), $GameCP->whitelist($malias, "clean"),$GameCP->whitelist($mtimeout, "clean"), $GameCP->whitelist($mftpport, "clean"), $GameCP->whitelist($msshport, "clean"), $GameCP->whitelist($tsadmin, "clean"), $GameCP->whitelist($tspass, "clean"), $GameCP->whitelist($gamehost, "clean"), $GameCP->whitelist($slotquota, "clean"), $GameCP->whitelist($ftpmotd, "clean"), $GameCP->whitelist($ftpadminport, "clean"), $GameCP->whitelist($ftpadminpass, "clean"), $GameCP->whitelist($ftpd, "clean"), $GameCP->whitelist($mmumble, "int"), $GameCP->whitelist($mmohawk, "int"), $GameCP->whitelist($ts3host, "int"), $GameCP->whitelist($ts3pass, "clean"), $GameCP->whitelist($ts3admin, "clean"), $GameCP->whitelist($mposition, "clean"), 
			$GameCP->whitelist($servernotes, "wysiwyg"), 
			$GameCP->whitelist($shownotes, "int"), 
			$GameCP->whitelist(@$iptablesconf, "clean"), 
			$GameCP->whitelist($eacdir, "clean"), 
			serialize($cvars), 
			$GameCP->whitelist($mactive, "int"), 
			$GameCP->whitelist($webroot, "clean"), 
			$GameCP->whitelist($webrooturl, "clean"), 
			$GameCP->whitelist($ts2port, "clean"), 
			$GameCP->whitelist($ts3port, "clean"), 
			$GameCP->whitelist($parent, "clean"), 
			$GameCP->whitelist($repo, "clean"), 
			$GameCP->whitelist($dashboard, "int"), 
			serialize(@$webservices), 
			$GameCP->whitelist($mid, "clean")))) or die(mysql_error());

	$Event->EventLogAdd('', "Machine ". $mid. " was changed by ".$_SESSION['gamecp']['userinfo']['name']);

	echo "Saved";

	if($mip != $ogmip){
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		$lic_api=$Backend->QueryResponse($mid, '', "lic_changeip:_:$ogmip");

		sql_query($safesql->query("UPDATE usergames SET fastdl='%s' WHERE fastdl='%s'", array($mip, $ogmip)));
		sql_query($safesql->query("UPDATE iptable SET sid='%s' WHERE sid='%s'", array($mip, $ogmip)));
		echo "<script>parent.window.location.reload();</script>";
	}
	
} 

if($mode == "addrange" && DEMO != "yes") { 

	echo $GameCP->whitelist($endip)."<br>";
	echo $GameCP->whitelist($startip)."<br>";

	$endip=explode(".", $endip);
	$startip=explode(".", $startip);

	$aipv1=$endip[0];
	$aipv2=$endip[1];
	$aipv3=$endip[2];
	$aipv4=$endip[3];

	$bipv1=$startip[0];
	$bipv2=$startip[1];
	$bipv3=$startip[2];
	$bipv4=$startip[3];

	if($aipv1 != $bipv1) $ipv1diff = $aipv1-$bipv1; 
	if($aipv2 != $bipv2) $ipv2diff = $aipv2-$bipv2; 
	if($aipv3 != $bipv3) $ipv3diff = $aipv3-$bipv3; 
	if($aipv4 != $bipv4) $ipv4diff = $aipv4-$bipv4; 

	echo $ipv1diff."<br>";
	echo $ipv2diff."<br>";
	echo $ipv3diff."<br>";
	echo $ipv4diff."<br>";

	$diff=$endip+$startip;
	echo $diff;
}

if ($mode == "addip" && DEMO != "yes") {
	$sid=$msid;

	function checkRowA($table, $col, $col2, $val, $val2){
		global $safesql;
		$checkQ=sql_query($safesql->query("SELECT * FROM $table WHERE $col2='%s'", array($val2)));
		$chk=mysql_num_rows($checkQ);
		if($chk >= "1") return "0";
	}
		
	$return="";
	if(count($_POST['mip']) > 0){
		foreach($_POST['mip'] as $gid => $sci) { 
			$ip = str_replace(' ', '', $sci);
			if($ip){
				if(checkRowA("iptable", "sid", "ip", $sid, $ip) != "0")  {
					$return.= "Inserting ip: " . $ip . "<br>";
					sql_query($safesql->query("INSERT INTO iptable SET sid='%s', ip='%s', useinternal='0'", array($GameCP->whitelist($sid, "clean"), $GameCP->whitelist($ip, "clean")))) or die(mysql_error());
				} else $return.=  $ip . " already added<br>";
				
			} // end ip if
		} // end for each
	} // end count
	if(isset($mip2)){
		$ip = str_replace(' ', '', $mip2);
		if($sid && $ip && checkRowA("iptable", "sid", "ip", $sid, $ip) != "0")  {
			$return.=  "Inserting ip: " . $ip . "<br>";
			sql_query($safesql->query("INSERT INTO iptable SET sid='%s', ip='%s', useinternal='0'", array($GameCP->whitelist($sid, "clean"), $GameCP->whitelist($ip, "clean")))) or die(mysql_error());
		} else {
			$return.=  $ip . " already added<br>";
		}
	}

	/* current ips for this machine */
	$result = sql_query($safesql->query("SELECT ip, id, assigned, internal, useinternal FROM iptable WHERE sid ='%s' ORDER BY ip ASC;", array($GameCP->whitelist($sid, "clean")))) or die(mysql_error());

	while ($cipl = mysql_fetch_array($result)){ 
		$ipGamesQ = sql_query($safesql->query("SELECT * FROM usergames UG, iptable I WHERE UG.ip = I.ip AND I.ip = '%s'", array($cipl['ip']))) or die(mysql_error());
		$ipgames=mysql_num_rows($ipGamesQ);
		$cipl['ipGames']=$ipgames;
		$ipaddresses[]=$cipl;
	}
	
	$GameCP->loadIncludes("ip");
	$IP=new IP();
	$IP->UpdateIPUse($msid);

	$smarty->assign("iplist", @$ipaddresses); 
	$smarty->assign("sid", $sid);
	$smarty->assign("gmid", $sid);
	$smarty->assign("result", $return);
	$smarty->display("managemachines/ip-add.tpl");
}

if($mode == "graphs"){
	if(is_file(path."/includes/stats/machines/".$gmid."/graph.rrd")){
		$smarty->assign("gmid", $gmid);
		$smarty->display("managemachines/machine-graphs.tpl");
	}  else {
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->Error("Graphs are not available for this machine.");
		$mode='edit';
	}
} 

if($mode == "edit") { 

	$machineTotal = sql_query("SELECT * FROM `servers`") or die(mysql_error());
	$machineTotal = mysql_num_rows($machineTotal);

	$allmachines=($_SESSION['gamecp']['count'][0]+$_SESSION['gamecp']['count'][1]);
	
	$smarty->assign("machines", $allmachines); 
	$smarty->assign("totalMachines", $machineTotal); 


	$machineList=array();
	$machineinitials=array();

	/* games are sortable by initial or location */
	if(isset($_REQUEST['initial'])){ $cQuery="AND UPPER(LEFT(name,1)) LIKE '".$GameCP->whitelist($_REQUEST['initial'][0])."'"; }
	if(isset($opt) && $opt == "bylocation" && $location){
		$localQ =" AND location = '".$GameCP->whitelist($location)."' ";
	}else $localQ ="";

	if(isset($_REQUEST['mini'])){
		$mq="AND active='1' AND dashboard='1'";
	} else $mq='';

	$machineLimitedQ=$safesql->query("SELECT SQL_CALC_FOUND_ROWS * FROM servers WHERE sid != '' $localQ $cQuery $mq ORDER BY `name` ASC", array());
	$machineLimited=Smarty_PageControl($machineLimitedQ, "machinePage", "machinePage");

	while($row = mysql_fetch_array($machineLimited)){
		$serverGamesQ = sql_query("SELECT UG.id FROM users U, usergames UG, iptable I, servers S WHERE U.active='1' AND U.id = UG.cid AND UG.ip = I.ip AND I.sid = S.sid AND S.sid = '".$row['sid']."'") or die(mysql_error());
		$serverGames=mysql_num_rows($serverGamesQ);

		$row['serverGames']=$serverGames;
		if($row['passphrase'] == ""){
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();
			sql_query($safesql->query("UPDATE servers SET passphrase='%s' WHERE id='%i';", array($Panel->RandomPassword(), $row['id'])));
		}

		if(@is_file(path."/includes/stats/machines/".$row['sid']."/graph.rrd")) $row['showgraphs']=true;
		$row['statscache']=json_decode($row['statscache']);

		$machineList[]=$row;
	} 

	$initialQ = sql_query("SELECT name FROM servers;") or die(mysql_error());
	while ($rowUserDetails = mysql_fetch_array($initialQ)) $machineinitials[]=$rowUserDetails;

	$GameCP->loadIncludes("display");
	$Display=new Display();

	$smarty->assign("machineList", $machineList);
	$smarty->assign("machineInitials", $Display->Initials($machineinitials));
	$smarty->assign("googlemapkey", googlemapkey);

	$smarty->assign("diplay_notifications", "no");

	$smarty->display("managemachines/machine-list.tpl");
} 

if($mode == "migrate") {
	if($gmid){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$serverInfo=$Panel->GetServer($GameCP->whitelist($gmid, "clean"));
		$smarty->assign("serverInfo", $serverInfo); 
		$smarty->display("managemachines/migrate.tpl");
	}
}

if($mode == "migrate2") {

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$isServer=$Panel->GetServer($GameCP->whitelist($newsid, "clean"));
	if(is_array($isServer) && $isServer['sid'] == $newsid){
		$mode = "migrate3";
	}else{
		// can run a check on new sid, if up = skip to step3
		$serverInfo=$Panel->GetServer($GameCP->whitelist($sid, "clean"));
		$GameCP->loadIncludes("backend");
		$Backend=new Backend();
		if(!$serverInfo['winport']) $serverInfo['winport']="240";
		if($distro == "4"){
			$distro="0";
			$_REQUEST['distro']="0";
			$smarty->assign("ubuntu","true");
		}
		$install=$Backend->Install($newsid, $distro, $serverInfo['name'], $serverInfo['location'], $serverInfo['cost'], $serverInfo['slotquota'], $serverInfo['quota'], $serverInfo['sshport'], $serverInfo['ftpport'], $serverInfo['alias'], $serverInfo['ts2'], $serverInfo['vent'], $serverInfo['winport']);
		if(!is_array($install))	$smarty->assign("error", $_SESSION['gamecp']['error']);
		$smarty->assign("passphrase",$install[1]);
		$smarty->assign("newid",$install[0]);
		$smarty->assign("msid",$mip);
		$smarty->assign("winport", $serverInfo['winport']);
		$smarty->assign("distro",$distro);
		$smarty->assign("serverInfo", $serverInfo); 
		$smarty->display("managemachines/migrate2.tpl");
	}
}

if($mode == "migrate3") {
	if($sid){

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$GameCP->loadIncludes("query");
		$Query=new Query();

		$res=$Query->Status($newsid);
		if(!$res){
			$serverInfo=$Panel->GetServer($GameCP->whitelist($newsid, "clean"));
			$smarty->assign("failed", true); 
			$smarty->assign("passphrase",$serverInfo['passphrase']);
			$smarty->assign("newid",$serverInfo['id']);
			$smarty->assign("msid",$serverInfo['sid']);
			$smarty->assign("winport", $serverInfo['winport']);
			$smarty->assign("distro",$serverInfo['distro']);
			$smarty->assign("serverInfo", $serverInfo); 
			$smarty->display("managemachines/migrate2.tpl");
		}else{
			$GameCP->loadIncludes("panel");
			$Panel=new Panel();

			$serverInfo=$Panel->GetServer($GameCP->whitelist($sid, "clean"));
			$smarty->assign("serverInfo", $serverInfo); 

			$iplist=$Panel->GetServerIPs($sid);
			$smarty->assign("iplist", $iplist); 

			if($_REQUEST['games'] == "1"){
				$userList=$Panel->GetServerUsers($sid);
				$smarty->assign("userList", $userList); 
			}

			$GameCP->loadIncludes("backend");
			$Backend=new Backend();
			$newlist=$Backend->QueryResponse($newsid, '', "iplist:_:");
			$newlist=str_replace(" ", "\n", $newlist);
			$smarty->assign("newIplist", explode("\n",$newlist)); 

			$smarty->display("managemachines/migrate3.tpl");
		}

	}
}

if($mode == "migrate4") {
	if($sid){
		$reply="";
		$_SESSION['gamecp']['migrate']="";
		$GameCP->loadIncludes("panel");
		$GameCP->loadIncludes("query");
		$Panel=new Panel();
		$Query=new Query();

		if((isset($backend) && $backend == "1") || is_array($users)){
			if(!$Query->Status($sid) || !$Query->Status($newsid))
				return $Panel->Error("One of the remote servers is offline");
			$GameCP->loadIncludes("user");
			$User=new User();
		}

		if(isset($backend) && $backend == "1"){
			$fname="gamecpcopy";
			$ubash = "/sbin/nologin"; 
			$fpassword=$Panel->RandomPassword();

			$reply.= "Validating `$fname` on  $newsid<br>";

			if(!$User->CheckThenAdd($newsid,$fname, $fpassword, $ubash) || !$User->CheckThenAdd($sid,$fname, $fpassword, $ubash)) return $Panel->Error("Unable to create `$fname`");
			
			$GameCP->loadIncludes("ftp");
			$FTP=new FTP();
			if(!$FTP->Status($newsid, $fname, $fpassword))
				return $Panel->Error("User was added to server but was unable to access FTP $newsid & $sid, $fname, $fpassword");
		
			$reply.= "Copying installs from $sid to $newsid using lftp...<br>";
			$GameCP->loadIncludes("linux");
			$Linux=new Linux();
			$Linux->MoveFTP($fname, $fpassword, $sid, $newsid, "installs", "installs", 'gameinstalls', '', 'lftp', $ftpport);
			$Linux->Screen($sid, "bash /home/$fname/ftpcmdgameinstalls.sh", '', $fname, true);
			$_SESSION['gamecp']['migrate']['backend']=true;

		}
		
		if(is_array($users)){
			foreach($users as $u => $uid){
				$GameCP->loadIncludes("game");
				$Game=new Game();
				foreach($Panel->GetUserGames($uid) as $uginfo){
					if(is_array($newip) && isset($newip[$uginfo['ip']])){
						if($newip[$uginfo['ip']]){
							$reply.= "Moving user# $uid, game#".$uginfo['ugid']."<br>";
							$_SESSION['gamecp']['migrate']['usergame'][$uginfo['ugid']]=array(
									"sid"=> $sid,
									"username"=> $uginfo['username'], 
									"password"=> $uginfo['password'], 
									"newip"=>$newip[$uginfo['ip']]
								);

							$Game->Move($uginfo['ugid'], $newip[$uginfo['ip']], $uginfo['port']);		
						}
					}
				}
			}
		}

		if(is_array($newip)) $_SESSION['gamecp']['migrate']['iplist']=$newip;

		$_SESSION['gamecp']['migrate']['sid']=$sid;
		$_SESSION['gamecp']['migrate']['newsid']=$newsid;
		$smarty->assign("reply", $reply); 
		$smarty->assign("sid", $sid); 
		$smarty->assign("newsid", $newsid); 
		$smarty->display("managemachines/migrate4.tpl");

	}
}

if($mode == "migratecheck"){
	$GameCP->loadIncludes("backend");
	$Backend=new Backend();
	$GameCP->loadIncludes("linux");
	$Linux=new Linux();
	$GameCP->loadIncludes("game");
	$Game=new Game();
	$okips=true;

	if(is_array($_SESSION['gamecp']['migrate']['usergame'])){
		$movest="";
		foreach($_SESSION['gamecp']['migrate']['usergame'] as $ugid => $uginfo){
			$moveStatus=$Game->MoveCheck($ugid, true);
			if(!$moveStatus[0]){
				echo "Move completed for: ".$uginfo['username']."<br>";
				unset($_SESSION['gamecp']['migrate']['usergame'][$ugid]);
			} else $okips=false;
			$movest.=$moveStatus[1];
		}
	}
	
	if($_SESSION['gamecp']['migrate']['sid'] && isset($_SESSION['gamecp']['migrate']['backend'])){
		$moveStatus=$Linux->Watch($_SESSION['gamecp']['migrate']['sid'], "", "gamecpcopy", true);
		if($moveStatus[0]){
			echo "Copying service install files<br>";
			$movest.=$moveStatus[1];
		} else {
			echo "Service install files copied<br>";
			unset($_SESSION['gamecp']['migrate']['sid']);
		}
	}


	if(trim($movest)) echo "<br><br><h3>Log</h3><br><textarea style='width: 90%; height: 180px;'>$movest</textarea>";


	if(is_array($_SESSION['gamecp']['migrate']['iplist'])){
		foreach($_SESSION['gamecp']['migrate']['iplist'] as $old => $new){
			if($new && $okips){
				echo "Database Update: $old to $new<br>";
				unset($_SESSION['gamecp']['migrate']['iplist'][$old]);
			}
		}
	}

	if(
		((is_array($_SESSION['gamecp']['migrate']['usergame']) && count($_SESSION['gamecp']['migrate']['usergame']) == 0) || !is_array($_SESSION['gamecp']['migrate']['usergame']) ) &&
		//((is_array($_SESSION['gamecp']['migrate']['iplist']) && count($_SESSION['gamecp']['migrate']['iplist']) == 0) || !is_array($_SESSION['gamecp']['migrate']['iplist']) )  &&
		((is_array($_SESSION['gamecp']['migrate']['sid']) && count($_SESSION['gamecp']['migrate']['sid']) == 0) || !is_array($_SESSION['gamecp']['migrate']['sid']) ) 
	){
		echo "<br><br><input type=\"button\" value=\"Completed\" onclick=\"window.location='machines.php'\"><script>$('#pleasewait').hide();</script>";
	}
}

if($mode == "directions"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$row=$Panel->GetServer($GameCP->whitelist($gmid, "clean"));
	$smarty->assign("passphrase",$row['passphrase']);
	$smarty->assign("newid",$row['id']);
	$smarty->assign("msid",$row['sid']);
	if($row['winport'] == "") $row['winport']="240";
	$smarty->assign("winport",$row['winport']);

	$smarty->display("managemachines/new-completed.tpl");
}

if($mode == "edit2") {

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$row=$Panel->GetServer($GameCP->whitelist($gmid, "clean"));
	
	$sid = $row['sid'];
	$os=$row['os'];
	$ipaddresses=array();

	/* current ips for this machine */
	$result = sql_query($safesql->query("SELECT ip, id, assigned, internal, useinternal FROM iptable WHERE sid ='%s' ORDER BY ip ASC;", array($GameCP->whitelist($gmid, "clean")))) or die(mysql_error());

	while ($cipl = mysql_fetch_array($result)){ 
		$ipGamesQ = sql_query($safesql->query("SELECT * FROM usergames UG, iptable I WHERE UG.ip = I.ip AND I.ip = '%s'", array($cipl['ip']))) or die(mysql_error());
		$ipgames=mysql_num_rows($ipGamesQ);
		$cipl['ipGames']=$ipgames;
		$ipaddresses[]=$cipl;
	}
	
	$parents='';
	$result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
	while ($rowa = mysql_fetch_array($result)) {
		if($rowa['sid'] == $row['parent']){
			$sel="selected=selected";
		} else $sel='';
		$parents.= "<option value=\"". $rowa['sid'] ."\" $sel>". $rowa['name']."</option>"; 
	}
	$smarty->assign("parents", $parents); 

	if($row['os']=="1"){
		$smarty->assign("masterrepo", masterrepowin);
	} else $smarty->assign("masterrepo", masterrepolinux); 

	$webservices=unserialize($row['webservices']);
	if(!is_array($webservices)) $webservices=array();
	$smarty->assign("iplist", $ipaddresses); 
	$smarty->assign("gmid", $gmid); 
	$smarty->assign("machineInfo", $row); 
	$smarty->assign("cvars", unserialize($row['cvars'])); 
	$smarty->assign("webservices", $webservices); 
	
	$smarty->display("managemachines/machine-edit.tpl");
}

if($mode == "viewdetail") {
	if(isset($sid)) $sid = $GameCP->whitelist($_REQUEST['sid'], 'clean');
	if(isset($ipid)){
		$ipid = $GameCP->whitelist($_REQUEST['ip'], 'clean');
		$ipinfo = sql_query($safesql->query("SELECT sid, ip FROM iptable WHERE id = '%i'", array($ipid))); 
		$ipinfo = mysql_fetch_row($ipinfo);
		$sid=$ipinfo[0];
		$ip=$ipinfo[1];
		$ipq="";

	} elseif(isset($sid)){
		$ipq=$safesql->query(" AND I.sid='%s'", array($sid));
		$_REQUEST['sid']=$sid;
	}

	if(isset($idd)) { 
			$query = "AND U.id = '$idd'";
			$sidQ = sql_query($safesql->query("SELECT S.sid FROM servers S, users U, usergames UG, iptable I WHERE S.sid = I.sid AND UG.cid = U.id AND U.id ='%s'", array($GameCP->whitelist($idd, "clean"))));
			$sid = mysql_fetch_row($sidQ); $sid = $sid[0];
	} else $query = "";

	$totalPriceQ = sql_query($safesql->query("SELECT sum(gross) FROM billing B, users U, usergames UG, iptable I WHERE I.sid='%s' AND UG.ip = I.ip  AND UG.cid = U.id AND B.cid = U.id $ipq", array($sid))); 
	$totalPrice = mysql_fetch_row($totalPriceQ); $totalPrice = $totalPrice[0];
	$totalCostQ = sql_query($safesql->query("SELECT cost, quota FROM servers WHERE sid = '%s'", array($sid))); 
	$totalCost = mysql_fetch_row($totalCostQ);
	$totalCost = $totalCost[0];
	if(isset($totalCost[1])){
		$quota = $totalCost[1];
	} else $quota='';
	$total = $totalPrice - $totalCost;

	$info = sql_query($safesql->query("SELECT distinct(UG.cid) FROM 
							usergames UG, iptable I
						WHERE
							I.sid='%s' AND UG.ip = I.ip $ipq", array($sid))) or die(mysql_error());
	$machineoverview=array();
	$GameCP->loadIncludes("query");
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Query=new Query();
	while ($serverdetails =  mysql_fetch_array($info)) {

		$cid = $serverdetails['cid'];
		$userinfo=$Panel->GetUser($cid);

		if(is_array($userinfo)){

			$smarty->assign("cid", $cid);
			
			/* there is some user details so lets find their games */
			$resultQ = sql_query($safesql->query("SELECT UG.ip, UG.port, UG.id, UG.active FROM usergames UG, game G, users U, iptable I WHERE I.ip = UG.ip AND I.sid='%s' AND U.id = UG.cid AND  UG.gid = G.id AND U.id = '%i'", array($sid,$cid))) or die(mysql_error());

			$usersgames=array();

			while($result = mysql_fetch_array($resultQ)){
				if(isset($result[0]) && (!isset($ipid) || isset($ipid) && $result['ip'] = $ip)) { 
					
					if($result['active'] == "1"){
						$status=$Query->GameQ($result['id']);
						$sp=$status[3];
						$result['sp']=$sp;
					}

					$usersgames[]=$result;
				}
			}

			$userinfo['gameinfo']=$usersgames;
			$machineoverview[]=$userinfo;
		
		}
	} 

	$smarty->assign("overview", $machineoverview);
	$smarty->assign("sid", $sid);
	$smarty->assign("total", $total);
	$smarty->assign("totalCost", $totalCost);
	$smarty->assign("totalPrice", $totalPrice);
	$smarty->assign("quota", $quota);


	$smarty->display("managemachines/machine-overview.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>