<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


if(!empty($_GET)) extract($_GET, EXTR_SKIP);
if(!empty($_POST)) extract($_POST, EXTR_SKIP);
if(!isset($_REQUEST['mode'])) $mode="";
if(!isset($validQ)) $validQ="";

if($mode == "add") { 
	if(!isset($fmip)) $fmip="no";
	@$cookieArray = "$fsendinfo-$doQueue-$startserver-$loginpath-$fmip-$fmaxclients-$subdirectory";
	@setcookie("gcp-newuser-field", $cookieArray, time()+900000, '', '', '', true); 
	$_REQUEST['addserver']=true;
}

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($mode) || !$mode) $mode ="new";

$GameCP->CheckPermissions('newservice');

$GameCP->SetURLCookie();

$smarty->assign('page_title', $LNG_CREATESERVICE);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "5" && $_SESSION['gamecp']['userinfo']['ulevel'] != "4"){
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->loadIncludes("billing");
$Billing=new Billing(); 


if($mode == "add") { 

	$failed=false;
	$rsid="";
	if( $_SESSION['gamecp']['userinfo']['ulevel'] == "4" && doreselleraddon == "1") $rsid=$_SESSION['gamecp']['userinfo']['id'];
	if(!$fmip) $fmip="no";
	if(isset($flimit)) $flimit="+1";
	if(!isset($installtype)) $installtype="install";
	if(!isset($loginpath)) $loginpath="no";
	if(!isset($fmanager)) $fmanager="2";
	if(!isset($fpubpriv)) $fpubpriv="";
	if(!isset($voiceType)) $voiceInstall="";

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();

	if($existinguser){
		$existingsignup=true;
		$fname=$existinguser;
	} else {
		$existingsignup=false;
		/* we assign this name here but it will be re-assigned after the user is added */
		$totalClientsQ = sql_query("SELECT Auto_increment FROM information_schema.tables WHERE table_name='users';") or die(mysql_error()); 
		$totalClients=mysql_fetch_array($totalClientsQ);
		$lastId=$totalClients[0];
		$fname=userprefix.$lastId;
	}

	/* auto info */
	if(!isset($pid) && $gameInstall == "yes") {
		$gamesQ = sql_query("SELECT id, name FROM game WHERE `active` = '1' LIMIT 1;") or die(mysql_error()); 
		$games=mysql_fetch_array($gamesQ);
		$gameId=$games['id'];
		$gameName=$games['name'];
		$pid=$gameId;
	}
	if($gameInstall != "yes") $pid="";
	

	if($orderterm == "onetime"){		$daystill="0";		} else
	if($orderterm == "hourly"){			$daystill="1";		} else
	if($orderterm == "monthly"){		$daystill="31";		} else
	if($orderterm == "quarterly"){		$daystill="91";		} else
	if($orderterm == "semiannualy"){	$daystill="182";	} else
	if($orderterm == "annualy"){		$daystill="365";	} else
	if($orderterm == "2years"){			$daystill="730";	} else $daystill="31"; 

	if($addbill == "yes"){
		if($gamepack){
			$packageInfo = sql_query($safesql->query("SELECT cost as 'monthly', fee, name, quarterly, semiannualy, annauly, 2years, slots, rate as 'hourly', id FROM prices WHERE id='%i' ORDER BY pid, rank", array($GameCP->whitelist($gamepack, "int")))) or die(mysql_error());
			$gpackdata=mysql_fetch_array($packageInfo);
			if(!isset($gamecost) || isset($gamecost) && !$gamecost) $gamecost=$gpackdata[$orderterm];
			if(!isset($gamefee) || isset($gamefee) && !$gamefee) $gamefee=$gpackdata['fee'];
			$ordergame=array("id"=>$gamepack, "cost"=>$Panel->RemFormatNumber($gamecost), "fee"=>$Panel->RemFormatNumber($gamefee));
		}
		if($voicepack){
			$packageInfo = sql_query($safesql->query("SELECT cost as 'monthly', fee, name, quarterly, semiannualy, annauly, 2years, slots, rate as 'hourly', id FROM prices WHERE id='%i' ORDER BY pid, rank", array($GameCP->whitelist($voicepack, "int")))) or die(mysql_error());
			$gpackdata=mysql_fetch_array($packageInfo);
			if(!isset($voicecost) || isset($voicecost) && !$voicecost) $voicecost=$gpackdata[$orderterm];
			if(!isset($voicefee) || isset($voicefee) && !$voicefee) $voicefee=$gpackdata['fee'];
			$ordervoice= array("id"=>$voicepack, "cost"=>$Panel->RemFormatNumber($voicecost), "fee"=>$Panel->RemFormatNumber($voicefee));
		}
	}

	if(isset($paddon) && is_array($paddon) && count($paddon) > 0){
		require_once(path.'/includes/core/classes/billing/order.inc.php');
		$Order=new Order();
		$ProcessAddonCost=$Order->ProcessAddonCost($paddon, $orderterm, $t);
		$are=$ProcessAddonCost[0];
		$paddons=$ProcessAddonCost[1];
		$atotal=$ProcessAddonCost[2];
	}

	if($failed != true){
		$queue="1";
		$smarty->assign("insertedq", "true");
		$modQ=array(
				'fname'				=> @$fname,
				'femail'			=> @$femail, 
				'pid'				=> @$pid, 
				'fusername'			=> @$fname, 
				'fuserlevel'		=> '0', 
				'fpassword'			=> @$fpassword, 
				'fip'				=> @$fip, 
				'fport'				=> @$fport, 
				'phone'				=> @$phone, 
				'address'			=> utf8_encode(@$address), 
				'city'				=> utf8_encode(@$city), 
				'state'				=> utf8_encode(@$state), 
				'country'			=> utf8_encode(@$country), 
				'zip'				=> @$zip, 
				'clienturl'			=> @$clienturl, 
				'installtype'		=> @$installtype, 
				'fnote'				=> utf8_encode(@$extrainfo), 
				'firstname'			=> @$firstname, 
				'lastname'			=> @$lastname, 
				'payment'			=> @$payment, 
				'address2'			=> @$address2, 
				'loginpath'			=> @$loginpath, 
				'today'				=> date(dateformat, time()), 
				'fconfig'			=> @$fconfig, 
				'fport'				=> @$fport, 
				'fstartmap'			=> @$fstartmap, 
				'clan'				=> @$clan, 
				'fmaxclients'		=> @$fmaxclients, 
				'fpubpriv'			=> @$fpubpriv, 
				'date'				=> @$date, 
				'status'			=> @$status, 
				'gross'				=> $Panel->RemFormatNumber(@$gross), 
				'fee'				=> $Panel->RemFormatNumber(@$fee), 
				'daystill'			=> @$daystill, 
				'startserver'		=> @$startserver, 
				'fsendinfo'			=> @$fsendinfo, 
				'addbill'			=> @$addbill, 
				'orderpage'			=> "1", 
				// this is the package ID used in billing
				'ordergame'			=> array("id"=>@$gamepack, "cost"=>$Panel->RemFormatNumber(@$gamecost), "fee"=>$Panel->RemFormatNumber(@$gamefee)),
				// the package id for voice
				'ordervoice'		=> array("id"=>@$voicepack, "cost"=>$Panel->RemFormatNumber(@$voicecost), "fee"=>$Panel->RemFormatNumber(@$voicefee)),
				'fmip'				=> @$fmip, 
				'queueNULL'			=> @$queue, 
				'voiceInstall'		=> @$voiceInstall, 
				'voiceType'			=> @$voiceType, 
				'voiceMaxClients'	=> @$voiceMaxClients, 
				'RCONPASSWORD'		=> @$RCONPASSWORD, 
				'SPECPASSWORD'		=> @$SPECPASSWORD, 
				'PRIVPASSWORD'		=> @$fprivpass, 
				'subscr_id'			=> FALSE, 
				'HOSTNAME'			=> @$hostname, 
				'MOTD'				=> @$motd, 
				'WEBSITE'			=> @$clienturl, 
				'freseller'			=> @$rsid, 
				'start_time'		=> '',
				'end_time'			=> '',
				'voiceName'			=> @$voiceName, 
				'voiceIP'			=> @$voiceIP, 
				'voicePort'			=> @$voicePort, 
				'taxvoice'			=> @$taxvoice, 
				'taxproduct'		=> @$taxproduct, 
				'subdirectory'		=> @$subdirectory, 
				'location'			=> '', 
				'existingsignup'	=> @$existingsignup, 
				'billingid'			=> @$billingid, 
				'servicebillingid'	=> @$servicebillingid, 
				'flimit'			=> @$flimit, 
				'extrainfo'			=> @$extrainfo, 
				'promo'				=> '', 
				'paidPrice'			=> '', 
				'transactionid'		=> '', 
				'suspend_notpaid'	=> '', 
				'paddons'			=> serialize(@$paddons), 
				'paddonsOriginal'	=> serialize(@$paddon), 
				'taxaddon'			=> '', 
				'fmanager'			=> @$fmanager,
				'demo'				=> @$demo
			);

		sql_query($safesql->query("INSERT INTO queue SET ref='1', user='%s',`mod`='%s', rundate='%s';", array($GameCP->whitelist($fname, "clean"), serialize($modQ), strtotime($queuedate)))) or die(mysql_error());
		$qid=mysql_insert_id();
		$smarty->assign("qid", $qid);

		if($doQueue != "yes") $Panel->ExecQueue($qid);
	} else $smarty->assign("insertedq", "false");

	$smarty->assign("queuedate", $GameCP->whitelist($queuedate, 'clean'));
	$smarty->assign("doQueue", $GameCP->whitelist($doQueue));
	$smarty->display("manageusers/addserver-footer.tpl");
}

if($mode == "new") {
	if($_SESSION['gamecp']['userinfo']['ulevel'] == "4"){
		$GameCP->loadIncludes("user");
		$User=new User();
		$User->CheckResellerLimits(true);
	}
	if(isset($_COOKIE["gcp-newuser-field"])){
		$cookie=$_COOKIE["gcp-newuser-field"];
		$cookieArray = explode("-", $cookie);
		$asendinf=$cookieArray[0];
		$adoqueue=$cookieArray[1];
		$astartserver=$cookieArray[2];
		$aloginpath=$cookieArray[3];
		$afmip=$cookieArray[4];
		$afmaxclients=$cookieArray[5];
		$afshared=$cookieArray[6];
	} else {
		$asendinf='';
		$adoqueue='';
		$astartserver='';
		$aloginpath='';
		$afmip='';
		$afmaxclients='';
		$afshared='';
	}

	$smarty->assign("asendinf", $asendinf);
	$smarty->assign("adoqueue", $adoqueue);
	$smarty->assign("astartserver", $astartserver);
	$smarty->assign("aloginpath", $aloginpath);
	$smarty->assign("afmip", $afmip);
	$smarty->assign("afmaxclients", $afmaxclients);
	$smarty->assign("afshared", $afshared);

	$GameCP->loadIncludes("display");
	$Display=new Display();

	$smarty->assign("gameList",$Display->GameIPList(true));
	$smarty->assign("machineIPList",$Display->MachineIPList(true)); 
	$GameCP->generateUserList();
	$smarty->assign("userList", $GameCP->userList);

	$showVoice = sql_query("SELECT ip, name, sid FROM servers WHERE ts2='1' OR vent='1' OR ts3host ='1'") or die(mysql_error());
	if(mysql_num_rows($showVoice) > 0 || usedarkstarvent == 'yes'){ 
		$GameCP->loadIncludes("display");
		$Display=new Display();
		$smarty->assign("showvoice", "yes");
		$smarty->assign("voicelist",$Display->VoiceIPList()); 
	}

	$resellers=array();
	

	if( $_SESSION['gamecp']['userinfo']['ulevel'] != "4"){
		$packageResult = sql_query("SELECT id, name FROM users WHERE userlevel='4'") or die(mysql_error());
		while ($row1 = mysql_fetch_array($packageResult)) $resellers[]=$row1['name'];
	} else $resellers[]=$_SESSION['gamecp']['userinfo']['username'];
	$smarty->assign("resellerList", $resellers);

/*
	$game = sql_query("SELECT P.name as 'pname', UP.id, UP.name FROM packages P, prices UP WHERE UP.pid = P.id AND (gid !='1000' AND gid !='1002' AND gid !='1003' AND gid !='1004') ORDER BY UP.pid, UP.rank") or die(mysql_error());
	$p=array();
	while ($pg = mysql_fetch_array($game)) {
		if($pg['name']) $p[]=array("id"=>$pg['id'], "name"=>$pg['name'], "pname"=>$pg['pname']);
	}
	$smarty->assign("packages", $p);
*/
	$game = sql_query("SELECT P.name as 'pname', UP.id, UP.name FROM packages P, prices UP WHERE UP.pid = P.id AND (gid = '1000' OR gid = '1002' OR gid = '1003' OR gid ='1004') ORDER BY UP.pid, UP.rank") or die(mysql_error());
	$p=array();
	while ($pg = mysql_fetch_array($game)) {
		if($pg['name']) $p[]=array("id"=>$pg['id'], "name"=>$pg['name'], "pname"=>$pg['pname']);
	}
	$smarty->assign("voicepackages", $p);


	$smarty->display("manageusers/addserver.tpl");
}

require_once(path.'/includes/core/editable/footer.inc.php');

?>
