<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/

require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($mode) || isset($mode) && !$mode) $mode = "edit";

$GameCP->CheckPermissions('notify');

$smarty->assign('page_title', $LNG_CLIENTMANAGEMENT);

if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1" && $_SESSION['gamecp']['userinfo']['ulevel'] != "2" && $_SESSION['gamecp']['userinfo']['ulevel'] != "3") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(isset($_REQUEST['idd'])){
	$_REQUEST['idd']=$GameCP->whitelist($_REQUEST['idd'], "int");
	$cronid=$_REQUEST['idd'];
}


function SendMass($cid){
	global $Email;

	$Email->userid = $cid;

	if ($_SESSION['gamecp']['mailtpl']) {
		$Email->templatename = $_SESSION['gamecp']['mailtpl'];
	} else {
		$Email->emailsubject = $_SESSION['gamecp']['mailsubject'];
		$Email->emailbody = $_SESSION['gamecp']['mailbody'];
	}
	$Email->GetTemplateStuff();

	$Email->usegamedata = true;
	$Email->usevoicedata = true;
	$Email->usebilldata = true;

	$Email->ReplaceStuff();
	$Email->send();

}

$GameCP->loadIncludes("email");



	if ($mode == "sendmasspre") $Email->Confirm($mode, $idd, $predefined); 
	if ($mode == "sendmass"){
		if(is_array($sendto)){
			foreach($_SESSION['gamecp']['massmail'] as $sm => $smm){
				if(!in_array($sm, $sendto)) unset($_SESSION['gamecp']['massmail'][$sm]);
			}
		}
		$Email->Confirm($mode, $idd, $predefined, $subject, $body); 
	}
	if ($mode == "send") $Email->Confirm($mode, $idd, $predefined, $subject, $body); 
	if ($mode == "sendpre") $Email->Confirm($mode, $idd, $predefined); 

	if(isset($doValid) && $doValid == "No") die("<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/system/index.php\">");


	// SEND ALL
	if ($mode == "DOsendmasspre" || $mode == "DOsendmass") {

		unset($_SESSION['gamecp']['mailtotal'],$_SESSION['gamecp']['mailsubject'],$_SESSION['gamecp']['mailbody'],$_SESSION['gamecp']['mailtpl']);
		$_SESSION['gamecp']['mailsubject']=$_POST['subject'];
		$_SESSION['gamecp']['mailbody']=$_POST['body'];
		$_SESSION['gamecp']['mailtpl']=$predefined;
		$_SESSION['gamecp']['mailtotal']=count($_SESSION['gamecp']['massmail']);
		$mode="next";

	}

	if($mode == "next"){
		$i=0;
		foreach($_SESSION['gamecp']['massmail'] as $mid => $userinfo){
			$list.="<li>".$userinfo[1]."</li>";
			SendMass($userinfo[0]);
			unset($_SESSION['gamecp']['massmail'][$mid]);
			$i++;
			if($i == 10){
				$smarty->assign("nextpage", "true");
				break;
			}
		}

		$smarty->assign("sent", $_SESSION['gamecp']['mailtotal']-count($_SESSION['gamecp']['massmail']));
		$smarty->assign("list", $list);
		$smarty->assign("mailtotal", $_SESSION['gamecp']['mailtotal']);
		$smarty->display("notify/mailcompleted.tpl");
	}


	// SEND PRE-DEFINED EMAIL
	if ($mode == "DOsendpre") {
		$Email->userid = $idd;
		$Email->templatename = $predefined;
		$Email->GetTemplateStuff();


		$Email->usegamedata = true;
		$Email->usevoicedata = true;
		$Email->usebilldata = true;

		$Email->ReplaceStuff();
		$Email->send();

		if(debugging =="0") { echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/system/index.php\">"; }
	}

	// SEND REGULAR EMAIL
	if ($mode == "DOsend") {
		$Email->userid = $idd;

		$Email->emailsubject = $subject;
		$Email->emailbody = $body;

		$Email->usegamedata = true;
		$Email->usevoicedata = true;
		$Email->usebilldata = true;

		$Email->ReplaceStuff();
		$Email->send();

		if(debugging =="0") { echo "<meta http-equiv=\"Refresh\" content=\"".$pgrefresh.";url=". $url . "/system/index.php\">"; }
	}



	if($mode == "edit") { 

		$result = sql_query("SELECT * FROM emails") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){
			$smarty->append("emailList", $row);
		}

		$userNameQ = sql_query($safesql->query("SELECT name, email FROM users WHERE id ='%i' LIMIT 1;", array($GameCP->whitelist($idd, "int")))) or die(mysql_error());
		$userNameR = mysql_fetch_row($userNameQ); 
		$userName = $userNameR[0]; 
		$userEmail = $userNameR[1];



		$smarty->assign("userName", $userName);
		$smarty->assign("userEmail", $userEmail);
		$smarty->assign("idd", $idd);

		$smarty->display("notify/send.tpl");

	} 

	if($mode == "sendall") {

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();

		$userListArray=$Panel->FetchMultiArray("SELECT id, name, firstname, lastname,email FROM users WHERE userlevel = '0' ORDER BY 'name'");
		$gameListArray=$Panel->FetchMultiArray("SELECT id, name FROM game WHERE active='1' ORDER BY 'name'");
		$machineListArray=$Panel->FetchMultiArray("SELECT id, name FROM servers ORDER BY 'name'");


		$smarty->assign("gameList", $gameListArray);
		$smarty->assign("userList", $userListArray);
		$smarty->assign("machineList", $machineListArray);

		$result = sql_query("SELECT * FROM emails") or die(mysql_error());
		while ($row = mysql_fetch_array($result)) $smarty->append("emailList", $row);
		


		$local = sql_query("SELECT DISTINCT(location) as 'name', id FROM servers") or die(mysql_error());
		$locations=array();
		while ($row = mysql_fetch_array($local)) $locations[]=array('id' => $row['id'], 'name' => $row['name']);
		$smarty->assign("locations", $locations);

		$smarty->display("notify/sendall-pre.tpl");
	}

	if($mode == "sendmassbuild"){
		if(!isset($clientStatus)) $clientStatus=array("1");
		$sent=array();

		if($mailtype == "users"){
			if(isset($user_user) && is_array($user_user) && count($user_user) > 0){
				$q="SELECT id, email FROM users WHERE userlevel='0' AND email !='' AND id IN (".implode(',', $user_user).") AND active IN (".implode(',', $clientStatus).") ";
				$UserInfoQ = sql_query($safesql->query($q, array())) or die(mysql_error());
				while ($UserInfo = mysql_fetch_array($UserInfoQ)) { 
					if($UserInfo[1] && !in_array($UserInfo[0], $sent)) $sent[]=array("id"=>$UserInfo[0], "email"=>$UserInfo[1]);	
				}
			}
		}

		if($mailtype == "location"){
			if(isset($local_locations) && is_array($local_locations) && count($local_locations) > 0){
				$q="SELECT U.id, U.email FROM users U, servers S, iptable I, usergames UG WHERE U.userlevel='0' AND U.email !='' AND U.active IN (".implode(',', $clientStatus).") AND S.location IN ('".implode("','", $local_locations)."') AND I.sid = S.sid AND I.ip = UG.ip AND UG.cid = U.id";
			}elseif(isset($local_machine) && is_array($local_machine) && count($local_machine) > 0)
				$q="SELECT U.id, U.email FROM users U, servers S, iptable I, usergames UG WHERE U.userlevel='0' AND U.email !='' AND U.active IN (".implode(',', $clientStatus).") AND S.id IN ('".implode("','", $local_machine)."') AND I.sid = S.sid AND I.ip = UG.ip AND UG.cid = U.id";
			if($q){
				$UserInfoQ = sql_query($safesql->query($q, array())) or die(mysql_error());
				while ($UserInfo = mysql_fetch_array($UserInfoQ)) { 
					if($UserInfo[1] && !in_array($UserInfo[0], $sent)) $sent[]=array("id"=>$UserInfo[0], "email"=>$UserInfo[1]);	
				}
			}
		}
		if($mailtype == "services"){


			if($service_voice){
				$gq="AND U.id=UV.cid AND UV.voicetype IN ('".implode("','", $service_voice)."')";
				if($service_locations) $gq." AND I.ip = UV.ip AND UV.cid = U.id";
				$tq = ", uservoice UV";
			}
			if($service_game){
				$gq="AND U.id=UG.cid AND UG.gid IN ('".implode("','", $service_game)."')";
				if($service_locations) $gq." AND I.ip = UG.ip AND UG.cid = U.id";
				$tq = ", usergames UG";
			}
			if($service_game && $service_voice){
				if($service_locations) $gq." AND I.ip = UG.ip AND UG.cid = U.id AND I.ip = UV.ip AND UV.cid = U.id";
				$gq="AND (U.id=UG.cid AND UG.gid IN ('".implode("','", $service_game)."') OR U.id=UV.cid AND UV.voicetype IN ('".implode("','", $service_voice)."'))";
				$tq = ", usergames UG, uservoice UV";
			}
			if($service_machine){
				$mq=" AND S.id IN ('".implode("','", $service_machine)."') AND I.sid = S.sid";
				$tq2 = ", servers S, iptable I";
				if($tq == "") $tq2.=", usergames UG";
			}
			if($service_locations){
				$mq=" AND S.location IN ('".implode("','", $service_locations)."') AND I.sid = S.sid";
				$tq2 = ", servers S, iptable I";
				if($tq == "") $tq2.=", usergames UG";
			}

			$q="SELECT distinct(U.email), U.id FROM users U $tq $tq2 WHERE U.userlevel='0' AND U.email !='' AND U.active IN (".implode(',', $clientStatus).") $gq $mq";
			$UserInfoQ = sql_query($safesql->query($q, array())) or die(mysql_error());
			while ($UserInfo = mysql_fetch_array($UserInfoQ)) { 
				if($UserInfo[0] && !in_array($UserInfo[1], $sent))  $sent[]=array("id"=>$UserInfo[1], "email"=>$UserInfo[0]);
			}

		}

		foreach($sent as $mid => $add){
			$_SESSION['gamecp']['massmail'][$add['id']]=array($add['id'],$add['email']);
		}

		if($predefined){
			$result = sql_query($safesql->query("SELECT * FROM emails WHERE id='%s' LIMIT 1", array($predefined))) or die(mysql_error());
			$predefined = mysql_fetch_assoc($result);
			$smarty->assign("predefined", $predefined);
		}

		$smarty->assign("mailto", $sent);
		$smarty->display("notify/sendall-post.tpl");


	}



require_once(path.'/includes/core/editable/footer.inc.php');

?>