<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

*/


require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

if(!isset($_REQUEST['mode']) || isset($_REQUEST['mode']) && empty($_REQUEST['mode'])) $_REQUEST['mode'] = "edit";

$GameCP->CheckPermissions('portal');

$smarty->assign('page_title', $LNG_PORTALMANAG);

if ($_SESSION['gamecp']['userinfo']['ulevel'] != "1") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if ($_REQUEST['mode'] == "remove" && DEMO != "yes") {
	$nid=$GameCP->whitelist($_REQUEST['nid']);
	$file="../includes/template/default/smarty/portal/".$nid;
	if(is_file($file)) unlink($file);

	$smarty->assign("showSaved", true);
	$_REQUEST['mode'] = "edit";
}

if ($_REQUEST['mode'] == "update" && DEMO != "yes") { 
	$pcontent=$GameCP->whitelist($_REQUEST['content'], 'web');

	$nid=$GameCP->whitelist($nid);
	$ffile="../includes/template/default/smarty/portal/".$nid;
	if(is_file($ffile)){

		$fp = fopen($ffile, 'w');
		fwrite($fp, $pcontent);
		fclose($fp);

		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
	
		$Panel->RemoveCache();

		 echo "Saved";
	}


	
}

if ($_REQUEST['mode'] == "add" && DEMO != "yes") {

	$pcontent=$GameCP->whitelist($_REQUEST['content'], 'web');
	$ptitle=str_replace(" ", "", $GameCP->whitelist($_REQUEST['title']));

	$ffile="../includes/template/default/smarty/portal/".$ptitle.".tpl";
	if(!is_file($ffile)){

		$fp = fopen($ffile, 'w');
		fwrite($fp, $pcontent);
		fclose($fp);
		
		$smarty->assign("showSaved", true);
	}


	$_REQUEST['mode'] = "edit";
}





if($_REQUEST['mode'] == "edit") { 
	$portalList=array();

	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$portalList=$Panel->GetDirContents("../includes/template/default/smarty/portal/", true);
	$bad=array();
	foreach($portalList as $p => $l) if(in_array($portalList[$p], $bad)) $portalList[$p]="";
	

	$smarty->assign("portalList",$portalList);
	$smarty->display("manageportal/portal-list.tpl");
} // end edit ng price



if($_REQUEST['mode'] == "edit2") { 
	$nid=$GameCP->whitelist($_REQUEST['nid']);
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$portalList=$Panel->GetDirContents("../includes/template/default/smarty/portal/", true);
	if(!in_array($nid, $portalList)) $Panel->ErrorExit("Invalid access");

	$ffile="../includes/template/default/smarty/portal/".$nid;
	if(is_file($ffile) && filesize($ffile) > 0){
		$handle = fopen($ffile, "r");
		$fcontents = fread($handle, filesize($ffile));
		fclose($handle);
	}

	if(isset($_REQUEST['alt'])){
		echo "<html><body>".$fcontents."</body></html>";
	} else {
		$smarty->assign("newsContent",$fcontents);
		$smarty->assign("nid",$nid);
		$smarty->display("manageportal/portal-edit.tpl");
	}

} // end edit ng price

if($_REQUEST['mode'] =="new"){ 

	/* lazy ass */
	$gameListQuery="";
	$machineListQuery="";
	 $result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			$gameListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";
		}

	 $result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
		while ($row = mysql_fetch_array($result)){ 
			$machineListQuery.="<option value=\"". $row['sid'] ."\">". $row['name']."</option>"; 
		}

	$smarty->assign("machineList",$machineListQuery);
	$smarty->assign("gameList",$gameListQuery);

	$smarty->display("manageportal/portal-edit.tpl");
} 

require_once(path.'/includes/core/editable/footer.inc.php');

?>