<?php 
/*
	GameCP - Game Server Control Panel
	Copyright (c) 2004 - 2013 All Rights Reserved.	
	----------------------------------------------	
	This document is bound under the GameCP Terms 
	of Use and MUST NOT be removed, distributed in any form, released
	or modified, without written permission from GameCP.

	The GameCP Terms of Use are agreed to upon installation
	of this software. If you do not agree to them remove GamecP from 
	your system.
	
	http://gamecp.com/terms.php

	The source code or encoded versions of the source code
	must ONLY exist on approved GameCP Licensed Servers.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

$header=true;
require('../includes/core/includes/user/session.inc.php');
require('../includes/config.inc.php');

$GameCP->CheckPermissions('schedule');

$smarty->assign('page_title', $LNG_SCHEDULER);

if($_SESSION['gamecp']['userinfo']['ulevel'] != "1") { 
	$GameCP->loadIncludes("panel");
	$Panel=new Panel();
	$Panel->ErrorExit("Invalid access");
}

$GameCP->SetURLCookie();

if(isset($_REQUEST['mode']) && $_REQUEST['mode'] == "remove") sql_query($safesql->query("DELETE FROM `schedule` WHERE id='%i' LIMIT 1;", array($GameCP->whitelist($_REQUEST['cronid'], "int")))) or die(mysql_error());

if(isset($_REQUEST['mode']) && $_REQUEST['mode'] == "save"){
	if(!$_REQUEST['taskname']) $_REQUEST['taskname']="task-".time();
	if(!$_REQUEST['result']){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("Please select a cron time.");
	}
	if(!$_REQUEST['tskcmd']){
		$GameCP->loadIncludes("panel");
		$Panel=new Panel();
		$Panel->ErrorExit("Please select a command.");
	} else {

		if(!defined(phpexec)){
			$phpexec=phpexec;
		} else $phpexec="php";

		sql_query($safesql->query("INSERT INTO `schedule` SET name='%s', cmd='%s', cron='';", array($GameCP->whitelist($_REQUEST['taskname'], "clean"),$GameCP->whitelist($_REQUEST['tskcmd'], "clean")))) or die(mysql_error());
		$taskid=mysql_insert_id();
		
		switch ($_REQUEST['tskcmd']){
			case "saved";
				sql_query($safesql->query("UPDATE `schedule` SET 
				games='%s', 
				users='%s', 
				servers='%s',
				cmdid='%s'
				WHERE id='%i' LIMIT 1;", array(
					$GameCP->whitelist(serialize($_REQUEST['gameid']), "clean"),
					$GameCP->whitelist(serialize($_REQUEST['users']), "clean"),
					$GameCP->whitelist(serialize($_REQUEST['sid']), "clean"),
					$GameCP->whitelist($_REQUEST['cmdid'], "int"),
					$GameCP->whitelist($taskid, "int")
					))) or die(mysql_error());
			break;

			case "gamecp";
				/*
					build into cmd control to run certain functions
				*/
				sql_query($safesql->query("UPDATE `schedule` SET 
				cmdid='%s'
				WHERE id='%i' LIMIT 1;", array(
					$GameCP->whitelist($_REQUEST['gamecpid'], "clean"),
					$GameCP->whitelist($taskid, "int")
					))) or die(mysql_error());

			break;

			case "games";
				sql_query($safesql->query("UPDATE `schedule` SET 
				games='%s', 
				servers='%s', 
				mode='%s' 
				WHERE id='%i' LIMIT 1;", array(
					$GameCP->whitelist(serialize($_REQUEST['gameid']), "clean"),
					$GameCP->whitelist(serialize($_REQUEST['sid']), "clean"),
					$GameCP->whitelist($_REQUEST['gamemode'], "clean"),
					$GameCP->whitelist($taskid, "int")
					))) or die(mysql_error());
			break;
		}

		require_once(path.'/includes/core/classes/cron/parser.inc.php');
		$cron_parser = new cron_parser($_REQUEST['result']);
		$next_time = $cron_parser->next_runtime();
		$last_time = $cron_parser->last_runtime();
		sql_query($safesql->query("UPDATE `schedule` SET `next_run`='%s' WHERE id='%i' LIMIT 1;", array($GameCP->whitelist(addslashes($next_time), "clean"),$GameCP->whitelist($taskid, "int")))) or die(mysql_error());
	}
		
	sql_query($safesql->query("UPDATE `schedule` SET cron='%s' WHERE id='%i' LIMIT 1;", array($GameCP->whitelist(addslashes($_REQUEST['result']), "clean"),$GameCP->whitelist($taskid, "int")))) or die(mysql_error());
	
	$smarty->assign("showSaved", "true");
}

$savedCommands='';
$result = sql_query("SELECT id, name FROM cmdcenter ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $savedCommands.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";
	
$gameListQuery="";
$result = sql_query("SELECT id, name FROM game ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $gameListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>";
	
$machineListQuery='';
$result = sql_query("SELECT sid, name FROM servers ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $machineListQuery.="<option value=\"". $row['sid'] ."\">". $row['name']."</option>"; 

$userListQuery='';
$result = sql_query("SELECT * FROM users WHERE userlevel = '0' AND active='1' ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $userListQuery.="<option value=\"". $row['id'] ."\">". $row['name']."</option>"; 
	
$cronList=array();
$result = sql_query("SELECT * FROM schedule ORDER BY 'name'") or die(mysql_error());
while ($row = mysql_fetch_array($result)) $cronList[]=$row; 
	
$smarty->assign("machineList",$machineListQuery);
$smarty->assign("gameList",$gameListQuery);
$smarty->assign("userList",$userListQuery);
$smarty->assign("savedList",$savedCommands);
$smarty->assign("cronList",$cronList);

$smarty->display("schedule/sched.tpl");

require_once(path.'/includes/core/editable/footer.inc.php');

?>